// $ANTLR 2.7.2: "AsmKeyParser.g" -> "AsmKeyParser.java"$


    package de.uka.ilkd.asmkey.parser.antlr;

    import de.uka.ilkd.asmkey.parser.ast.*;
    import de.uka.ilkd.key.parser.Location;
    import de.uka.ilkd.asmkey.logic.AsmOperator;
    import de.uka.ilkd.asmkey.logic.dfinfo.*;

    import java.util.*;


import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class AsmKeyParser extends antlr.LLkParser       implements AsmKeyParserTokenTypes
 {


    /* --- static methods --- */

    private static final Location getLocation(AstDeclaration[] decls) {
        if (decls.length == 0) {
            return null;
        } else {
            return decls[0].getLocation();
        }
    }

    private static final Location getLocation(AstTerm[] terms) {
        if (terms.length == 0) {
            return null;
        } else {
            return terms[0].getLocation();
        }
    }

    /** Return a new empty list. */
    private static List createList() {
        return new ArrayList();
    }

    private static Location createLocation(Token token) {
        return new Location(null, token.getLine(), token.getColumn());
    }

    /** return a new array 't # terms'. */
    private static AstTerm[] prependTerm(AstTerm t, AstTerm[] terms) {
        AstTerm[] a = new AstTerm[terms.length + 1];
        System.arraycopy(terms, 0, a, 1, terms.length);
        a[0] = t;
        return a;
    }


    /* --- static fields --- */

    private static final AstTerm[] EMPTY_TERMS = new AstTerm[]{ };

    private static final Identifier[] EMPTY_IDS = new Identifier[]{ };

    private static final AstCondition[] EMPTY_CONDITIONS = new AstCondition[]{ };

    private static final AstParameter[] EMPTY_PARAMETERS = new AstParameter[]{ };

    
    /* --- constructors --- */

    /** Create a parser with the given input and the given ast factory. */
    public AsmKeyParser(TokenStream lexer, AstFactory af) {
        this(lexer);
        this.af = af;
    }


    /* --- fields --- */

    /** The used AstFactory. */
    private AstFactory af = null;


    /* --- inner class --- */

    /** This class stores either a term or a sequent. It is needed
     * because some productions can't distinguish between terms and 
     * sequents without infinte lookahead.  */
    private static final class TermSequent {
        
        final AstTerm term;
        
        final AstSequent sequent;


        TermSequent(AstTerm term) {
            this(term, null);
        }

        TermSequent(AstSequent sequent) {
            this(null, sequent);
        }

        TermSequent(AstTerm term, AstSequent sequent) {
            this.term = term;
            this.sequent = sequent;
        }

    }
    

protected AsmKeyParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public AsmKeyParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected AsmKeyParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public AsmKeyParser(TokenStream lexer) {
  this(lexer,2);
}

public AsmKeyParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final AstTerm  top_formula() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		t=term();
		match(Token.EOF_TYPE);
		return t;
	}
	
	protected final AstTerm  term() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		t=term20();
		return t;
	}
	
	public final AstTerm  top_term() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		t=term();
		match(Token.EOF_TYPE);
		return t;
	}
	
	public final AstProblem  top_problem() throws RecognitionException, TokenStreamException {
		AstProblem p;
		
		
		p=problem();
		match(Token.EOF_TYPE);
		return p;
	}
	
	protected final AstProblem  problem() throws RecognitionException, TokenStreamException {
		AstProblem p;
		
		
		AstDeclaration[] l;
		AstTerm a;
		AstProofExpression pe = null;
		AstImportFile[] im, il;
		
		
		{
		switch ( LA(1)) {
		case IMPORTFILES:
		{
			im=importdecls();
			break;
		}
		case PROBLEM:
		case PROCEDURES:
		case SORTS:
		case SCHEMA:
		case PREDICATES:
		case FUNCTIONS:
		case RULES:
		case HYPERRULES:
		case HEURISTICS:
		case LEMMAS:
		case IMPORTLEMMAS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case IMPORTLEMMAS:
		{
			il=importlemmas();
			break;
		}
		case PROBLEM:
		case PROCEDURES:
		case SORTS:
		case SCHEMA:
		case PREDICATES:
		case FUNCTIONS:
		case RULES:
		case HYPERRULES:
		case HEURISTICS:
		case LEMMAS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		l=decls();
		match(PROBLEM);
		match(LBRACE);
		a=formula();
		match(RBRACE);
		{
		switch ( LA(1)) {
		case PROOF:
		{
			pe=proof();
			break;
		}
		case EOF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		p = new AstProblem(getLocation(l), l, a, pe);
		
		return p;
	}
	
	public final AstDeclaration[]  top_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		decls=decls();
		match(Token.EOF_TYPE);
		return decls;
	}
	
	protected final AstDeclaration[]  decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration[] l;
		
		
		l=decls_without_lemmas();
		
		list.addAll(Arrays.asList(l));
		
		{
		switch ( LA(1)) {
		case LEMMAS:
		{
			l=lemma_decls();
			
			list.addAll(Arrays.asList(l));
			
			break;
		}
		case EOF:
		case PROBLEM:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	public final AstDeclaration[]  top_package_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		decls=package_decls();
		match(Token.EOF_TYPE);
		return decls;
	}
	
	protected final AstDeclaration []  package_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration [] decls;
		
		
		AstDeclaration[] l;
		boolean ps;
		boolean ls;
		
		
		{
		switch ( LA(1)) {
		case PACKAGES:
		{
			ps=packages_section();
			break;
		}
		case EOF:
		case PROCEDURES:
		case SORTS:
		case SCHEMA:
		case PREDICATES:
		case FUNCTIONS:
		case RULES:
		case HYPERRULES:
		case HEURISTICS:
		case LEMMAS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		l=decls_without_lemmas();
		{
		switch ( LA(1)) {
		case LEMMAS:
		{
			ls=lemmas_section();
			break;
		}
		case EOF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		decls=l;
		
		return decls;
	}
	
	public final AstDeclaration[]  top_package_lemmas() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		decls=package_lemmas();
		match(Token.EOF_TYPE);
		return decls;
	}
	
	protected final AstDeclaration []  package_lemmas() throws RecognitionException, TokenStreamException {
		AstDeclaration [] decls;
		
		
		AstDeclaration[] l;
		boolean ps;
		AstDeclaration[] ls=null;
		
		
		{
		switch ( LA(1)) {
		case PACKAGES:
		{
			ps=packages_section();
			break;
		}
		case EOF:
		case PROCEDURES:
		case SORTS:
		case SCHEMA:
		case PREDICATES:
		case FUNCTIONS:
		case RULES:
		case HYPERRULES:
		case HEURISTICS:
		case LEMMAS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		l=decls_without_lemmas();
		{
		switch ( LA(1)) {
		case LEMMAS:
		{
			ls=lemma_decls();
			break;
		}
		case EOF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		decls=ls==null?(new AstDeclaration[0]):ls;
		
		return decls;
	}
	
	public final AstAsmRule  top_asm_rule() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		r=asm_rule();
		match(Token.EOF_TYPE);
		return r;
	}
	
	protected final AstAsmRule  asm_rule() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		r=asm_rule_seq();
		return r;
	}
	
	public final AstImportFile[]  top_importdecls() throws RecognitionException, TokenStreamException {
		AstImportFile[] impfiles;
		
		
		impfiles=problem_importdecls();
		match(Token.EOF_TYPE);
		return impfiles;
	}
	
	protected final AstImportFile[]  problem_importdecls() throws RecognitionException, TokenStreamException {
		AstImportFile[] importfiles;
		
		
		AstImportFile[] imfs=null, il;
		AstProofExpression pe;
		AstDeclaration[] l;
		AstTerm a;
		
		
		{
		switch ( LA(1)) {
		case IMPORTFILES:
		{
			imfs=importdecls();
			break;
		}
		case PROBLEM:
		case PROCEDURES:
		case SORTS:
		case SCHEMA:
		case PREDICATES:
		case FUNCTIONS:
		case RULES:
		case HYPERRULES:
		case HEURISTICS:
		case LEMMAS:
		case IMPORTLEMMAS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case IMPORTLEMMAS:
		{
			il=importlemmas();
			break;
		}
		case PROBLEM:
		case PROCEDURES:
		case SORTS:
		case SCHEMA:
		case PREDICATES:
		case FUNCTIONS:
		case RULES:
		case HYPERRULES:
		case HEURISTICS:
		case LEMMAS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		l=decls();
		match(PROBLEM);
		match(LBRACE);
		a=formula();
		match(RBRACE);
		{
		switch ( LA(1)) {
		case PROOF:
		{
			pe=proof();
			break;
		}
		case EOF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		importfiles = imfs==null?(new AstImportFile[0]):imfs;
		
		return importfiles;
	}
	
	public final AstImportFile[]  top_importlemmas() throws RecognitionException, TokenStreamException {
		AstImportFile[] impfiles;
		
		
		impfiles=problem_importlemmas();
		match(Token.EOF_TYPE);
		return impfiles;
	}
	
	protected final AstImportFile[]  problem_importlemmas() throws RecognitionException, TokenStreamException {
		AstImportFile[] importfiles;
		
		
		AstImportFile[] imfs, il=null;
		AstProofExpression pe;
		AstDeclaration[] l;
		AstTerm a;
		
		
		{
		switch ( LA(1)) {
		case IMPORTFILES:
		{
			imfs=importdecls();
			break;
		}
		case PROBLEM:
		case PROCEDURES:
		case SORTS:
		case SCHEMA:
		case PREDICATES:
		case FUNCTIONS:
		case RULES:
		case HYPERRULES:
		case HEURISTICS:
		case LEMMAS:
		case IMPORTLEMMAS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case IMPORTLEMMAS:
		{
			il=importlemmas();
			break;
		}
		case PROBLEM:
		case PROCEDURES:
		case SORTS:
		case SCHEMA:
		case PREDICATES:
		case FUNCTIONS:
		case RULES:
		case HYPERRULES:
		case HEURISTICS:
		case LEMMAS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		l=decls();
		match(PROBLEM);
		match(LBRACE);
		a=formula();
		match(RBRACE);
		{
		switch ( LA(1)) {
		case PROOF:
		{
			pe=proof();
			break;
		}
		case EOF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		importfiles = il==null?(new AstImportFile[0]):il;
		
		return importfiles;
	}
	
	protected final Identifier  ident() throws RecognitionException, TokenStreamException {
		Identifier s;
		
		Token  id = null;
		Token  plus = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			id = LT(1);
			match(IDENT);
			
						s = new Identifier(createLocation(id), id.getText());
					
			break;
		}
		case PLUS:
		{
			plus = LT(1);
			match(PLUS);
			
			s = new Identifier(createLocation(plus), "+");
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return s;
	}
	
	protected final Identifier  ident_asm_rule() throws RecognitionException, TokenStreamException {
		Identifier s;
		
		Token  asm = null;
		
		{
		switch ( LA(1)) {
		case PLUS:
		case IDENT:
		{
			{
			s=ident();
			}
			break;
		}
		case ASM:
		{
			{
			asm = LT(1);
			match(ASM);
			match(RULE);
			
			s = new Identifier(createLocation(asm), "asm-rule");
			
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return s;
	}
	
	protected final Identifier  identtimed() throws RecognitionException, TokenStreamException {
		Identifier s;
		
		Token  id = null;
		
		id = LT(1);
		match(IDENTTIMED);
		
		s = new Identifier(createLocation(id), id.getText());
		
		return s;
	}
	
	protected final Identifier  identnarity() throws RecognitionException, TokenStreamException {
		Identifier s;
		
		Token  id = null;
		
		id = LT(1);
		match(IDENTNARITY);
		
		s = new Identifier(createLocation(id), id.getText());
		
		return s;
	}
	
	protected final Identifier[]  id_list() throws RecognitionException, TokenStreamException {
		Identifier[] ids;
		
		
		Identifier id;
		List list = createList();
		
		
		id=ident();
		
		list.add(id);
		
		{
		_loop19:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				id=ident();
				
				list.add(id);
				
			}
			else {
				break _loop19;
			}
			
		} while (true);
		}
		
		ids = (Identifier[]) list.toArray(new Identifier[list.size()]);
		
		return ids;
	}
	
	protected final Identifier[]  id_asm_rule_list() throws RecognitionException, TokenStreamException {
		Identifier[] ids;
		
		
		Identifier id;
		List list = createList();
		
		
		id=ident_asm_rule();
		
		list.add(id);
		
		{
		_loop22:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				id=ident_asm_rule();
				
				list.add(id);
				
			}
			else {
				break _loop22;
			}
			
		} while (true);
		}
		
		ids = (Identifier[]) list.toArray(new Identifier[list.size()]);
		
		return ids;
	}
	
/**
 * In the special but important case of Taclets, we don't yet know
 * whether we are going to have a term or a formula, and it is hard
 * to decide a priori what we are looking at.  So the `term'
 * non-terminal will recognize a term or a formula.  The `formula'
 * reads a formula/term and throws an error if it wasn't a formula.
 * This gives a rather late error message. */
	protected final AstTerm  formula() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		t=term();
		return t;
	}
	
	protected final AstTerm  term20() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  eqv = null;
		
		AstTerm t2;
		
		
		t1=term30();
		{
		switch ( LA(1)) {
		case EQV:
		{
			eqv = LT(1);
			match(EQV);
			t2=term20();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(eqv), Operator.EQV),
			new AstTerm[]{ t1, t2 });
			
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMDO:
		case ASMPAR:
		case ASMSEQ:
		case SEMI:
		case COLON:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case GT:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term30() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  imp = null;
		
		AstTerm t2;
		
		
		t1=term40();
		{
		switch ( LA(1)) {
		case IMP:
		{
			imp = LT(1);
			match(IMP);
			t2=term30();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(imp), Operator.IMP), 
			new AstTerm[]{ t1, t2 });
			
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMDO:
		case ASMPAR:
		case ASMSEQ:
		case SEMI:
		case COLON:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case EQV:
		case GT:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term40() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  or = null;
		Token  orelse = null;
		
		AstTerm t2;
		
		
		t1=term50();
		{
		switch ( LA(1)) {
		case OR:
		{
			{
			or = LT(1);
			match(OR);
			t2=term40();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(or), Operator.OR), 
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case ORELSE:
		{
			{
			orelse = LT(1);
			match(ORELSE);
			t2=term40();
			
			t1 = af.createTerm(t1.getLocation(),
			new AstOperator(createLocation(orelse), Operator.ORELSE),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMDO:
		case ASMPAR:
		case ASMSEQ:
		case SEMI:
		case COLON:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case IMP:
		case EQV:
		case GT:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term50() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  and = null;
		Token  andalso = null;
		
		AstTerm t2;
		
		
		t1=term60();
		{
		switch ( LA(1)) {
		case AND:
		{
			{
			and = LT(1);
			match(AND);
			t2=term50();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(and), Operator.AND), 
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case ANDALSO:
		{
			{
			andalso = LT(1);
			match(ANDALSO);
			t2=term50();
			
			t1 = af.createTerm(t1.getLocation(),
			new AstOperator(createLocation(andalso), Operator.ANDALSO),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMDO:
		case ASMPAR:
		case ASMSEQ:
		case SEMI:
		case COLON:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case ORELSE:
		case OR:
		case IMP:
		case EQV:
		case GT:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term60() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		Token  not = null;
		
		switch ( LA(1)) {
		case TRUE:
		case FALSE:
		case ASM:
		case LPAREN:
		case LSETBRACK:
		case LSEQBRACK:
		case AT:
		case PLUS:
		case IDENT:
		case IDENTTIMED:
		case IDENTNARITY:
		{
			t=term70();
			break;
		}
		case FORALL:
		case EXISTS:
		case LBRACE:
		{
			t=bindingterm();
			break;
		}
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMEQUIA:
		case ASMACCT:
		case ASMACCF:
		case ASMACC:
		case ASMJOINABLE:
		case LBRACK:
		case LT:
		{
			t=dl_term();
			break;
		}
		case BIGAND:
		case BIGOR:
		{
			t=big_term();
			break;
		}
		case FUNCTION:
		{
			t=function_term();
			break;
		}
		case NOT:
		{
			not = LT(1);
			match(NOT);
			t=term60();
			
			t = af.createTerm(createLocation(not), 
			new AstOperator(createLocation(not), Operator.NOT), 
			new AstTerm[]{ t });
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return t;
	}
	
	protected final AstTerm  term70() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  equals = null;
		
		AstTerm t2;
		
		
		t1=term80();
		{
		switch ( LA(1)) {
		case EQUALS:
		{
			equals = LT(1);
			match(EQUALS);
			t2=term80();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(equals), Operator.EQUALS), 
			new AstTerm[]{ t1, t2 });
			
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMDO:
		case ASMPAR:
		case ASMSEQ:
		case SEMI:
		case COLON:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case ORELSE:
		case ANDALSO:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case GT:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  bindingterm() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		
		AstQuantifier q;
		Identifier var;
		AstTerm t1, t2;
		Identifier sort = null;
		
		
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		{
			q=quantifier();
			{
			switch ( LA(1)) {
			case PLUS:
			case IDENT:
			{
				var=ident();
				break;
			}
			case IDENTNARITY:
			{
				var=identnarity();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				sort=ident();
				break;
			}
			case DOT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(DOT);
			t1=term60();
			
			t = af.createTerm(q.getLocation(), q, var, sort, t1);
			
			break;
		}
		case LBRACE:
		{
			match(LBRACE);
			var=ident();
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				sort=ident();
				break;
			}
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case ASM:
			case ASMDEF:
			case ASMUPD:
			case ASMCON:
			case ASMINV:
			case ASMEQUI:
			case ASMEQUIS:
			case ASMEQUIA:
			case ASMACCT:
			case ASMACCF:
			case ASMACC:
			case ASMJOINABLE:
			case BIGAND:
			case BIGOR:
			case FUNCTION:
			case LPAREN:
			case LBRACE:
			case LSETBRACK:
			case LBRACK:
			case LSEQBRACK:
			case AT:
			case LT:
			case PLUS:
			case IDENT:
			case IDENTTIMED:
			case IDENTNARITY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			t1=term();
			match(RBRACE);
			t2=term60();
			
			t = af.createSubstitutionTerm(var.getLocation(), var, sort, t1, t2);
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t;
	}
	
	protected final AstTerm  dl_term() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		Token  lbrack = null;
		Token  lt = null;
		Token  def = null;
		Token  upd = null;
		Token  con = null;
		Token  inv = null;
		Token  joinable = null;
		Token  equi = null;
		Token  equiS = null;
		Token  equiA = null;
		Token  accT = null;
		Token  accF = null;
		Token  acc = null;
		
		AstAsmRule r, s;
		AstTerm t1, t2, t3=null, f;
		
		
		switch ( LA(1)) {
		case LBRACK:
		{
			lbrack = LT(1);
			match(LBRACK);
			r=asm_rule();
			match(RBRACK);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case ASM:
			case ASMDEF:
			case ASMUPD:
			case ASMCON:
			case ASMINV:
			case ASMEQUI:
			case ASMEQUIS:
			case ASMEQUIA:
			case ASMACCT:
			case ASMACCF:
			case ASMACC:
			case ASMJOINABLE:
			case BIGAND:
			case BIGOR:
			case FUNCTION:
			case LPAREN:
			case LBRACE:
			case LSETBRACK:
			case LBRACK:
			case LSEQBRACK:
			case AT:
			case LT:
			case PLUS:
			case IDENT:
			case IDENTTIMED:
			case IDENTNARITY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			t=term60();
			
			t = af.createDlBox(createLocation(lbrack), r, t, t3);
			
			break;
		}
		case LT:
		{
			lt = LT(1);
			match(LT);
			r=asm_rule();
			match(GT);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case ASM:
			case ASMDEF:
			case ASMUPD:
			case ASMCON:
			case ASMINV:
			case ASMEQUI:
			case ASMEQUIS:
			case ASMEQUIA:
			case ASMACCT:
			case ASMACCF:
			case ASMACC:
			case ASMJOINABLE:
			case BIGAND:
			case BIGOR:
			case FUNCTION:
			case LPAREN:
			case LBRACE:
			case LSETBRACK:
			case LBRACK:
			case LSEQBRACK:
			case AT:
			case LT:
			case PLUS:
			case IDENT:
			case IDENTTIMED:
			case IDENTNARITY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			t=term60();
			
			t = af.createDlDiamond(createLocation(lt), r, t, t3);
			
			break;
		}
		case ASMDEF:
		{
			def = LT(1);
			match(ASMDEF);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			r=asm_rule();
			match(RPAREN);
			
			t = af.createDlDef(createLocation(def), r, t3);
			
			break;
		}
		case ASMUPD:
		{
			upd = LT(1);
			match(ASMUPD);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			r=asm_rule();
			match(COMMA);
			t1=term();
			match(COMMA);
			t2=term();
			match(RPAREN);
			
			t = af.createDlUpd(createLocation(upd), t1, t2, r, t3);
			
			break;
		}
		case ASMCON:
		{
			con = LT(1);
			match(ASMCON);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			r=asm_rule();
			match(RPAREN);
			
			t = af.createDlCon(createLocation(con), r, t3);
			
			break;
		}
		case ASMINV:
		{
			inv = LT(1);
			match(ASMINV);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			r=asm_rule();
			match(COMMA);
			t=term();
			match(RPAREN);
			
			t = af.createDlInv(createLocation(inv), t, r, t3);
			
			break;
		}
		case ASMJOINABLE:
		{
			joinable = LT(1);
			match(ASMJOINABLE);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			r=asm_rule();
			match(COMMA);
			s=asm_rule();
			match(RPAREN);
			
			t = af.createDlJoinable(createLocation(joinable), r, s, t3);
			
			break;
		}
		case ASMEQUI:
		{
			equi = LT(1);
			match(ASMEQUI);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			r=asm_rule();
			match(COMMA);
			s=asm_rule();
			match(RPAREN);
			
			t = af.createDlEqui(createLocation(equi), r, s, t3);
			
			break;
		}
		case ASMEQUIS:
		{
			equiS = LT(1);
			match(ASMEQUIS);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			r=asm_rule();
			match(COMMA);
			s=asm_rule();
			match(RPAREN);
			
			t = af.createDlEquiS(createLocation(equiS), r, s, t3);
			
			break;
		}
		case ASMEQUIA:
		{
			equiA = LT(1);
			match(ASMEQUIA);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			r=asm_rule();
			match(COMMA);
			s=asm_rule();
			match(RPAREN);
			
			t = af.createDlEquiA(createLocation(equiA), r, s, t3);
			
			break;
		}
		case ASMACCT:
		{
			accT = LT(1);
			match(ASMACCT);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			t2=term();
			match(COMMA);
			t1=term();
			match(RPAREN);
			
			t = af.createDlAccT(createLocation(accT), t1, t2, t3);
			
			break;
		}
		case ASMACCF:
		{
			accF = LT(1);
			match(ASMACCF);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			f=formula();
			match(COMMA);
			t=term();
			match(RPAREN);
			
			t = af.createDlAccF(createLocation(accF), t ,f, t3);
			
			break;
		}
		case ASMACC:
		{
			acc = LT(1);
			match(ASMACC);
			{
			switch ( LA(1)) {
			case TIMED:
			{
				match(TIMED);
				t3=simpleterm();
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			r=asm_rule();
			match(COMMA);
			t=term();
			match(RPAREN);
			
			t = af.createDlAcc(createLocation(acc), t, r, t3);
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return t;
	}
	
	protected final AstTerm  big_term() throws RecognitionException, TokenStreamException {
		AstTerm term;
		
		Token  big = null;
		
		boolean and_flag;
		int type_flag = AstFactory.ALL_TYPE;
		int prop_flag = AstFactory.ALL_PROPERTY;
		Identifier id;
		Identifier[] rules = null;
		AstTerm form;
		
		
		{
		switch ( LA(1)) {
		case BIGAND:
		{
			match(BIGAND);
			and_flag = true;
			break;
		}
		case BIGOR:
		{
			match(BIGOR);
			and_flag = false;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		big = LT(1);
		match(LPAREN);
		id=ident();
		{
		switch ( LA(1)) {
		case RPAREN:
		{
			match(RPAREN);
			
			term = af.createTerm(id.getLocation(), id, null);
			term = af.createBigTerm(createLocation(big), term, and_flag);
			
			break;
		}
		case DYNAMIC:
		case STATIC:
		case COMMA:
		{
			{
			{
			switch ( LA(1)) {
			case STATIC:
			{
				match(STATIC);
				type_flag = AstFactory.STATIC_TYPE;
				break;
			}
			case DYNAMIC:
			{
				match(DYNAMIC);
				{
				switch ( LA(1)) {
				case ACCESS:
				case UPDATE:
				{
					{
					switch ( LA(1)) {
					case UPDATE:
					{
						match(UPDATE);
						prop_flag = AstFactory.UPDATE_PROPERTY;
						break;
					}
					case ACCESS:
					{
						match(ACCESS);
						prop_flag = AstFactory.ACCESS_PROPERTY;
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					match(LPAREN);
					rules=big_term_rules();
					match(RPAREN);
					break;
				}
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				type_flag = AstFactory.DYNAMIC_TYPE;
				break;
			}
			case COMMA:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(COMMA);
			form=formula();
			match(RPAREN);
			
			term = af.createBigTerm(createLocation(big), id, form, and_flag, type_flag, prop_flag, rules);
			
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return term;
	}
	
	protected final AstTerm  function_term() throws RecognitionException, TokenStreamException {
		AstTerm term;
		
		Token  function = null;
		
		Identifier id;
		AstTerm func, form;
		
		
		function = LT(1);
		match(FUNCTION);
		match(LPAREN);
		id=ident();
		match(COMMA);
		func=term();
		match(COMMA);
		form=formula();
		match(RPAREN);
		
		term=af.createFunctionTerm(createLocation(function),id,func,form);
		
		return term;
	}
	
	protected final AstTerm  term80() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  asterix = null;
		Token  slash = null;
		
		AstTerm t2;
		
		
		t1=term90();
		{
		switch ( LA(1)) {
		case ASTERIX:
		{
			{
			asterix = LT(1);
			match(ASTERIX);
			t2=term80();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(asterix), Operator.MULT),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case SLASH:
		{
			{
			slash = LT(1);
			match(SLASH);
			t2=term80();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(slash), Operator.DIV),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMDO:
		case ASMPAR:
		case ASMSEQ:
		case SEMI:
		case COLON:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case ORELSE:
		case ANDALSO:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case EQUALS:
		case GT:
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term90() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  plus = null;
		Token  minus = null;
		
		AstTerm t2;
		
		
		t1=term95();
		{
		switch ( LA(1)) {
		case PLUS:
		{
			{
			plus = LT(1);
			match(PLUS);
			t2=term90();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(plus), Operator.ADD),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case MINUS:
		{
			{
			minus = LT(1);
			match(MINUS);
			t2=term90();
			
			t1 = af.createTerm(t1.getLocation(), 
			new AstOperator(createLocation(minus), Operator.SUB),
			new AstTerm[]{ t1, t2 });
			
			}
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMDO:
		case ASMPAR:
		case ASMSEQ:
		case SEMI:
		case COLON:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case ORELSE:
		case ANDALSO:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case EQUALS:
		case GT:
		case SEQARROW:
		case ASTERIX:
		case SLASH:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term95() throws RecognitionException, TokenStreamException {
		AstTerm t1;
		
		Token  timed = null;
		
		AstTerm t2;
		
		
		t1=term100();
		{
		switch ( LA(1)) {
		case DLBRACK:
		{
			timed = LT(1);
			match(DLBRACK);
			t2=simpleterm();
			match(DRBRACK);
			
			t1 = af.createTerm(createLocation(timed),
			new AstOperator(createLocation(timed), Operator.TIMED),
			new AstTerm[]{ t1, t2 });
			
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMDO:
		case ASMPAR:
		case ASMSEQ:
		case SEMI:
		case COLON:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case ORELSE:
		case ANDALSO:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case EQUALS:
		case GT:
		case SEQARROW:
		case PLUS:
		case MINUS:
		case ASTERIX:
		case SLASH:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return t1;
	}
	
	protected final AstTerm  term100() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		Token  true_ = null;
		Token  false_ = null;
		Token  at = null;
		
		Location location;
		Identifier abbr;
		
		
		switch ( LA(1)) {
		case PLUS:
		case IDENT:
		case IDENTTIMED:
		case IDENTNARITY:
		{
			t=funcpredvarterm();
			break;
		}
		case LSETBRACK:
		{
			t=set_term();
			break;
		}
		case LSEQBRACK:
		{
			t=sequence_term();
			break;
		}
		case ASM:
		{
			match(ASM);
			match(LPAREN);
			t=asm_rule();
			match(RPAREN);
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			t=term();
			match(RPAREN);
			break;
		}
		case TRUE:
		{
			true_ = LT(1);
			match(TRUE);
			
			t = af.createTerm(createLocation(true_), 
			new AstOperator(createLocation(true_), Operator.TRUE),
			null);
			
			break;
		}
		case FALSE:
		{
			false_ = LT(1);
			match(FALSE);
			
			t = af.createTerm(createLocation(false_), 
			new AstOperator(createLocation(false_), Operator.FALSE), 
			null);
			
			break;
		}
		case AT:
		{
			at = LT(1);
			match(AT);
			abbr=ident();
			
			t = af.createAbbreviationTerm(createLocation(at), abbr);
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return t;
	}
	
	protected final AstTerm  simpleterm() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		Token  true_ = null;
		Token  false_ = null;
		Token  at = null;
		
		Location location;
		Identifier abbr;
		
		
		switch ( LA(1)) {
		case PLUS:
		case IDENT:
		{
			t=varterm();
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			t=term();
			match(RPAREN);
			break;
		}
		case TRUE:
		{
			true_ = LT(1);
			match(TRUE);
			
			t = af.createTerm(createLocation(true_), 
			new AstOperator(createLocation(true_), Operator.TRUE),
			null);
			
			break;
		}
		case FALSE:
		{
			false_ = LT(1);
			match(FALSE);
			
			t = af.createTerm(createLocation(false_), 
			new AstOperator(createLocation(false_), Operator.FALSE), 
			null);
			
			break;
		}
		case AT:
		{
			at = LT(1);
			match(AT);
			abbr=ident();
			
			t = af.createAbbreviationTerm(createLocation(at), abbr);
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return t;
	}
	
	protected final AstTerm  funcpredvarterm() throws RecognitionException, TokenStreamException {
		AstTerm a;
		
		
		Identifier id;
		AstTerm[] l=null;
		AstTerm t=null;
		
		
		{
		switch ( LA(1)) {
		case PLUS:
		case IDENT:
		{
			id=ident();
			l=term_args();
			break;
		}
		case IDENTTIMED:
		{
			id=identtimed();
			t=simpleterm();
			l=term_args();
			break;
		}
		case IDENTNARITY:
		{
			id=identnarity();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		if (t != null) {
		AstTerm[] temp;
		temp = new AstTerm[l.length + 1];
		for (int i=1; i<= l.length; i++) {
		temp[i] = l[i-1];
		}
		temp[0] = t;
		l = temp;
		}
		a = af.createTerm(id.getLocation(), id, l);
		
		return a;
	}
	
	protected final AstTerm  set_term() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		Token  set = null;
		
		AstTerm[] elems = null;
		
		
		set = LT(1);
		match(LSETBRACK);
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASM:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMEQUIA:
		case ASMACCT:
		case ASMACCF:
		case ASMACC:
		case ASMJOINABLE:
		case BIGAND:
		case BIGOR:
		case FUNCTION:
		case LPAREN:
		case LBRACE:
		case LSETBRACK:
		case LBRACK:
		case LSEQBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		case IDENTTIMED:
		case IDENTNARITY:
		{
			elems=term_list();
			break;
		}
		case RBRACK:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RBRACK);
		
		t = af.createSetTerm(createLocation(set), elems);
		
		return t;
	}
	
	protected final AstTerm  sequence_term() throws RecognitionException, TokenStreamException {
		AstTerm t;
		
		Token  lbrack = null;
		
		AstTerm[] elems = null;
		AstTerm tail = null;
		
		
		lbrack = LT(1);
		match(LSEQBRACK);
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASM:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMEQUIA:
		case ASMACCT:
		case ASMACCF:
		case ASMACC:
		case ASMJOINABLE:
		case BIGAND:
		case BIGOR:
		case FUNCTION:
		case LPAREN:
		case LBRACE:
		case LSETBRACK:
		case LBRACK:
		case LSEQBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		case IDENTTIMED:
		case IDENTNARITY:
		{
			elems=term_list();
			break;
		}
		case COLON:
		case GT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			tail=term();
			break;
		}
		case GT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		t = af.createSequenceTerm(createLocation(lbrack), elems, tail);
		
		match(GT);
		return t;
	}
	
	protected final AstTerm  varterm() throws RecognitionException, TokenStreamException {
		AstTerm a;
		
		
		Identifier id;
		
		
		id=ident();
		
		a = af.createTerm(id.getLocation(), id, null);
		
		return a;
	}
	
	protected final AstQuantifier  quantifier() throws RecognitionException, TokenStreamException {
		AstQuantifier q;
		
		Token  all = null;
		Token  ex = null;
		
		switch ( LA(1)) {
		case FORALL:
		{
			all = LT(1);
			match(FORALL);
			
			q = new AstQuantifier(createLocation(all), Quantifier.ALL);
			
			break;
		}
		case EXISTS:
		{
			ex = LT(1);
			match(EXISTS);
			
			q = new AstQuantifier(createLocation(ex), Quantifier.EX);
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return q;
	}
	
	protected final Identifier[]  big_term_rules() throws RecognitionException, TokenStreamException {
		Identifier[] rules;
		
		
		List list = createList();
		Identifier id;
		
		
		id=ident();
		
		list.add(id);
		
		{
		_loop82:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				id=ident();
				
				list.add(id);
				
			}
			else {
				break _loop82;
			}
			
		} while (true);
		}
		
		rules = (Identifier[]) list.toArray(new Identifier[list.size()]);
		
		return rules;
	}
	
	protected final AstTerm[]  term_list() throws RecognitionException, TokenStreamException {
		AstTerm[] terms;
		
		
		List list = createList();
		AstTerm t;
		
		
		t=term();
		
		list.add(t);
		
		{
		_loop85:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				t=term();
				
				list.add(t);
				
			}
			else {
				break _loop85;
			}
			
		} while (true);
		}
		
		terms = (AstTerm[]) list.toArray(new AstTerm[list.size()]);
		
		return terms;
	}
	
	protected final AstTerm[]  term_args() throws RecognitionException, TokenStreamException {
		AstTerm[] terms = null;
		
		
		Identifier id;
		
		
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			{
			switch ( LA(1)) {
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case ASM:
			case ASMDEF:
			case ASMUPD:
			case ASMCON:
			case ASMINV:
			case ASMEQUI:
			case ASMEQUIS:
			case ASMEQUIA:
			case ASMACCT:
			case ASMACCF:
			case ASMACC:
			case ASMJOINABLE:
			case BIGAND:
			case BIGOR:
			case FUNCTION:
			case LPAREN:
			case LBRACE:
			case LSETBRACK:
			case LBRACK:
			case LSEQBRACK:
			case AT:
			case LT:
			case PLUS:
			case IDENT:
			case IDENTTIMED:
			case IDENTNARITY:
			{
				terms=term_list();
				match(RPAREN);
				break;
			}
			case RPAREN:
			{
				match(RPAREN);
				
				terms = EMPTY_TERMS;
				
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case EOF:
		case ASMTHEN:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMIN:
		case ASMDO:
		case ASMPAR:
		case ASMSEQ:
		case SEMI:
		case COLON:
		case ASSIGN:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case DLBRACK:
		case ORELSE:
		case ANDALSO:
		case OR:
		case AND:
		case IMP:
		case EQV:
		case EQUALS:
		case GT:
		case SEQARROW:
		case PLUS:
		case MINUS:
		case ASTERIX:
		case SLASH:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return terms;
	}
	
	protected final AstSequent  seq() throws RecognitionException, TokenStreamException {
		AstSequent s;
		
		
		AstTerm[] ant = EMPTY_TERMS, suc = EMPTY_TERMS;
		
		
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASM:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMEQUIA:
		case ASMACCT:
		case ASMACCF:
		case ASMACC:
		case ASMJOINABLE:
		case BIGAND:
		case BIGOR:
		case FUNCTION:
		case LPAREN:
		case LBRACE:
		case LSETBRACK:
		case LBRACK:
		case LSEQBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		case IDENTTIMED:
		case IDENTNARITY:
		{
			ant=term_list();
			break;
		}
		case SEQARROW:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEQARROW);
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASM:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMEQUIA:
		case ASMACCT:
		case ASMACCF:
		case ASMACC:
		case ASMJOINABLE:
		case BIGAND:
		case BIGOR:
		case FUNCTION:
		case LPAREN:
		case LBRACE:
		case LSETBRACK:
		case LBRACK:
		case LSEQBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		case IDENTTIMED:
		case IDENTNARITY:
		{
			suc=term_list();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		s = new AstSequent(getLocation(ant), ant, suc);
		
		return s;
	}
	
	protected final TermSequent  termorseq() throws RecognitionException, TokenStreamException {
		TermSequent ts;
		
		Token  seqarrow = null;
		
		AstTerm t;
		AstTerm[] ant, suc = EMPTY_TERMS;
		
		
		{
		switch ( LA(1)) {
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASM:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMEQUIA:
		case ASMACCT:
		case ASMACCF:
		case ASMACC:
		case ASMJOINABLE:
		case BIGAND:
		case BIGOR:
		case FUNCTION:
		case LPAREN:
		case LBRACE:
		case LSETBRACK:
		case LBRACK:
		case LSEQBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		case IDENTTIMED:
		case IDENTNARITY:
		{
			t=term();
			{
			switch ( LA(1)) {
			case RPAREN:
			{
				
				ts = new TermSequent(t);
				
				break;
			}
			case SEQARROW:
			{
				match(SEQARROW);
				{
				switch ( LA(1)) {
				case FORALL:
				case EXISTS:
				case TRUE:
				case FALSE:
				case NOT:
				case ASM:
				case ASMDEF:
				case ASMUPD:
				case ASMCON:
				case ASMINV:
				case ASMEQUI:
				case ASMEQUIS:
				case ASMEQUIA:
				case ASMACCT:
				case ASMACCF:
				case ASMACC:
				case ASMJOINABLE:
				case BIGAND:
				case BIGOR:
				case FUNCTION:
				case LPAREN:
				case LBRACE:
				case LSETBRACK:
				case LBRACK:
				case LSEQBRACK:
				case AT:
				case LT:
				case PLUS:
				case IDENT:
				case IDENTTIMED:
				case IDENTNARITY:
				{
					suc=term_list();
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				ts = new TermSequent(new AstSequent(t.getLocation(), new AstTerm[]{ t }, suc));
				
				break;
			}
			case COMMA:
			{
				match(COMMA);
				ant=term_list();
				match(SEQARROW);
				{
				switch ( LA(1)) {
				case FORALL:
				case EXISTS:
				case TRUE:
				case FALSE:
				case NOT:
				case ASM:
				case ASMDEF:
				case ASMUPD:
				case ASMCON:
				case ASMINV:
				case ASMEQUI:
				case ASMEQUIS:
				case ASMEQUIA:
				case ASMACCT:
				case ASMACCF:
				case ASMACC:
				case ASMJOINABLE:
				case BIGAND:
				case BIGOR:
				case FUNCTION:
				case LPAREN:
				case LBRACE:
				case LSETBRACK:
				case LBRACK:
				case LSEQBRACK:
				case AT:
				case LT:
				case PLUS:
				case IDENT:
				case IDENTTIMED:
				case IDENTNARITY:
				{
					suc=term_list();
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				ts = new TermSequent(new AstSequent(t.getLocation(), prependTerm(t, ant), suc));
				
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case SEQARROW:
		{
			seqarrow = LT(1);
			match(SEQARROW);
			{
			switch ( LA(1)) {
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case ASM:
			case ASMDEF:
			case ASMUPD:
			case ASMCON:
			case ASMINV:
			case ASMEQUI:
			case ASMEQUIS:
			case ASMEQUIA:
			case ASMACCT:
			case ASMACCF:
			case ASMACC:
			case ASMJOINABLE:
			case BIGAND:
			case BIGOR:
			case FUNCTION:
			case LPAREN:
			case LBRACE:
			case LSETBRACK:
			case LBRACK:
			case LSEQBRACK:
			case AT:
			case LT:
			case PLUS:
			case IDENT:
			case IDENTTIMED:
			case IDENTNARITY:
			{
				suc=term_list();
				break;
			}
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			
			ts = new TermSequent(new AstSequent(createLocation(seqarrow), EMPTY_TERMS, suc));
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return ts;
	}
	
	protected final AstTaclet  taclet() throws RecognitionException, TokenStreamException {
		AstTaclet r;
		
		Token  if_ = null;
		Token  find = null;
		Token  builtin = null;
		
		AstSequent s = null;
		TermSequent ts;
		AstCondition[] conds = EMPTY_CONDITIONS;
		AstGoal[] goals;
		AstTacletModifier[] mods;
		Location location = null;
		
		
		{
		switch ( LA(1)) {
		case FIND:
		case IF:
		{
			{
			{
			switch ( LA(1)) {
			case IF:
			{
				if_ = LT(1);
				match(IF);
				match(LPAREN);
				s=seq();
				match(RPAREN);
				
				location = createLocation(if_);
				
				break;
			}
			case FIND:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			find = LT(1);
			match(FIND);
			match(LPAREN);
			ts=termorseq();
			match(RPAREN);
			
			if (location == null) {
			location = createLocation(find);
			}
			
			}
			{
			switch ( LA(1)) {
			case VARCOND:
			case COND:
			{
				{
				switch ( LA(1)) {
				case VARCOND:
				{
					match(VARCOND);
					break;
				}
				case COND:
				{
					match(COND);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(LPAREN);
				conds=conditions();
				match(RPAREN);
				break;
			}
			case CLOSE:
			case REPLACEWITH:
			case REPLACEBRANCH:
			case ADDRULES:
			case ADD:
			case NONINTERACTIVE:
			case RECURSIVE:
			case DISPLAYNAME:
			case HELPTEXT:
			case HEURISTICS:
			case SEMI:
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			goals=goalspecs();
			mods=modifiers();
			
			if (ts.term != null) {
			r = new AstTaclet(location, s, ts.term, conds, goals, mods);
			} else {
			r = new AstTaclet(location, s, ts.sequent, conds, goals, mods);
			}
			
			}
			break;
		}
		case BUILTIN:
		{
			{
			builtin = LT(1);
			match(BUILTIN);
			
			r = null;
			
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return r;
	}
	
	protected final AstCondition[]  conditions() throws RecognitionException, TokenStreamException {
		AstCondition[] conds;
		
		
		AstCondition cond;
		List list = createList();
		
		
		cond=condition();
		
		list.add(cond);
		
		{
		_loop116:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				cond=condition();
				
				list.add(cond);
				
			}
			else {
				break _loop116;
			}
			
		} while (true);
		}
		
		conds = (AstCondition[]) list.toArray(new AstCondition[list.size()]);
		
		return conds;
	}
	
	protected final AstGoal[]  goalspecs() throws RecognitionException, TokenStreamException {
		AstGoal[] goals;
		
		
		switch ( LA(1)) {
		case CLOSE:
		{
			match(CLOSE);
			match(GOAL);
			
			goals = new AstGoal[]{ };
			
			break;
		}
		case REPLACEWITH:
		case REPLACEBRANCH:
		case ADDRULES:
		case ADD:
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			goals=goalspec_list();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return goals;
	}
	
	protected final AstTacletModifier[]  modifiers() throws RecognitionException, TokenStreamException {
		AstTacletModifier[] l;
		
		
		List list = createList();
		AstTacletModifier tm;
		
		
		{
		_loop140:
		do {
			if ((_tokenSet_0.member(LA(1)))) {
				tm=modifier();
				
				list.add(tm);
				
			}
			else {
				break _loop140;
			}
			
		} while (true);
		}
		
		l = (AstTacletModifier[]) list.toArray(new AstTacletModifier[list.size()]);
		
		return l;
	}
	
	protected final AstCondition  condition() throws RecognitionException, TokenStreamException {
		AstCondition cond;
		
		Token  op = null;
		Token  pure = null;
		Token  static_ = null;
		Token  staticargs = null;
		Token  dynamic = null;
		Token  atomic = null;
		Token  call = null;
		
		Identifier v, w, r, f;
		
		
		switch ( LA(1)) {
		case OP:
		{
			op = LT(1);
			match(OP);
			v=ident();
			{
			switch ( LA(1)) {
			case EQUALS:
			{
				match(EQUALS);
				w=ident();
				
				cond = af.createOperatorEqualsCondition(createLocation(op), true, v, w);
				
				break;
			}
			case NOTEQUALS:
			{
				match(NOTEQUALS);
				w=ident();
				
				cond = af.createOperatorEqualsCondition(createLocation(op), false, v, w);
				
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case PURE:
		{
			pure = LT(1);
			match(PURE);
			v=ident();
			
			cond = af.createPureCondition(createLocation(pure), v);
			
			break;
		}
		case STATIC:
		{
			static_ = LT(1);
			match(STATIC);
			v=ident();
			
			cond = af.createStaticCondition(createLocation(static_), v);
			
			break;
		}
		case STATICARGS:
		{
			staticargs = LT(1);
			match(STATICARGS);
			v=ident();
			
			cond = af.createStaticArgsCondition(createLocation(staticargs), v);
			
			break;
		}
		case DYNAMIC:
		{
			dynamic = LT(1);
			match(DYNAMIC);
			v=ident();
			
			cond = af.createDynamicCondition(createLocation(dynamic), v);
			
			break;
		}
		case ATOMIC:
		{
			atomic = LT(1);
			match(ATOMIC);
			v=ident();
			
			cond = af.createAtomicCondition(createLocation(atomic), v);
			
			break;
		}
		case CALL:
		{
			call = LT(1);
			match(CALL);
			v=ident();
			
			cond = af.createCallCondition(createLocation(call), v);
			
			break;
		}
		default:
			if ((LA(1)==PLUS||LA(1)==IDENT) && (LA(2)==NOT)) {
				v=ident();
				match(NOT);
				{
				switch ( LA(1)) {
				case FREE:
				{
					match(FREE);
					match(ASMIN);
					w=ident();
					
					cond = af.createNotFreeCondition(v.getLocation(), v, w);
					
					break;
				}
				case UPDATE:
				{
					match(UPDATE);
					f=ident();
					
					cond = af.createNotUpdateCondition(v.getLocation(), v,f);
					
					break;
				}
				case ACCESS:
				{
					match(ACCESS);
					f=ident();
					
					cond = af.createNotAccessCondition(v.getLocation(), v, f);
					
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
			}
			else if ((LA(1)==PLUS||LA(1)==IDENT) && (LA(2)==NEW)) {
				v=ident();
				match(NEW);
				match(DEPENDING);
				match(ON);
				w=ident();
				
				cond = af.createSkolemCondition(v.getLocation(), v, w);
				
			}
			else if ((LA(1)==PLUS||LA(1)==IDENT) && (LA(2)==MAY)) {
				r=ident();
				match(MAY);
				{
				switch ( LA(1)) {
				case UDPATE:
				{
					match(UDPATE);
					f=ident();
					
					cond = af.createMayUpdateCondition(r.getLocation(), r, f);
					
					break;
				}
				case ACCESS:
				{
					match(ACCESS);
					f=ident();
					
					cond = af.createMayAccessCondition(r.getLocation(), r, f);
					
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return cond;
	}
	
	protected final AstGoal[]  goalspec_list() throws RecognitionException, TokenStreamException {
		AstGoal[] goals;
		
		
		List list = createList();
		AstGoal g;
		
		
		{
		switch ( LA(1)) {
		case REPLACEWITH:
		case ADDRULES:
		case ADD:
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			{
			g=goalspec();
			
			list.add(g);
			
			{
			_loop126:
			do {
				if ((LA(1)==SEMI)) {
					match(SEMI);
					g=goalspec();
					
					list.add(g);
					
				}
				else {
					break _loop126;
				}
				
			} while (true);
			}
			}
			break;
		}
		case REPLACEBRANCH:
		{
			{
			g=replacebranch();
			
			list.add(g);
			
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		goals = (AstGoal[]) list.toArray(new AstGoal[list.size()]);
		
		return goals;
	}
	
	protected final AstGoal  goalspec() throws RecognitionException, TokenStreamException {
		AstGoal goal;
		
		
		goal=replacewith();
		return goal;
	}
	
	protected final AstGoal  replacebranch() throws RecognitionException, TokenStreamException {
		AstGoal g;
		
		Token  replacebranch = null;
		
		AstSequent s;
		
		
		replacebranch = LT(1);
		match(REPLACEBRANCH);
		match(LPAREN);
		s=seq();
		match(RPAREN);
		
		g = af.createReplaceGoal(createLocation(replacebranch), null, s);
		
		return g;
	}
	
	protected final AstGoal  replacewith() throws RecognitionException, TokenStreamException {
		AstGoal goal;
		
		Token  rw = null;
		Token  str = null;
		Token  add = null;
		Token  addrules = null;
		
		Location location = null;
		TermSequent ts = null;
		AstSequent s = null;
		AstTacletDeclaration[] l = null;
		String name = null;
		
		
		{
		switch ( LA(1)) {
		case REPLACEWITH:
		{
			rw = LT(1);
			match(REPLACEWITH);
			{
			switch ( LA(1)) {
			case STRING_LITERAL:
			{
				str = LT(1);
				match(STRING_LITERAL);
				
				name = str.getText();
				
				break;
			}
			case LPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LPAREN);
			ts=termorseq();
			match(RPAREN);
			
			if (location == null) {
			location = createLocation(rw);
			}
			
			break;
		}
		case ADDRULES:
		case ADD:
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case ADD:
		{
			add = LT(1);
			match(ADD);
			match(LPAREN);
			s=seq();
			match(RPAREN);
			
			if (location == null) {
			location = createLocation(add);
			}
			
			break;
		}
		case ADDRULES:
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case ADDRULES:
		{
			addrules = LT(1);
			match(ADDRULES);
			match(LPAREN);
			l=taclet_decl_list();
			match(RPAREN);
			
			if (location == null) {
			location = createLocation(addrules);
			}
			
			break;
		}
		case NONINTERACTIVE:
		case RECURSIVE:
		case DISPLAYNAME:
		case HELPTEXT:
		case HEURISTICS:
		case SEMI:
		case RBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		if (ts == null) {
		goal = af.createReplaceGoal(location, name, (AstTerm) null, s, l);
		} else if (ts.term != null) {
		goal = af.createReplaceGoal(location, name, ts.term, s, l);
		} else {
		goal = af.createReplaceGoal(location, name, ts.sequent, s, l);
		}
		
		return goal;
	}
	
	protected final AstTacletDeclaration[]  taclet_decl_list() throws RecognitionException, TokenStreamException {
		AstTacletDeclaration[] l;
		
		
		AstTacletDeclaration decl;
		List list = createList();
		
		
		decl=taclet_decl();
		
		list.add(decl);
		
		{
		_loop137:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				decl=taclet_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop137;
			}
			
		} while (true);
		}
		
		l = (AstTacletDeclaration[]) list.toArray(new AstTacletDeclaration[list.size()]);
		
		return l;
	}
	
	protected final AstTacletDeclaration  taclet_decl() throws RecognitionException, TokenStreamException {
		AstTacletDeclaration decl;
		
		
		Identifier id;
		AstTaclet t;
		
		
		id=ident();
		match(LBRACE);
		t=taclet();
		match(RBRACE);
		
		decl = new AstTacletDeclaration(id.getLocation(), id, t);
		
		return decl;
	}
	
	protected final AstTacletModifier  modifier() throws RecognitionException, TokenStreamException {
		AstTacletModifier tm;
		
		Token  heurs = null;
		Token  ni = null;
		Token  re = null;
		Token  dn = null;
		Token  dname = null;
		Token  ht = null;
		Token  htext = null;
		
		Identifier[] ids;
		
		
		switch ( LA(1)) {
		case HEURISTICS:
		{
			heurs = LT(1);
			match(HEURISTICS);
			match(LPAREN);
			ids=id_list();
			match(RPAREN);
			
			tm = af.createTacletHeuristics(createLocation(heurs), ids);
			
			break;
		}
		case NONINTERACTIVE:
		{
			ni = LT(1);
			match(NONINTERACTIVE);
			
			tm = af.createTacletNonInteractiveModifier(createLocation(ni));
			
			break;
		}
		case RECURSIVE:
		{
			re = LT(1);
			match(RECURSIVE);
			
			tm = af.createTacletRecursiveModifier(createLocation(re));
			
			break;
		}
		case DISPLAYNAME:
		{
			dn = LT(1);
			match(DISPLAYNAME);
			dname = LT(1);
			match(STRING_LITERAL);
			
			tm = af.createTacletDisplayNameModifier(createLocation(dn), dname.getText());
			
			break;
		}
		case HELPTEXT:
		{
			ht = LT(1);
			match(HELPTEXT);
			htext = LT(1);
			match(STRING_LITERAL);
			
			tm = af.createTacletHelpTextModifier(createLocation(ht), htext.getText());
			// b.setHelpText(htext.getText());
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return tm;
	}
	
	protected final boolean  packages_section() throws RecognitionException, TokenStreamException {
		boolean b;
		
		
		boolean up;
		
		
		match(PACKAGES);
		match(LBRACE);
		{
		int _cnt162=0;
		_loop162:
		do {
			if ((LA(1)==USE)) {
				up=use_package();
			}
			else {
				if ( _cnt162>=1 ) { break _loop162; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt162++;
		} while (true);
		}
		match(RBRACE);
		
		b=true;
		
		return b;
	}
	
	protected final AstDeclaration[]  decls_without_lemmas() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration[] l;
		
		
		{
		_loop181:
		do {
			if ((_tokenSet_1.member(LA(1)))) {
				{
				switch ( LA(1)) {
				case SORTS:
				{
					l=sort_decls();
					break;
				}
				case SCHEMA:
				{
					l=schema_var_decls();
					break;
				}
				case PREDICATES:
				{
					l=pred_decls();
					break;
				}
				case FUNCTIONS:
				{
					l=func_decls();
					break;
				}
				case HEURISTICS:
				{
					l=heur_decls();
					break;
				}
				case RULES:
				{
					l=taclet_decls();
					break;
				}
				case HYPERRULES:
				{
					l=hyper_decls();
					break;
				}
				case PROCEDURES:
				{
					l=procedure_decls();
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				list.addAll(Arrays.asList(l));
				
			}
			else {
				break _loop181;
			}
			
		} while (true);
		}
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final boolean  lemmas_section() throws RecognitionException, TokenStreamException {
		boolean b;
		
		
		boolean l;
		
		
		match(LEMMAS);
		match(LBRACE);
		{
		int _cnt166=0;
		_loop166:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				l=lemma_def();
			}
			else {
				if ( _cnt166>=1 ) { break _loop166; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt166++;
		} while (true);
		}
		match(RBRACE);
		
		b = true;
		
		return b;
	}
	
	protected final AstDeclaration[]  lemma_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration d;
		
		
		match(LEMMAS);
		match(LBRACE);
		{
		_loop230:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				d=lemma_decl();
				match(SEMI);
				
				list.add(d);
				
			}
			else {
				break _loop230;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstImportFile[]  importdecls() throws RecognitionException, TokenStreamException {
		AstImportFile[] impfiles;
		
		
		List list = createList();
		AstImportFile imfile;
		
		
		match(IMPORTFILES);
		match(LBRACE);
		{
		_loop170:
		do {
			if ((LA(1)==FILE)) {
				imfile=importfile();
				
				list.add(imfile);
				
			}
			else {
				break _loop170;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		if (list.size() == 0) {
		impfiles = null;
		} else {
		impfiles = (AstImportFile[]) list.toArray(new AstImportFile[list.size()]);
		}
		
		return impfiles;
	}
	
	protected final AstImportFile[]  importlemmas() throws RecognitionException, TokenStreamException {
		AstImportFile[] impfiles;
		
		
		List list = createList();
		AstImportFile imfile;
		
		
		match(IMPORTLEMMAS);
		match(LBRACE);
		{
		_loop173:
		do {
			if ((LA(1)==FILE)) {
				imfile=importfile();
				
				list.add(imfile);
				
			}
			else {
				break _loop173;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		if (list.size() == 0) {
		impfiles = null;
		} else {
		impfiles = (AstImportFile[]) list.toArray(new AstImportFile[list.size()]);
		}
		
		return impfiles;
	}
	
	public final AstProofExpression  proof() throws RecognitionException, TokenStreamException {
		AstProofExpression pe;
		
		
		match(PROOF);
		match(LBRACE);
		pe=proof_expr();
		match(RBRACE);
		return pe;
	}
	
	protected final boolean  use_package() throws RecognitionException, TokenStreamException {
		boolean b;
		
		
		Identifier id;
		
		
		match(USE);
		id=ident();
		match(SEMI);
		
		b=true;
		
		return b;
	}
	
	protected final boolean  lemma_def() throws RecognitionException, TokenStreamException {
		boolean b;
		
		
		Identifier id;
		AstTerm f;
		
		
		id=ident();
		match(LBRACE);
		match(FORMULA);
		match(LBRACE);
		f=formula();
		match(RBRACE);
		match(RBRACE);
		match(SEMI);
		
		b=true;
		
		return b;
	}
	
	protected final AstImportFile  importfile() throws RecognitionException, TokenStreamException {
		AstImportFile imfile;
		
		Token  path = null;
		
		String p;
		
		
		path = LT(1);
		match(FILE);
		p=path();
		match(SEMI);
		
		imfile = new AstImportFile(createLocation(path),p);
		
		return imfile;
	}
	
	protected final String  path() throws RecognitionException, TokenStreamException {
		String p;
		
		Token  pa = null;
		
		pa = LT(1);
		match(STRING_LITERAL);
		
		p = pa.getText();
		
		return p;
	}
	
	protected final AstDeclaration[]  sort_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			List list = createList();
		AstDeclaration decl;
		
		
		match(SORTS);
		match(LBRACE);
		{
		_loop184:
		do {
			if ((LA(1)==GENERIC||LA(1)==PLUS||LA(1)==IDENT)) {
				decl=sort_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop184;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  schema_var_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			List list = createList();
		AstDeclaration[] decl;
		
		
		match(SCHEMA);
		match(VARIABLES);
		match(LBRACE);
		{
		_loop189:
		do {
			if ((_tokenSet_2.member(LA(1)))) {
				decl=schema_var_decl();
				
				list.addAll(Arrays.asList(decl));
				
			}
			else {
				break _loop189;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  pred_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration decl;
		
		
		match(PREDICATES);
		match(LBRACE);
		{
		_loop196:
		do {
			if ((_tokenSet_3.member(LA(1)))) {
				decl=pred_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop196;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  func_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration decl;
		
		
		match(FUNCTIONS);
		match(LBRACE);
		{
		_loop204:
		do {
			if ((_tokenSet_3.member(LA(1)))) {
				decl=func_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop204;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  heur_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		AstDeclaration decl;
		
		
		match(HEURISTICS);
		match(LBRACE);
		{
		_loop212:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				decl=heur_decl();
				
				list.add(decl);
				
			}
			else {
				break _loop212;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  taclet_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			List list = createList();
		AstDeclaration d;
		
		
		match(RULES);
		match(LBRACE);
		{
		_loop219:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				d=taclet_decl();
				match(SEMI);
				
				list.add(d);
				
			}
			else {
				break _loop219;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration[]  hyper_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
		List list = createList();
		//AstHyper h;
		
		
		match(HYPERRULES);
		match(LBRACE);
		match(RBRACE);
		
		decls = null;
		
		return decls;
	}
	
	protected final AstDeclaration[]  procedure_decls() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			List list = createList();
		AstDeclaration d;
		
		
		match(PROCEDURES);
		match(LBRACE);
		{
		_loop224:
		do {
			if ((LA(1)==PLUS||LA(1)==IDENT)) {
				d=procedure_decl();
				match(SEMI);
				
				list.add(d);
				
			}
			else {
				break _loop224;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		decls = (AstDeclaration[]) list.toArray(new AstDeclaration[list.size()]);
		
		return decls;
	}
	
	protected final AstDeclaration  sort_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration decl;
		
		
		Identifier id;
		boolean isGenericSort=false;
		
		
		{
		switch ( LA(1)) {
		case GENERIC:
		{
			match(GENERIC);
			isGenericSort=true;
			break;
		}
		case PLUS:
		case IDENT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		id=ident();
		match(SEMI);
		
		decl = af.createSortDeclaration(id.getLocation(), id, isGenericSort);
		
		return decl;
	}
	
	protected final AstDeclaration[]  schema_var_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration[] decls;
		
		
			AstSchemaType r;
		Identifier[] l;
		
		
		r=schema_type_ref();
		l=id_list();
		match(SEMI);
		
		decls = new AstDeclaration[l.length];
		for (int i = 0; i < l.length; ++i) {
		decls[i] = af.createSchemaVariableDeclaration(r.getLocation(), l[i], r);
		}
		
		return decls;
	}
	
	protected final AstSchemaType  schema_type_ref() throws RecognitionException, TokenStreamException {
		AstSchemaType r;
		
		Token  asm = null;
		Token  formula = null;
		
		Identifier sort;
		boolean variable = false;
		boolean depending = false;
		
		
		{
		switch ( LA(1)) {
		case ASM:
		{
			asm = LT(1);
			match(ASM);
			match(RULE);
			
			r = af.createSchemaType(createLocation(asm), PrimitiveSchemaType.ASMRULE);
			
			break;
		}
		case FORMULA:
		{
			formula = LT(1);
			match(FORMULA);
			
			r = af.createSchemaType(createLocation(formula), PrimitiveSchemaType.FORMULA);
			
			break;
		}
		case PLUS:
		case IDENT:
		{
			sort=ident();
			{
			switch ( LA(1)) {
			case VARIABLES:
			{
				match(VARIABLES);
				
				variable = true; 
				
				break;
			}
			case DEPENDING:
			{
				match(DEPENDING);
				
				depending = true;
				
				break;
			}
			case PLUS:
			case IDENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			
			if (depending) {
			r = af.createDependingSchemaType(sort.getLocation(), sort);
			} else {
			r = af.createSchemaType(sort.getLocation(), sort, variable);
			}
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return r;
	}
	
	protected final AstDeclaration  pred_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration decl;
		
		Token  der = null;
		Token  dyn = null;
		
		Identifier id;
		Identifier[] args = null;
		Location location = null;
		boolean dynamic = false;
		AstTerm t = null;
		
		
		{
		switch ( LA(1)) {
		case DERIVED:
		{
			{
			der = LT(1);
			match(DERIVED);
			id=ident();
			args=arg_ids();
			match(EQUALS);
			t=formula();
			
			decl = af.createDerivedPredicateDeclaration(createLocation(der), id, args, t);
			
			}
			break;
		}
		case DYNAMIC:
		case PLUS:
		case IDENT:
		{
			{
			{
			switch ( LA(1)) {
			case DYNAMIC:
			{
				dyn = LT(1);
				match(DYNAMIC);
				
				dynamic = true;
				
				break;
			}
			case PLUS:
			case IDENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			id=ident();
			args=arg_ids();
			
			decl = af.createPredicateDeclaration(location == null ? id.getLocation() : location, id, args);
			
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEMI);
		return decl;
	}
	
	protected final Identifier[]  arg_ids() throws RecognitionException, TokenStreamException {
		Identifier[] sorts = null;
		
		
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			{
			switch ( LA(1)) {
			case ASM:
			case PLUS:
			case IDENT:
			{
				sorts=id_asm_rule_list();
				match(RPAREN);
				break;
			}
			case RPAREN:
			{
				match(RPAREN);
				
				sorts = EMPTY_IDS;
				
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case SEMI:
		case EQUALS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return sorts;
	}
	
	protected final AstDeclaration  func_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration decl;
		
		Token  der = null;
		Token  d = null;
		
		Identifier ret;
		Identifier id;
			Identifier[] args=null;
		boolean dynamic = false;
		Location location = null;
		AstTerm t = null;
		
		
		{
		switch ( LA(1)) {
		case DERIVED:
		{
			{
			der = LT(1);
			match(DERIVED);
			ret=ident();
			id=ident();
			args=arg_ids();
			match(EQUALS);
			t=term();
			
			decl = af.createDerivedFunctionDeclaration(createLocation(der), id, args, ret, t);
			
			}
			break;
		}
		case DYNAMIC:
		case PLUS:
		case IDENT:
		{
			{
			{
			switch ( LA(1)) {
			case DYNAMIC:
			{
				d = LT(1);
				match(DYNAMIC);
				
				dynamic = true;
				location = createLocation(d);
				
				break;
			}
			case PLUS:
			case IDENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			ret=ident();
			id=ident();
			args=arg_ids();
			
			decl = af.createFunctionDeclaration(location != null ? location : ret.getLocation(),
			id, args, ret, dynamic);
			
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEMI);
		return decl;
	}
	
	protected final AstDeclaration  heur_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration decl;
		
		
		Identifier id;
		
		
		id=ident();
		match(SEMI);
		
		decl = af.createHeuristicDeclaration(id.getLocation(), id);
		
		return decl;
	}
	
	protected final AstDeclaration  procedure_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration d;
		
		
		Identifier id;
		AstParameter[] params = EMPTY_PARAMETERS;
		AstAsmRule r;
		
		
		id=ident();
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			{
			switch ( LA(1)) {
			case PLUS:
			case IDENT:
			{
				params=param_list();
				break;
			}
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RPAREN);
			break;
		}
		case LBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(LBRACE);
		r=asm_rule();
		match(RBRACE);
		
		d = af.createProcedureDeclaration(id.getLocation(), id, params, r);
		
		return d;
	}
	
	protected final AstParameter[]  param_list() throws RecognitionException, TokenStreamException {
		AstParameter[] l;
		
		
		AstParameter p;
		List list = createList();
		
		
		p=param();
		
		list.add(p);
		
		{
		_loop258:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				p=param();
				
				list.add(p);
				
			}
			else {
				break _loop258;
			}
			
		} while (true);
		}
		
		l = (AstParameter[]) list.toArray(new AstParameter[list.size()]);
		
		return l;
	}
	
	protected final AstDeclaration  lemma_decl() throws RecognitionException, TokenStreamException {
		AstDeclaration d;
		
		
		Identifier id;
		AstTerm phi;
		
		
		id=ident();
		match(LBRACE);
		match(FORMULA);
		match(LBRACE);
		phi=formula();
		match(RBRACE);
		match(RBRACE);
		
		d = af.createLemmaDeclaration(id.getLocation(), id, phi);
		
		return d;
	}
	
	protected final AstAsmRule  asm_rule_seq() throws RecognitionException, TokenStreamException {
		AstAsmRule r1;
		
		
		AstAsmRule r2;
		
		
		r1=asm_rule_par();
		{
		switch ( LA(1)) {
		case ASMSEQ:
		{
			match(ASMSEQ);
			r2=asm_rule_seq();
			
			r1 = af.createAsmSeq(r1.getLocation(), r1, r2);
			
			break;
		}
		case EOF:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case GT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return r1;
	}
	
	protected final AstAsmRule  asm_rule_par() throws RecognitionException, TokenStreamException {
		AstAsmRule r1;
		
		
		AstAsmRule r2;
		
		
		r1=asm_rule_atom();
		{
		switch ( LA(1)) {
		case ASMPAR:
		{
			match(ASMPAR);
			r2=asm_rule_par();
			
			r1 = af.createAsmPar(r1.getLocation(), r1, r2);
			
			break;
		}
		case EOF:
		case ASMELSE:
		case ASMELSEIF:
		case ASMEND:
		case ASMSEQ:
		case COMMA:
		case RPAREN:
		case RBRACE:
		case RBRACK:
		case GT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return r1;
	}
	
	protected final AstAsmRule  asm_rule_atom() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		Identifier id;
		
		
		{
		switch ( LA(1)) {
		case ASMSKIP:
		{
			r=asm_rule_skip();
			break;
		}
		case CALL:
		{
			r=asm_rule_call();
			break;
		}
		case IF:
		{
			r=asm_rule_if();
			break;
		}
		case ASMELSEIF:
		{
			r=asm_rule_elseif();
			break;
		}
		case ASMLET:
		{
			r=asm_rule_let();
			break;
		}
		case ASMFORALL:
		{
			r=asm_rule_forall();
			break;
		}
		case ASMTRY:
		{
			r=asm_rule_try();
			break;
		}
		case LBRACE:
		{
			r=asm_rule_subst();
			break;
		}
		case AT:
		{
			r=asm_rule_meta();
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			r=asm_rule();
			match(RPAREN);
			break;
		}
		default:
			if ((_tokenSet_4.member(LA(1))) && (_tokenSet_5.member(LA(2)))) {
				r=asm_rule_assign();
			}
			else if ((LA(1)==PLUS||LA(1)==IDENT) && (_tokenSet_6.member(LA(2)))) {
				id=ident();
				
				r = af.createAsmSchemaVariable(id.getLocation(), id);
				
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return r;
	}
	
	protected final AstAsmRule  asm_rule_skip() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  skip = null;
		
		skip = LT(1);
		match(ASMSKIP);
		
		r = af.createAsmSkip(createLocation(skip));
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_assign() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		AstTerm t1, t2;
		
		
		t1=funcpredvarterm();
		match(ASSIGN);
		t2=term();
		
		r = af.createAsmAssign(t1.getLocation(), t1, t2);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_call() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		
		Identifier id;
		AstTerm[] l;
		
		
		match(CALL);
		id=ident();
		l=term_args();
		
		r = af.createAsmCall(id.getLocation(), id, l);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_if() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  if_ = null;
		
		AstTerm phi;
		AstAsmRule r1, r2;
		
		
		if_ = LT(1);
		match(IF);
		phi=formula();
		match(ASMTHEN);
		r1=asm_rule();
		r2=asm_rule_if_end();
		
		r = af.createAsmIf(createLocation(if_), phi, r1, r2);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_elseif() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  elseif = null;
		
		AstTerm phi;
		AstAsmRule r1, r2;
		
		
		elseif = LT(1);
		match(ASMELSEIF);
		phi=formula();
		match(ASMTHEN);
		r1=asm_rule();
		r2=asm_rule_if_end();
		
		r = af.createAsmElseif(createLocation(elseif), phi, r1, r2);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_let() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  let = null;
		
		Identifier v;
		Identifier sort = null;
		AstTerm t;
		
		
		let = LT(1);
		match(ASMLET);
		v=ident();
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			sort=ident();
			break;
		}
		case EQUALS:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(EQUALS);
		t=funcpredvarterm();
		match(ASMIN);
		r=asm_rule();
		match(ASMEND);
		
		r = af.createAsmLet(createLocation(let), v, sort, t, r);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_forall() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  forall = null;
		
		Identifier v;
		Identifier sort = null;
		AstTerm t;
		
		
		forall = LT(1);
		match(ASMFORALL);
		v=ident();
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			sort=ident();
			break;
		}
		case ASMWITH:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(ASMWITH);
		t=formula();
		match(ASMDO);
		r=asm_rule();
		match(ASMEND);
		
		r = af.createAsmForall(createLocation(forall), v, sort, t, r);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_try() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  try_ = null;
		
		AstAsmRule r1, r2;
		
		
		try_ = LT(1);
		match(ASMTRY);
		r1=asm_rule();
		match(ASMELSE);
		r2=asm_rule();
		match(ASMEND);
		
		r = af.createAsmTry(createLocation(try_), r1, r2);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_subst() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  lbrace = null;
		
		Identifier var;
		Identifier sort = null;
		AstTerm t;
		
		
		lbrace = LT(1);
		match(LBRACE);
		var=ident();
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			sort=ident();
			break;
		}
		case FORALL:
		case EXISTS:
		case TRUE:
		case FALSE:
		case NOT:
		case ASM:
		case ASMDEF:
		case ASMUPD:
		case ASMCON:
		case ASMINV:
		case ASMEQUI:
		case ASMEQUIS:
		case ASMEQUIA:
		case ASMACCT:
		case ASMACCF:
		case ASMACC:
		case ASMJOINABLE:
		case BIGAND:
		case BIGOR:
		case FUNCTION:
		case LPAREN:
		case LBRACE:
		case LSETBRACK:
		case LBRACK:
		case LSEQBRACK:
		case AT:
		case LT:
		case PLUS:
		case IDENT:
		case IDENTTIMED:
		case IDENTNARITY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		t=term();
		match(RBRACE);
		r=asm_rule_atom();
		
		r = af.createAsmSubstitution(createLocation(lbrace), var, sort, t, r);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_meta() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  at = null;
		
		Identifier id;
		
		
		at = LT(1);
		match(AT);
		id=ident();
		match(LPAREN);
		r=asm_rule();
		match(RPAREN);
		
		r = af.createAsmRuleMeta(createLocation(at), id, r);
		
		return r;
	}
	
	protected final AstAsmRule  asm_rule_if_end() throws RecognitionException, TokenStreamException {
		AstAsmRule r;
		
		Token  elseif = null;
		Token  else_ = null;
		
		AstTerm phi, phi1;
		AstAsmRule r1, r2=null;
		List phis = createList();
		List elsifs = createList();
		List locations = createList();
		int ll;
		
		
		{
		_loop246:
		do {
			if ((LA(1)==ASMELSEIF)) {
				elseif = LT(1);
				match(ASMELSEIF);
				phi=formula();
				match(ASMTHEN);
				r1=asm_rule();
				phis.add(phi); elsifs.add(r1);
				locations.add(createLocation(elseif));
			}
			else {
				break _loop246;
			}
			
		} while (true);
		}
		{
		else_ = LT(1);
		match(ASMELSE);
		r2=asm_rule();
		}
		match(ASMEND);
		
		//first create the tail.
		if (r2 == null) { r2 = af.createAsmSkip(createLocation(else_)); }
		
		//simple if or elsif
		ll = phis.size();
		if (ll == 0) {
		r = r2;
		} else {
		r = af.createAsmElseif((Location) locations.get(ll-1),
		(AstTerm) phis.get(ll-1),
		(AstAsmRule) elsifs.get(ll-1), r2);
		for(int i = ll-2; i>=0; i--) {
		r = af.createAsmElseif((Location) locations.get(i),
		(AstTerm)phis.get(i),
		(AstAsmRule)elsifs.get(i), r);
		}
		}
		
		return r;
	}
	
	protected final AstParameter  param() throws RecognitionException, TokenStreamException {
		AstParameter p;
		
		
		Identifier id;
		Identifier sort;
		
		
		id=ident();
		match(COLON);
		sort=ident();
		
		p = new AstParameter(id.getLocation(), id, sort);
		
		return p;
	}
	
	protected final AstProofExpression  proof_expr() throws RecognitionException, TokenStreamException {
		AstProofExpression pe = null;
		
		Token  paren = null;
		Token  str = null;
		
		AstProofExpression child;
		AstProofExpressionType type;
		List list = createList();
		String id = null;
		
		
		paren = LT(1);
		match(LPAREN);
		{
		switch ( LA(1)) {
		case BUILTIN:
		case TERM:
		case BRANCH:
		case INST:
		case IFSEQFORMULA:
		case INTERACTIVE:
		case HEUR:
		case FORMULA:
		case RULE:
		case IDENT:
		{
			type=proof_expr_type();
			{
			switch ( LA(1)) {
			case STRING_LITERAL:
			{
				str = LT(1);
				match(STRING_LITERAL);
				
				id = str.getText();
				
				break;
			}
			case LPAREN:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop265:
			do {
				if ((LA(1)==LPAREN)) {
					child=proof_expr();
					
					list.add(child);
					
				}
				else {
					break _loop265;
				}
				
			} while (true);
			}
			
			AstProofExpression[] children = (AstProofExpression[]) list.toArray(new AstProofExpression[list.size()]);
			pe = new AstProofExpression(createLocation(paren), type, id, children);
			
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RPAREN);
		return pe;
	}
	
	protected final AstProofExpressionType  proof_expr_type() throws RecognitionException, TokenStreamException {
		AstProofExpressionType type;
		
		
		{
		switch ( LA(1)) {
		case FORMULA:
		{
			match(FORMULA);
			
			type = AstProofExpressionType.FORMULA;
			
			break;
		}
		case TERM:
		{
			match(TERM);
			
			type = AstProofExpressionType.TERM;
			
			break;
		}
		case BUILTIN:
		{
			match(BUILTIN);
			
			type = AstProofExpressionType.BUILTIN;
			
			break;
		}
		case RULE:
		{
			match(RULE);
			
			type = AstProofExpressionType.RULE;
			
			break;
		}
		case BRANCH:
		{
			match(BRANCH);
			
			type = AstProofExpressionType.BRANCH;
			
			break;
		}
		case INST:
		{
			match(INST);
			
			type = AstProofExpressionType.INST;
			
			break;
		}
		case IFSEQFORMULA:
		{
			match(IFSEQFORMULA);
			
			type = AstProofExpressionType.IFSEQFORMULA;
			
			break;
		}
		case INTERACTIVE:
		{
			match(INTERACTIVE);
			
			type = AstProofExpressionType.INTERACTIVE;
			
			break;
		}
		case HEUR:
		{
			match(HEUR);
			
			type = AstProofExpressionType.HEURISTICS;
			
			break;
		}
		case IDENT:
		{
			match(IDENT);
			
			type = AstProofExpressionType.IDENT;
			
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return type;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"all\"",
		"\"ex\"",
		"\"true\"",
		"\"false\"",
		"\"find\"",
		"\"if\"",
		"\"close\"",
		"\"goal\"",
		"\"replacewith\"",
		"\"replacebranch\"",
		"\"addrules\"",
		"\"add\"",
		"\"builtin\"",
		"\"apply\"",
		"\"taclet\"",
		"\"varcond\"",
		"\"cond\"",
		"\"typeof\"",
		"\"new\"",
		"\"op\"",
		"\"not\"",
		"\"free\"",
		"\"pure\"",
		"\"depending\"",
		"\"on\"",
		"\"noninteractive\"",
		"\"recursive\"",
		"\"displayname\"",
		"\"helptext\"",
		"\"proof\"",
		"\"depends\"",
		"\"term\"",
		"\"branch\"",
		"\"inst\"",
		"\"ifseqformula\"",
		"\"interactive\"",
		"\"heur\"",
		"\"problem\"",
		"\"procedures\"",
		"\"call\"",
		"\"is\"",
		"\"sorts\"",
		"\"schema\"",
		"\"variables\"",
		"\"consts\"",
		"\"predicates\"",
		"\"functions\"",
		"\"formula\"",
		"\"metarules\"",
		"\"rules\"",
		"\"hyperrules\"",
		"\"heuristics\"",
		"\"lemmas\"",
		"\"packages\"",
		"\"importdecls\"",
		"\"importlemmas\"",
		"\"file\"",
		"\"use\"",
		"\"may\"",
		"\"access\"",
		"\"update\"",
		"\"derived\"",
		"\"rule\"",
		"\"asm\"",
		"\"dynamic\"",
		"\"static\"",
		"\"staticargs\"",
		"\"atomic\"",
		"\"generic\"",
		"\"def\"",
		"\"upd\"",
		"\"Con\"",
		"\"inv\"",
		"\"skip\"",
		"\"equi\"",
		"\"equiS\"",
		"\"equiA\"",
		"\"accT\"",
		"\"accF\"",
		"\"acc\"",
		"\"then\"",
		"\"else\"",
		"\"elseif\"",
		"\"end\"",
		"\"in\"",
		"\"let\"",
		"\"forall\"",
		"\"with\"",
		"\"do\"",
		"\"try\"",
		"\"joinable\"",
		"\"and\"",
		"\"par\"",
		"\"seq\"",
		"\"bigand\"",
		"\"bigor\"",
		"\"function\"",
		"SEMI",
		"COLON",
		"ASSIGN",
		"DOT",
		"COMMA",
		"LPAREN",
		"RPAREN",
		"LBRACE",
		"RBRACE",
		"LSETBRACK",
		"LBRACK",
		"RBRACK",
		"LSEQBRACK",
		"DLBRACK",
		"DRBRACK",
		"AT",
		"ORELSE",
		"ANDALSO",
		"OR",
		"AND",
		"IMP",
		"EQV",
		"EQUALS",
		"NOTEQUALS",
		"LT",
		"GT",
		"SEQARROW",
		"PLUS",
		"MINUS",
		"ASTERIX",
		"SLASH",
		"TIMED",
		"a digit",
		"a letter",
		"an admissible character for identifiers",
		"an identifer or a timed identifier",
		"IDENTTIMED",
		"IDENTNARITY",
		"white space",
		"a comment",
		"a comment",
		"a string in double quotes",
		"ESC",
		"UDPATE"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 36028805072027648L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 64849195806228480L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 2251799813685248L, 8L, 257L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 0L, 18L, 257L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 0L, 0L, 1793L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 192L, 4508547429695488L, 257L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 2L, 4612013685792047104L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	
	}
