--
-- OclType
--
lin OclType = stdClass "OclType";

    class2oclType c = const c.s;

    otName t = dotOper0 t "name";
    otAttributes t = dotOper0 t "attributes";
    otOperations t = dotOper0 t "operations";
    otSupertypes t = dotOper0 t "supertypes";
    otAllSupertypes t = dotOper0 t "allSupertypes";
    otAllInstancesStrict _ t = dotOper0 t "allInstances";


--
-- OclAny 
--
lin OclAny = stdClass "OclAny";
    conforms2OclAny c = ss (c.s ++ ["conforms to OclAny"]);
    
    anyEq a b =  infix eqP "=" a b;
    anyNeq a b =  infix eqP "<>" a b;
    anyOclIsKindOf a t = dotOper1 a "oclIsKindOf" t;
    anyOclIsTypeOf a t = dotOper1 a "oclIsTypeOf" t;
    anyOclAsTypeStrict a c t = dotOper1 a "oclAsType" t;
    anyOclInState a s = dotOper1 a "oclIsInState" s;
    anyOclIsNew a = dotOper0 a "oclIsNew";


--
-- OclState 
--
lin OclState = stdClass "OclState";


--
-- OclExpression
--
lin OclExpression = stdClass "OclExpression";

    inst2OclExpr _ i = i; -- oh yes, circular
    oeEvaluationType e = dotOper0 e "evaluationType";


--
-- Integer
--
lin Integer = stdClass "Integer";
lin	
	intEq a b = infix eqP "=" a b;
	intAdd a b = infix addP "+" a b;
	intSub a b = infixL addP "-" a b;
	intUnaryMinus a = prefix unP "-" a;
	intTimes a b = infix multP "*" a b;
	intDiv2Real a b = infixL multP "/" a b;
	intAbs a = dotOper0 a "abs";
	intDiv2Int a b = dotOper1 a "div" b;
	intMod a b = dotOper1 a "mod" b;
	intMax a b = dotOper1 a "max" b;
	intMin a b = dotOper1 a "min" b;
	intLT a b = infix gtP "<" a b;
	intGT a b = infix gtP ">" a b;
	intLTE a b = infix gtP "<=" a b;
	intGTE a b = infix gtP ">=" a b;

lin	Zero = const "0";
	One = const "1";
	Two = const "2";
	int i = const i.s;

--
-- Real
--
lin Real = stdClass "Real";
lin
	realEq a b = infix eqP "=" a b;
	realNeq a b = infix eqP "<>" a b;
	realAdd a b = infix addP "+" a b;
	realSub a b = infixL addP "-" a b;
	realUnaryMinus a = prefix unP "-" a;
	realTimes a b = infix multP "*" a b;
	realDiv a b = infixL multP "/" a b;
	realAbs a = dotOper0 a "abs";
	realFloor a = dotOper0 a "floor";
	realRound a = dotOper0 a "round";
	realMax a b = dotOper1 a "max" b;
	realMin a b = dotOper1 a "min" b;
	realLT a b = infix gtP "<" a b;
	realGT a b = infix gtP ">" a b;
	realLTE a b = infix gtP "<=" a b;
	realGTE a b = infix gtP ">=" a b;


--
-- Bool
--
lin BoolC = stdClass "Bool";
	true = const "true";
	false = const "false";
	notBool a = prefix unP "not" a;
	boolEq a b = infix eqP "=" a b;
	orBool a b = infix andP "or" a b;
	andBool a b = infix andP "and" a b;
	xorBool a b = infix andP "xor" a b;
	impliesBool a b = infixR impP "implies" a b; 
--
-- Sent
--
lin sentEq a b = infix eqP "=" a b;
	notS a = prefix unP "not" a;
	orS a b = infix andP "or" a b;
	andS a b = infix andP "and" a b;
	xorS a b = infix andP "xor" a b;
	impliesS a b = infixR impP "implies" a b; 

lin ifThenElse _ cond t e = {
		s0 = "if" ++ noParen cond ++ "then" ++ noParen t ++ "else" ++ noParen e ++ "endif"; 
		s1 = "if" ++ noParen cond ++ "then" ++ noParen t ++ "else" ++ noParen e ++ ["endif @pre"]; -- erroneous 
		p = ifP;
		isAtpre = False
	};
	
	ifThenElseS cond t e = {
		s0 = "if" ++ noParen cond ++ "then" ++ noParen t ++ "else" ++ noParen e ++ "endif"; 
		s1 = "if" ++ noParen cond ++ "then" ++ noParen t ++ "else" ++ noParen e ++ ["endif @pre"]; -- erroneous 
		p = ifP;
		isAtpre = False
	};
	
-- 
-- String
--
lin StringC = stdClass "String";
	stringEq a b = infix eqP "=" a b;
	stringLiteral lit = const (lit.s);
	stringSize s = dotOper0 s "size";
	stringConcat a b = dotOper1 a "concat" b;
	stringToUpper s = dotOper0 s "toUpper";
	stringToLower s = dotOper0 s "toLower";
	stringSubstring s a b = dotOper s "substring" (noParen a ++ "," ++ noParen b);

--
-- Iterators (N.B.: not used for the OCL "iterate" construction!)
--
lincat InstIter = {s1, s2, s3 : Str};
{---- with variants:
oper wrapIter : {s1, s2, s3 :Str} -> Str = \i -> (variants {
		i.s1 ++ i.s2 ++ "|" ++ i.s3;  -- with type info (i.s2)
		i.s1 ++ "|" ++ i.s3});     -- without type info
----}
-- without variants (just one of them):
oper wrapIter : {s1, s2, s3 :Str} -> Str = \i -> (
		i.s1 ++ i.s2 ++ "|" ++ i.s3);  -- with type info (i.s2)

		
lin	instIterSingle varC _ body = {s1 = body.v; s2 = ":" ++ varC.s; 
		s3 = inst2str {s0=body.s0; s1=body.s1; p=body.p; isAtpre=body.isAtpre}};
	instIterMany varC _ body = { s1 = body.v ++ "," ++ body.s1; s2 = ":" ++ varC.s;
		s3 = body.s3};
		
lincat SentIter = {s1, s2, s3 : Str};
lin sentIterSingle varC body = {s1 = body.v; s2 = ":" ++ varC.s; 
		s3 = inst2str {s0=body.s0; s1=body.s1; p=body.p; isAtpre=body.isAtpre}};
	sentIterMany varC body = { s1 = body.v ++ "," ++ body.s1; s2 = ":" ++ varC.s;
		s3 = body.s3};
		
--
-- collections
--
lin
	Collection c = stdClass ("Collection" ++ c.s);
	size _ coll = arrowOper0 coll "size";
	includes _ _ coll a = arrowOper1 coll "includes" a; 
	excludes _ _ coll a = arrowOper1 coll "excludes" a;
	count _ coll a = arrowOper1 coll "count" a;
	includesAll _ coll1 coll2 = arrowOper1 coll1 "includesAll" coll2;
	excludesAll _ coll1 coll2 = arrowOper1 coll1 "excludesAll" coll2;
	isEmpty _ coll = arrowOper coll "isEmpty" "";
	notEmpty _ coll = arrowOper coll "notEmpty" "";
	sum _ coll = arrowOper coll "sum" "";
	exists c coll i = arrowOper coll "exists" (wrapIter i);
		-- arrow1 coll (app1 "exists" (wrapIter i));
	forAll c coll i = arrowOper coll "forAll" (wrapIter i);
	isUnique c d coll i = arrowOper coll "isUnique" (wrapIter i);
	sortedBy c d coll i = arrowOper coll "sortedBy" (wrapIter i);
	iterate c a coll init body = arrowOper coll "iterate" ( 
		body.v0 ++ ":" ++ c.s ++ ";" ++    -- this is the "element", same type as the collection
		body.v1 ++ ":" ++ a.s ++ "=" ++    -- this is the "accumulator", same type as the result
		(noParen init) ++ "|" ++
		(noParen {s=body.s; s1=body.s1; p=body.p; isAtpre = False})  -- NB: "noParen body"  does not work with GF!?
		);
	any c coll i = arrowOper coll "any" (wrapIter i);
	one c coll i = arrowOper coll "one" (wrapIter i);
	
--
-- Set
--
lin	Set c = stdClass ("Set" ++ c.s);
	unionSS c set1 set2 = arrowOper1 set1  "union" set2;
	unionSB c set bag = arrowOper1 set "union" bag;
	setEq c set1 set2 = infix eqP "=" set1 set2;
	intersectionSS c set1 set2 = arrowOper1 set1 "intersection" set2;
	intersectionSB c set bag = arrowOper1 set "intersection" bag;
	subS c set1 set2 = infixL addP "-" set1 set2;
	includingS c set a = arrowOper1 set "including" a;
	excludingS c set a = arrowOper1 set "excluding" a;
	symmetricDiff c set1 set2 = arrowOper1 set1 "symmetricDifference" set2;
	selectSet c set i = arrowOper set "select" (wrapIter i);
	rejectSet c set i = arrowOper set "reject" (wrapIter i);
	collectSet c d set i = arrowOper set "exists" (wrapIter i); 
	countSet c set a = arrowOper1 set "count" a;
	setAsSequence c set = arrowOper set "asSequence" "";
	setAsBag c set = arrowOper set "asBag" "";

--
-- Bag
--
lin	Bag c = stdClass ("Bag" ++ c.s);
	bagEq _ a b = infix eqP "=" a b;
	unionBB _ a b = arrowOper1 a "union" b;
	unionBS _ a b = arrowOper1 a "union" b;
	intersectionBB _ a b = arrowOper1 a "intersection" b;
	intersectionBS _ a b = arrowOper1 a "intersection" b;
	includingB _ bag e = arrowOper1 bag "including" e;
	excludingB _ bag e = arrowOper1 bag "excluding" e;
	selectBag _ bag i = arrowOper bag "select" (wrapIter i);
	rejectBag _ bag i = arrowOper bag "reject" (wrapIter i);
	collectBag _ _  bag i = arrowOper bag "collect" (wrapIter i);
	countBag _ bag e = arrowOper1 bag "count" e;
	bagAsSequence _ bag = arrowOper0 bag "asSequence";
	bagAsSet _ bag = arrowOper0 bag "asSet";
	
		


--
-- Sequence
--
lin	Sequence c = stdClass ("Sequence" ++ c.s);
	sequenceEq c a b = infix eqP "=" a b;
	unionSeq _ a b = arrowOper1 a "union" b;
	append _ a b = arrowOper1 a "append" b;
	prepend _ a b = arrowOper1 a "prepend" b;
	subSequence _ a start end = arrowOper a "subSequence" (noParen start ++ "," ++ noParen end);
	at _ a i = arrowOper1 a "at" i;
	first _ a = arrowOper0 a "first";
	last _ a = arrowOper0 a "last";
	includingSeq _ seq e = arrowOper1 seq "including" e;
	excludingSeq _ seq e = arrowOper1 seq "excluding" e;
	selectSeq _ seq i = arrowOper seq "select" (wrapIter i);
	rejectSeq _ seq i = arrowOper seq "reject" (wrapIter i);
	collectSeq _ _  seq i = arrowOper seq "collect" (wrapIter i);
	seqAsBag _ a = arrowOper0 a "asBag";
	seqAsSet _ a = arrowOper0 a "asSet";
