// $ANTLR 2.7.2: "expandedglobalDeclarationTerms.g" -> "GlobalDeclarationTermParser.java"$


    package de.uka.ilkd.key.parser;

    import java.io.*;
    import antlr.*;
    import de.uka.ilkd.key.logic.*;
    import de.uka.ilkd.key.logic.sort.*;    
    import de.uka.ilkd.key.logic.op.*;
    import de.uka.ilkd.key.rule.metaconstruct.*;
    import de.uka.ilkd.key.rule.*;
    import de.uka.ilkd.key.proof.init.Includes;
    import java.util.List;
    import java.util.LinkedList;
    import java.util.HashMap;
    import java.util.HashSet;
    import java.util.Iterator;
    import de.uka.ilkd.key.java.visitor.ProgramVariableCollector;
    import de.uka.ilkd.key.java.Recoder2KeY;
    import de.uka.ilkd.key.java.JavaReader;
    import de.uka.ilkd.key.java.JavaInfo;
    import de.uka.ilkd.key.java.Services;
    import de.uka.ilkd.key.java.recoderext.*;
    import de.uka.ilkd.key.java.abstraction.KeYJavaType;
    import de.uka.ilkd.key.java.abstraction.ListOfKeYJavaType;
    import de.uka.ilkd.key.java.abstraction.SLListOfKeYJavaType;
    import de.uka.ilkd.key.proof.UseInsteadMap;
    import de.uka.ilkd.key.proof.RuleSource;
    import de.uka.ilkd.key.gui.AbbrevMap;
    

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class GlobalDeclarationTermParser extends antlr.LLkParser       implements GlobalDeclarationTermParserTokenTypes
 {

    static final Sort[] AN_ARRAY_OF_SORTS = new Sort[0];
    static final Term[] AN_ARRAY_OF_TERMS = new Term[0];
    
    protected NamespaceSet nss;

    protected Choice defaultChoice = null; 
    protected HashMap category2Default = new HashMap();
    protected boolean parse_includes = false;
    protected Includes includes = new Includes();
    protected boolean onlyWith=false;
    protected SetOfChoice activatedChoices = SetAsListOfChoice.EMPTY_SET;
    protected HashSet usedChoiceCategories = new HashSet();

    protected AbbrevMap scm = new AbbrevMap();
	private Prioritization.StaticPrioritization heur_prioritization
		= new Prioritization.StaticPrioritization ();

    // these variables are set if a file is read in step by
    // step. This used when reading in LDTs because of cyclic
    // dependencies.
    protected boolean skip_functions;
    protected boolean skip_predicates;
    protected boolean skip_sorts;
    protected boolean skip_schemavariables;
    protected boolean skip_heuristics;
    protected UseInsteadMap useInstead=new UseInsteadMap();

    private boolean schemaMode;

    protected JavaReader javaReader;
    protected TermFactory tf;
    private Services services = new Services();

    /** collects errors and warnings that occured during parsing */
    protected ErrorHandler errHandler = new ErrorHandler();

    public boolean errors = false;



    public GlobalDeclarationTermParser(TokenStream lexer,
				       TermFactory tf,
		  		       JavaReader jr,
				       NamespaceSet nss,
                       Choice defaultChoice) {
	this(lexer,2);
	this.tf = tf;
	this.javaReader = jr;
	this.nss     = nss;
	switchToNormalMode();
    this.defaultChoice = defaultChoice;
    }

    public GlobalDeclarationTermParser(TokenStream lexer,
				       TermFactory tf,
		  		       Services services,
				       NamespaceSet nss,
                       Choice defaultChoice) {
	this(lexer, tf, 
		new Recoder2KeY(new KeYCrossReferenceServiceConfiguration(), 
				services.getJavaInfo().rec2key(), new NamespaceSet(), 
				services.getTypeConverter()),
   	        nss, defaultChoice);	
    }

    public GlobalDeclarationTermParser(TokenStream lexer,
				       Services services,
				       NamespaceSet nss) {
	this(lexer, TermFactory.DEFAULT,
	     new Recoder2KeY(new KeYCrossReferenceServiceConfiguration(), 
		 services.getJavaInfo().rec2key(), new NamespaceSet(), services.getTypeConverter()),
	        nss,new Choice(new Name("Default")));
    }
    
    protected boolean isPackage(String name){
        try {
            return getJavaInfo().isPackage(name);
        } catch(RuntimeException e){	    
	    // may be thrown in cases of invalid java identifiers
            return false;
        } 
    }

    private void switchToNormalMode() {
        schemaMode   = false;
    }

    private boolean inSchemaMode() {
	return schemaMode;
    }

    private void switchToSchemaMode() {
        schemaMode   = true;
    }

    public NamespaceSet namespaces(){
    return nss;
    }

    public Namespace sorts() {
	return nss.sorts();
    }

    public Namespace variables() {
	return nss.variables();
    }

    public Namespace functions() {
	return nss.functions();
    }

    public Namespace programVariables() {
        return nss.programVariables();
    }

    public Namespace heuristics() {
	return nss.heuristics();
    }

    public Namespace choices() {
	return nss.choices();
    }

    public Named lookup(Name n) {
	final Namespace[] lookups = {
		functions(), variables(), 
		programVariables()
	};

	for (int i = 0; i<lookups.length; i++) {
	    if (lookups[i].lookup(n) != null) {
		return lookups[i].lookup(n);
            }
	}
	return null;	
    }


    protected KeYJavaType getTypeByClassName(String s){
        KeYJavaType kjt = null;
        try {
            kjt = getJavaInfo().getTypeByClassName(s);
        } catch(RuntimeException e){
            return null;
        } 
        return kjt;
    }


    protected int getLine() {
	int line = -1;
	try {
	    line = LT(0).getLine();
	} 
	catch (TokenStreamException e) {
	    System.err.println("No further token in stream");
	}
	return line;
    }   

    protected int getColumn() {
	int col = -1;
	try {
	    col = LT(0).getColumn();
	} 
	catch (TokenStreamException e) {
	    System.err.println("No further token in stream");
	}
	return col;
    }   

    // These three methods are required because the unused productions
    // from terms.g are inherited.  They should not be called.
    protected LogicVariable bindVar(Token id,Sort s) {
	throw new RuntimeException("bindVar was called in " +
				   "GlobalDeclarationTermParser.");
    }
	
    protected ProgramVariable progVar(Token id,Sort s) {
	variables().lookup(new Name(id.getText()));
	ProgramVariable v = (ProgramVariable)(ProgramVariable)
	    variables().lookup(new Name(id.getText()));
	if (v == null) {
	    v = new ProgramVariable(new ProgramElementName(id.getText()), s);
	    nss.setVariables(variables().extended(v));
	}
	return v;
    }

    protected void unbindVars() {
	throw new RuntimeException("unbindVars was called in " +
				   "GlobalDeclarationTermParser.");
    }


    protected static HashSet progVars(JavaBlock jb) {
	ProgramVariableCollector pvc
	    = new ProgramVariableCollector(jb.program());
	pvc.start();
	return pvc.result();
    }


    protected void bindProgVars(HashSet progVars) {
	nss.setVariables(new Namespace(variables()));
	Iterator it=progVars.iterator();
	while (it.hasNext()) {
	    variables().add((ProgramVariable)it.next());
	}
    }

    protected void unbindProgVars() {
	nss.setVariables(variables().parent());
    }


    protected Term termForParsedVariable(ParsableVariable v) 
	throws antlr.SemanticException 
	{
	    if ( v instanceof LogicVariable ) {
		return tf.createVariableTerm((LogicVariable)v);
	    } else if ( v instanceof ProgramVariable ) {
		return tf.createVariableTerm((ProgramVariable)v);
	    } else {
		throw new antlr.SemanticException(
						  ""+ v +" is not a logic variable");
	    }
	}

    protected void addInclude(String filename, boolean relativePath, boolean ldt){
        InputStream input=null;
        RuleSource source=null;
        if(relativePath){
            int end = getFilename().lastIndexOf(File.separator);
            int start = 0;
            filename = filename.replace('/', File.separatorChar);
            filename = filename.replace('\\', File.separatorChar);
            if(getFilename().startsWith("file:")){
                start = 5;
            }
            File path=new File(getFilename().substring(start,end+1)+filename);
            try{ 
                source = RuleSource.initRuleFile(path.toURL()); 
            }catch(java.net.MalformedURLException e){
                System.err.println("Exception due to malformed URL of file "+
                   filename+"\n " +e);
            }
        }else{
            source = RuleSource.initRuleFile(filename+".key"); 
        }
        if(ldt){
            includes.putLDT(filename, source);
        }else{
            includes.put(filename, source);
        }
    }  

    public Term createAttributeTerm(Term prefix, 
				    TermSymbol attribute,
				    int shadowPrimes) {
	Term result = prefix;
	if (((ProgramVariable)attribute).isStatic()){
	    result = tf.createVariableTerm((ProgramVariable)attribute);
	} else {
	    if (shadowPrimes > 0) {
		Term shadownum = TermParser.toZNotation("" + shadowPrimes, functions(), tf);
		result = tf.createShadowAttributeTerm((ProgramVariable)attribute, 
						      result, shadownum);
	    } else {
		result = tf.createAttributeTerm((ProgramVariable)attribute, result);
	    }
	}	
	return result;
    }

    public TermSymbol getAttribute(Sort prefixSort, 
				   String attributeName) 
	throws antlr.SemanticException {
	    final JavaInfo javaInfo = getJavaInfo();
	    TermSymbol v = null;
            if (!inSchemaMode()) {
		if (attributeName.indexOf(':') != -1) {
		   v = javaInfo.getAttribute(attributeName, 
			javaInfo.getKeYJavaType(attributeName.substring(0, attributeName.indexOf(':'))));
	        } else {
		    v = javaInfo.getAttribute(attributeName, (ObjectSort)prefixSort);
                }
            } else {
                v = (SortedSchemaVariable)variables().lookup(new Name(attributeName));
            }
            if ( v == null && !"length".equals(attributeName) ) {
                throw new NotDeclException
                    ("Attribute ", attributeName, getFilename(), 
                     getLine(), getColumn());

            }

	return v;
    }

    protected JavaBlock getJavaBlock(Token t) {
	return javaReader.readBlockWithEmptyContext(t.getText());
    }

    /** returns the java information object */
    public JavaInfo getJavaInfo() {
	return null;
//	return javaReader.createJavaInfo(new Services());
    }

	public Services getServices() {
	    return services;
    	}
	
       
       public void schema_var_decl(String name,Sort s,
                                    boolean makeVariableSV,
                                    boolean makeDependingSV,
                                    boolean rigid,
                                    boolean listModifier)
	{
              if (!skip_schemavariables) {
                  SchemaVariable v;
                  if ( s == Sort.FORMULA ) {
                      v = SchemaVariableFactory.createFormulaSV
                          (new Name(name), listModifier, rigid);
                      } else if ( s instanceof ProgramSVSort ) {
                          v = SchemaVariableFactory.createProgramSV
                         (new ProgramElementName(name),(ProgramSVSort) s, listModifier);
                      } else {
                        if ( makeVariableSV ) {
                             v=SchemaVariableFactory.createVariableSV
                             (new Name(name), s, listModifier);
                        } else if ( makeDependingSV ) {
                               v = SchemaVariableFactory.createDependingSV
                             (new Name(name), s, listModifier);
                        } else { v = SchemaVariableFactory.createTermSV
                              (new Name(name), s, listModifier, rigid);
                        }
                     }
                     if (inSchemaMode()) {
                         variables().add(v);
                     }
               }

         }

    /** looks up a function, (program) variable or static query of the 
     * given name varfunc_id and the argument terms args in the namespaces 
     * and java info. 
     * @param args is null iff no argument list is given, for instance `f', 
     * and is an array of size zero, if an empty argument list was given,
     * for instance `f()'.
     */
    protected Operator lookupVarfuncId(String varfunc_name, Term[] args) 
                                                    throws NotDeclException{
        // case 1: variable
        Operator v = (TermSymbol) variables().lookup(new Name(varfunc_name));
        if (v != null && args==null) {
            return v;
        }
        // case 2: function
        v = (Function) functions().lookup(new Name(varfunc_name));
        if (v != null) { // we allow both args==null (e.g. `c')
                         // and args.length=0 (e.g. 'c())' here 
            return v;
        }
        // case 3: static query
        if (varfunc_name.lastIndexOf("::")>0 && args!=null) {
            String classname = varfunc_name.substring
            (0, varfunc_name.lastIndexOf("::"));
            varfunc_name = varfunc_name.substring
            (varfunc_name.lastIndexOf("::")+2);
            v = getServices().getJavaInfo().getProgramMethodTerm
                (null, varfunc_name, args, classname).op();
            if (v != null) {
                return v;
            }
        }
        // case 4: program variable
        v = (ProgramVariable) programVariables().lookup
            (new ProgramElementName(varfunc_name));
        if (v != null && args==null) {
            return v;
        }
        if (args==null) {
            throw new NotDeclException
            ("(program) variable or constant", varfunc_name,
                getFilename(), getLine(), getColumn());
        } else {
            throw new NotDeclException
            ("function or static query", varfunc_name,
                getFilename(), getLine(), getColumn());
        }
    }


protected GlobalDeclarationTermParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public GlobalDeclarationTermParser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected GlobalDeclarationTermParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public GlobalDeclarationTermParser(TokenStream lexer) {
  this(lexer,1);
}

public GlobalDeclarationTermParser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final void top() throws RecognitionException, TokenStreamException {
		
		Term t;
		
		try {      // for error handling
			t=formula();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
	}
	
	public final Term  formula() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		try {      // for error handling
			a=term();
			if ( inputState.guessing==0 ) {
				
				if ( a.sort() != Sort.FORMULA ) {
				throw new antlr.SemanticException
				("Just Parsed a Term where a Formula was expected");
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  bindingterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		try {      // for error handling
			a=global_bindingterm();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  global_bindingterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
			Operator op = null;
			ParsableVariable v0, v1;
			LogicVariable v = null;
			ProgramVariable pv = null;
			Term a1,a2;
			boolean waryAll = false;
			boolean waryEx = false;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case FORALL:
			case EXISTS:
			{
				{
				switch ( LA(1)) {
				case FORALL:
				{
					match(FORALL);
					if ( inputState.guessing==0 ) {
						op = Op.ALL;
					}
					break;
				}
				case EXISTS:
				{
					match(EXISTS);
					if ( inputState.guessing==0 ) {
						op = Op.EX;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				v0=varId();
				match(DOT);
				if ( inputState.guessing==0 ) {
					v = (LogicVariable) v0;
				}
				a1=term60();
				if ( inputState.guessing==0 ) {
					
								a = tf.createQuantifierTerm((Quantifier)op, v,a1);
							
				}
				break;
			}
			case LBRACE:
			{
				match(LBRACE);
				v1=varId();
				{
				switch ( LA(1)) {
				case FORALL:
				case EXISTS:
				case TRUE:
				case FALSE:
				case NOT:
				case IN_TYPE:
				case IS_OBJECT:
				case LPAREN:
				case LBRACE:
				case AT:
				case CTRL:
				case ARITH_OP:
				case CHAR_LITERAL:
				case DIAMOND:
				case BOX:
				case THROUGHOUT:
				case PIDENT:
				case IDENT:
				{
					a1=term();
					{
					switch ( LA(1)) {
					case WARY_ALL:
					{
						match(WARY_ALL);
						if ( inputState.guessing==0 ) {
							waryAll = true;
						}
						break;
					}
					case WARY_EX:
					{
						match(WARY_EX);
						if ( inputState.guessing==0 ) {
							waryEx  = true;
						}
						break;
					}
					case RBRACE:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					match(RBRACE);
					if ( inputState.guessing==0 ) {
						v = (LogicVariable) v1;
					}
					a2=term60();
					if ( inputState.guessing==0 ) {
						
								    if ( waryAll )
								        a = tf.createSubstitutionTerm ( Op.WARY_SUBST_ALL,
								                                        v, a1, a2 );
								    else if ( waryEx )
								        a = tf.createSubstitutionTerm ( Op.WARY_SUBST_EX,
								                                        v, a1, a2 );
								    else
								        a = tf.createSubstitutionTerm ( Op.SUBST,
								                                        v, a1, a2 );
								
					}
					break;
				}
				case ASSIGN:
				{
					match(ASSIGN);
					a1=term();
					match(RBRACE);
					if ( inputState.guessing==0 ) {
						pv = (ProgramVariable) v1;
					}
					a2=term60();
					if ( inputState.guessing==0 ) {
						
								    a = tf.createUpdateTerm ( new Term[] { tf.createVariableTerm ( pv ),
								                                           a1, a2 } );
								
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final ParsableVariable  varId() throws RecognitionException, TokenStreamException {
		ParsableVariable v = null;
		
		Token  id = null;
		
		try {      // for error handling
			id = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				
				v = (ParsableVariable) variables().lookup(new Name(id.getText()));
				if (v == null) {
				throw new NotDeclException("variable", id, 
				getFilename());
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		return v;
	}
	
	public final Term  term60() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		Term a1,a2;
		Sort s;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case NOT:
			{
				match(NOT);
				a1=term60();
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.NOT,new Term[]{a1});
				}
				break;
			}
			case CTRL:
			{
				match(CTRL);
				a1=term60();
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.CTRL,new Term[]{a1});
				}
				break;
			}
			case FORALL:
			case EXISTS:
			case LBRACE:
			{
				a=bindingterm();
				break;
			}
			case TRUE:
			case FALSE:
			case IN_TYPE:
			case IS_OBJECT:
			case LPAREN:
			case AT:
			case ARITH_OP:
			case CHAR_LITERAL:
			case DIAMOND:
			case BOX:
			case THROUGHOUT:
			case PIDENT:
			case IDENT:
			{
				a=dlTermOrTerm70();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  term() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		try {      // for error handling
			a=term20();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_3);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  term20() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		Term a1;
		
		
		try {      // for error handling
			a=term30();
			{
			switch ( LA(1)) {
			case EQV:
			{
				match(EQV);
				a1=term20();
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.EQV, new Term[]{a, a1});
				}
				break;
			}
			case EOF:
			case WARY_ALL:
			case WARY_EX:
			case COMMA:
			case RPAREN:
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_3);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  term30() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		Term a1;
		
		
		try {      // for error handling
			a=term40();
			{
			switch ( LA(1)) {
			case IMP:
			{
				match(IMP);
				a1=term30();
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.IMP, new Term[]{a, a1});
				}
				break;
			}
			case EOF:
			case WARY_ALL:
			case WARY_EX:
			case COMMA:
			case RPAREN:
			case RBRACE:
			case EQV:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_4);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  term40() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		Term a1;
		
		
		try {      // for error handling
			a=term50();
			{
			switch ( LA(1)) {
			case OR:
			{
				match(OR);
				a1=term40();
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.OR, new Term[]{a, a1});
				}
				break;
			}
			case EOF:
			case WARY_ALL:
			case WARY_EX:
			case COMMA:
			case RPAREN:
			case RBRACE:
			case IMP:
			case EQV:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  term50() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		Term a1;
		
		
		try {      // for error handling
			a=term60();
			{
			switch ( LA(1)) {
			case AND:
			{
				match(AND);
				a1=term50();
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.AND, new Term[]{a, a1});
				}
				break;
			}
			case EOF:
			case WARY_ALL:
			case WARY_EX:
			case COMMA:
			case RPAREN:
			case RBRACE:
			case OR:
			case IMP:
			case EQV:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_6);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  dlTermOrTerm70() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		try {      // for error handling
			if (((LA(1) >= DIAMOND && LA(1) <= THROUGHOUT))) {
				a=normal_dl_term();
			}
			else {
				boolean synPredMatched20 = false;
				if (((LA(1)==IDENT))) {
					int _m20 = mark();
					synPredMatched20 = true;
					inputState.guessing++;
					try {
						{
						match(IDENT);
						match(MODALITYARG);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched20 = false;
					}
					rewind(_m20);
					inputState.guessing--;
				}
				if ( synPredMatched20 ) {
					a=named_dl_term();
				}
				else if ((_tokenSet_7.member(LA(1)))) {
					a=term70();
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					consume();
					consumeUntil(_tokenSet_1);
				} else {
				  throw ex;
				}
			}
			return a;
		}
		
	public final Term  normal_dl_term() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Token  d1 = null;
		Token  d2 = null;
		Token  d3 = null;
		JavaBlock jb=null;
		Term a1;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case DIAMOND:
			{
				d1 = LT(1);
				match(DIAMOND);
				if ( inputState.guessing==0 ) {
					
					jb=getJavaBlock(d1);
					HashSet progVars=progVars(jb);
					bindProgVars(progVars);
					
				}
				a1=term60();
				if ( inputState.guessing==0 ) {
					
					a = tf.createDiamondTerm(jb, a1);
					unbindProgVars();
					
				}
				break;
			}
			case BOX:
			{
				d2 = LT(1);
				match(BOX);
				if ( inputState.guessing==0 ) {
					
					jb=getJavaBlock(d2);
					HashSet progVars=progVars(jb);
					bindProgVars(progVars);
					
				}
				a1=term60();
				if ( inputState.guessing==0 ) {
					
					a = tf.createBoxTerm(jb, a1);
					unbindProgVars();
					
				}
				break;
			}
			case THROUGHOUT:
			{
				d3 = LT(1);
				match(THROUGHOUT);
				if ( inputState.guessing==0 ) {
					
					jb=getJavaBlock(d3);
					HashSet progVars=progVars(jb);
					bindProgVars(progVars);
					
				}
				a1=term60();
				if ( inputState.guessing==0 ) {
					
					a = tf.createProgramTerm(Op.TOUT,jb, a1);
					unbindProgVars();
					
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  named_dl_term() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Token  id = null;
		Token  bl = null;
		
		TermWithBoundVars[] argsWithBoundVars = new TermWithBoundVars[0];
		Term[] terms = null;
		Term term = null;
		JavaBlock jb = null;
		
		
		try {      // for error handling
			id = LT(1);
			match(IDENT);
			bl = LT(1);
			match(MODALITYARG);
			{
			if ( inputState.guessing==0 ) {
				
				jb = getJavaBlock(bl);               
				bindProgVars(progVars(jb));
				
			}
			argsWithBoundVars=argument_list();
			if ( inputState.guessing==0 ) {
				
				unbindProgVars();
				terms = new Term[argsWithBoundVars.length];
				for (int i=0; i<argsWithBoundVars.length; i++) {
				terms[i] = argsWithBoundVars[i].term;
				}
				Operator op = null;
				if (id.getText().charAt(0)=='#') {
				if (!inSchemaMode()) {
				throw new KeYSemanticException
				("No schema elements allowed outside taclet declarations.",
				id, getFilename());
				}
				op = (SchemaVariable)variables().lookup(new Name(id.getText()));
				} else {
				op = Op.getModality(id.getText());
				}
				if(op == null) {
				throw new KeYSemanticException("Unknown modal operator.", id, getFilename());
				}
				if(op.arity() != terms.length) {
				throw new KeYSemanticException
				("The arity of " + op.name() +
				" is "+op.arity() + ", but you provided " + terms.length + " arguments",
				getLine(), getColumn(), getFilename());
				}
				a = tf.createProgramTerm(op, jb, terms);
				
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  term70() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		Term a1;
		
		
		try {      // for error handling
			a=accessterm();
			{
			boolean synPredMatched24 = false;
			if (((LA(1)==EQUALS))) {
				int _m24 = mark();
				synPredMatched24 = true;
				inputState.guessing++;
				try {
					{
					match(EQUALS);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched24 = false;
				}
				rewind(_m24);
				inputState.guessing--;
			}
			if ( synPredMatched24 ) {
				match(EQUALS);
				a1=logicTermReEntry();
				if ( inputState.guessing==0 ) {
					a = tf.createEqualityTerm(a, a1);
				}
			}
			else if ((_tokenSet_1.member(LA(1)))) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  accessterm() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		Token  neg = null;
		Token  rb = null;
		
		KeYJavaType kjt = null;
		Sort arraySort = null;
		Term indexTerm = null;
		int shadowPrimes = 0;
		String className = null;
		
		
		try {      // for error handling
			boolean synPredMatched42 = false;
			if (((LA(1)==LPAREN))) {
				int _m42 = mark();
				synPredMatched42 = true;
				inputState.guessing++;
				try {
					{
					match(LPAREN);
					logicTermReEntry();
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						break;
					}
					case GUARD:
					{
						match(GUARD);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
				}
				catch (RecognitionException pe) {
					synPredMatched42 = false;
				}
				rewind(_m42);
				inputState.guessing--;
			}
			if ( synPredMatched42 ) {
				result=conditional();
			}
			else if (((LA(1)==ARITH_OP))&&("-".equals(LT(1).getText()) && 
	!TermParser.isNumber(LT(2).getText()))) {
				neg = LT(1);
				match(ARITH_OP);
				result=logicTermReEntry();
				if ( inputState.guessing==0 ) {
					
					if (result.sort() != Sort.FORMULA) {
					result = tf.createFunctionTerm
					((Function) functions().lookup(new Name("~m")), result);
					} else {
					throw new KeYSemanticException
					("Formula cannot be prefixed with: ", neg, getFilename());
					}
					
				}
			}
			else if ((_tokenSet_7.member(LA(1)))) {
				{
				if (((LA(1)==IDENT))&&(LA(2) == DOT && ( isPackage ( LT(1).getText() ) || 
                ( kjt = getTypeByClassName(LT(1).getText()))!=null ))) {
					className=classReference();
					result=static_attribute_suffix(className);
				}
				else if ((_tokenSet_7.member(LA(1)))) {
					result=term80();
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				{
				_loop46:
				do {
					switch ( LA(1)) {
					case LBRACKET:
					{
						match(LBRACKET);
						indexTerm=logicTermReEntry();
						{
						switch ( LA(1)) {
						case RBRACKET:
						{
							match(RBRACKET);
							break;
						}
						case RBRACKETPRIMES:
						{
							rb = LT(1);
							match(RBRACKETPRIMES);
							if ( inputState.guessing==0 ) {
								
								shadowPrimes = rb.getText().length()-1;                 
								
							}
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						if ( inputState.guessing==0 ) {
							
							if (arraySort != null && 
							arraySort != ProgramSVSort.VARIABLE) {
							if (!(arraySort instanceof ArraySort)){
							throw new NotDeclException
							("array "+result+" declared with a different"+
							" dimension than required here", ""+result, 
							getFilename(), getLine(), getColumn());
							} else {
							arraySort = ((ArraySort) arraySort).elementSort();
							} 
							} else if (arraySort == ProgramSVSort.VARIABLE && !inSchemaMode()) {
							throw new antlr.SemanticException
							("Schemavariable are not allowed in this context.");
							}
							if (shadowPrimes>0) {
							result = tf.createArrayTerm
							(Op.SHADOW_ARRAY, result, indexTerm, 
							TermParser.toZNotation("" + shadowPrimes, functions(), tf));
							} else {
							result = tf.createArrayTerm(Op.ARRAY, result, indexTerm);
							}   
							
						}
						break;
					}
					case DOT:
					{
						result=attribute_or_query_suffix(result);
						break;
					}
					default:
					{
						break _loop46;
					}
					}
				} while (true);
				}
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final Term  logicTermReEntry() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case TRUE:
			case FALSE:
			case IN_TYPE:
			case IS_OBJECT:
			case LPAREN:
			case AT:
			case ARITH_OP:
			case CHAR_LITERAL:
			case PIDENT:
			case IDENT:
			{
				result=accessterm();
				break;
			}
			case LBRACE:
			{
				result=update_or_substitution();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
				if (result.sort() == Sort.FORMULA) {
				throw 
				new KeYSemanticException
				("Only terms may stand here.", getLine(), getColumn(), 
				getFilename());
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final Term  update_or_substitution() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		
		
		try {      // for error handling
			boolean synPredMatched63 = false;
			if (((LA(1)==LBRACE))) {
				int _m63 = mark();
				synPredMatched63 = true;
				inputState.guessing++;
				try {
					{
					match(LBRACE);
					match(IDENT);
					match(COLON);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched63 = false;
				}
				rewind(_m63);
				inputState.guessing--;
			}
			if ( synPredMatched63 ) {
				result=substitutionterm();
			}
			else if ((LA(1)==LBRACE)) {
				result=updateterm();
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final String  classReference() throws RecognitionException, TokenStreamException {
		String classReference = "";
		
		Token  id = null;
		
		try {      // for error handling
			id = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				
				classReference = id.getText(); 
				while (isPackage(classReference)) {
				match(DOT);
				classReference += "." + LT(1).getText();
				match(IDENT);
				}      
				
				if (getJavaInfo().getTypeByClassName(classReference) == null) {
				throw new NotDeclException
				("class " + classReference + " is unknown.", 
				classReference, getFilename(), getLine(), 
				getColumn());
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		return classReference;
	}
	
	public final Term  static_attribute_suffix(
		String className
	) throws RecognitionException, TokenStreamException {
		Term result = null;
		
		Token  ps = null;
		
		TermSymbol v = null;
		int shadowPrimes = 0;    
		String attributeName = "";
		
		
		try {      // for error handling
			match(DOT);
			attributeName=attrid();
			if ( inputState.guessing==0 ) {
				v = getAttribute(getTypeByClassName(className).
				getSort(), attributeName);
			}
			{
			{
			switch ( LA(1)) {
			case PRIMES:
			{
				ps = LT(1);
				match(PRIMES);
				if ( inputState.guessing==0 ) {
					shadowPrimes = ps.getText().length();
				}
				break;
			}
			case EOF:
			case WARY_ALL:
			case WARY_EX:
			case COLON:
			case GUARD:
			case ASSIGN:
			case DOT:
			case COMMA:
			case RPAREN:
			case RBRACE:
			case LBRACKET:
			case RBRACKET:
			case OR:
			case AND:
			case IMP:
			case EQV:
			case EQUALS:
			case RBRACKETPRIMES:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
				result = createAttributeTerm(null, v, shadowPrimes);
				
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final String  attrid() throws RecognitionException, TokenStreamException {
		String attr = "";;
		
		Token  attrID = null;
		
		try {      // for error handling
			{
			if (((LA(1)==IDENT))&&( isPackage(LT(1).getText()) || (LA(2) == COLON && LA(3) == COLON) )) {
				attr=classReference();
				match(COLON);
				match(COLON);
				if ( inputState.guessing==0 ) {
					attr += "::";
				}
			}
			else if ((LA(1)==IDENT)) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			attrID = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				attr += attrID.getText();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		return attr;
	}
	
	public final Term  attribute_or_query_suffix(
		Term prefix
	) throws RecognitionException, TokenStreamException {
		Term result = null;
		
		Token  ps = null;
		
		TermSymbol v = null;
		int shadowPrimes = 0;
		result = prefix;
		String attributeName = "";    
		
		
		try {      // for error handling
			match(DOT);
			{
			boolean synPredMatched34 = false;
			if (((LA(1)==IDENT))) {
				int _m34 = mark();
				synPredMatched34 = true;
				inputState.guessing++;
				try {
					{
					id();
					match(LPAREN);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched34 = false;
				}
				rewind(_m34);
				inputState.guessing--;
			}
			if ( synPredMatched34 ) {
				{
				result=query(prefix);
				}
			}
			else if ((LA(1)==IDENT)) {
				attributeName=attrid();
				if ( inputState.guessing==0 ) {
					v = getAttribute(prefix.sort(), attributeName);
				}
				{
				{
				switch ( LA(1)) {
				case PRIMES:
				{
					ps = LT(1);
					match(PRIMES);
					if ( inputState.guessing==0 ) {
						shadowPrimes = ps.getText().length();
					}
					break;
				}
				case EOF:
				case WARY_ALL:
				case WARY_EX:
				case COLON:
				case GUARD:
				case ASSIGN:
				case DOT:
				case COMMA:
				case RPAREN:
				case RBRACE:
				case LBRACKET:
				case RBRACKET:
				case OR:
				case AND:
				case IMP:
				case EQV:
				case EQUALS:
				case RBRACKETPRIMES:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				if ( inputState.guessing==0 ) {
					
					result = createAttributeTerm(prefix, v, shadowPrimes);
					
				}
				}
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final String  id() throws RecognitionException, TokenStreamException {
		String name = null;
		
		Token  prefix = null;
		Token  pprefix = null;
		Token  nameID = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case IDENT:
			{
				prefix = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					name = prefix.getText();
				}
				break;
			}
			case PIDENT:
			{
				pprefix = LT(1);
				match(PIDENT);
				if ( inputState.guessing==0 ) {
					name = pprefix.getText();
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			boolean synPredMatched204 = false;
			if (((LA(1)==COLON))) {
				int _m204 = mark();
				synPredMatched204 = true;
				inputState.guessing++;
				try {
					{
					match(COLON);
					match(COLON);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched204 = false;
				}
				rewind(_m204);
				inputState.guessing--;
			}
			if ( synPredMatched204 ) {
				match(COLON);
				match(COLON);
				nameID = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					
					name += "::" + nameID.getText();
					
				}
			}
			else if ((_tokenSet_11.member(LA(1)))) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		return name;
	}
	
	public final Term  query(
		Term prefix
	) throws RecognitionException, TokenStreamException {
		Term result = null;
		
		Token  mid = null;
		
		String classRef = "";
		Term[] args;
		TermWithBoundVars[] argsWithBoundVars = new TermWithBoundVars[0];
		
		
		try {      // for error handling
			classRef=classReference();
			match(COLON);
			match(COLON);
			mid = LT(1);
			match(IDENT);
			argsWithBoundVars=argument_list();
			if ( inputState.guessing==0 ) {
				
				args = new Term[argsWithBoundVars.length];
				for (int i=0; i<argsWithBoundVars.length; i++) {
				args[i] = argsWithBoundVars[i].term;
				}
				try {
				result = getServices().getJavaInfo().getProgramMethodTerm
				(prefix, mid.getText(), args, classRef);
				} catch (IllegalArgumentException e) {
				throw new antlr.SemanticException(e.getMessage());
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final TermWithBoundVars[]  argument_list() throws RecognitionException, TokenStreamException {
		TermWithBoundVars[] ts = null;
		
		
		List args = new LinkedList();
		TermWithBoundVars p1, p2;
		
		
		try {      // for error handling
			match(LPAREN);
			{
			switch ( LA(1)) {
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case IN_TYPE:
			case IS_OBJECT:
			case SLASH:
			case BACKSLASH:
			case LPAREN:
			case LBRACE:
			case AT:
			case CTRL:
			case ARITH_OP:
			case CHAR_LITERAL:
			case DIAMOND:
			case BOX:
			case THROUGHOUT:
			case PIDENT:
			case IDENT:
			{
				p1=argument();
				if ( inputState.guessing==0 ) {
					args.add(p1);
				}
				{
				_loop80:
				do {
					if ((LA(1)==COMMA)) {
						match(COMMA);
						p2=argument();
						if ( inputState.guessing==0 ) {
							args.add(p2);
						}
					}
					else {
						break _loop80;
					}
					
				} while (true);
				}
				break;
			}
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
				ts = (TermWithBoundVars[]) args.toArray(new TermWithBoundVars[args.size()]);
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return ts;
	}
	
	public final Term  conditional() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		Term comparator = null;
		
		
		try {      // for error handling
			match(LPAREN);
			comparator=logicTermReEntry();
			{
			switch ( LA(1)) {
			case GUARD:
			{
				result=normalConditional(comparator);
				break;
			}
			case COMMA:
			{
				result=conjunctionConditional(comparator);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final Term  term80() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case AT:
			case ARITH_OP:
			case CHAR_LITERAL:
			case PIDENT:
			case IDENT:
			{
				a=funcpredvarterm();
				break;
			}
			case IN_TYPE:
			case IS_OBJECT:
			{
				a=specialTerm();
				break;
			}
			case LPAREN:
			{
				match(LPAREN);
				a=term();
				match(RPAREN);
				break;
			}
			case TRUE:
			{
				match(TRUE);
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.TRUE);
				}
				break;
			}
			case FALSE:
			{
				match(FALSE);
				if ( inputState.guessing==0 ) {
					a = tf.createJunctorTerm(Op.FALSE);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  funcpredvarterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Token  ch = null;
		Token  number = null;
		
		Term[] arguments = null;
		TermWithBoundVars[] argsWithBoundVars = null;
		String varfuncid;
		String neg = "";
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case CHAR_LITERAL:
			{
				ch = LT(1);
				match(CHAR_LITERAL);
				if ( inputState.guessing==0 ) {
					
					String s = ch.getText();
					int intVal = 0;
					if (s.length()==3) {
					intVal = (int)s.charAt(1);
					} else {
					try {
					intVal = Integer.parseInt(s.substring(3,s.length()-1),16);
					} catch (NumberFormatException ex) {
					throw new KeYSemanticException
					("Expected '"+s+"' to be a character", ch, getFilename());
					}       
					}
					a = tf.createFunctionTerm((Function) functions().lookup(new Name("C")), 
					TermParser.toZNotation(""+intVal, functions(), tf).sub(0));
					
				}
				break;
			}
			case AT:
			{
				match(AT);
				a=abbreviation();
				break;
			}
			default:
				if (((LA(1)==ARITH_OP||LA(1)==IDENT))&&( ("-".equals(LT(1).getText()) && TermParser.isNumber(LT(2).getText())) 
	|| 
        (TermParser.isNumber(LT(1).getText()) && !"(".equals(LT(2).getText())))) {
					{
					if (((LA(1)==ARITH_OP))&&("-".equals(LT(1).getText()))) {
						match(ARITH_OP);
						if ( inputState.guessing==0 ) {
							neg = "-";
						}
					}
					else if ((LA(1)==IDENT)) {
					}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					
					}
					number = LT(1);
					match(IDENT);
					if ( inputState.guessing==0 ) {
						a = TermParser.toZNotation(neg+number.getText(), functions(), tf);
					}
				}
				else if ((LA(1)==PIDENT||LA(1)==IDENT)) {
					varfuncid=id();
					{
					switch ( LA(1)) {
					case LPAREN:
					{
						argsWithBoundVars=argument_list();
						break;
					}
					case EOF:
					case WARY_ALL:
					case WARY_EX:
					case COLON:
					case GUARD:
					case ASSIGN:
					case DOT:
					case COMMA:
					case RPAREN:
					case RBRACE:
					case LBRACKET:
					case RBRACKET:
					case OR:
					case AND:
					case IMP:
					case EQV:
					case EQUALS:
					case RBRACKETPRIMES:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					if ( inputState.guessing==0 ) {
						
						ArrayOfQuantifiableVariable vars = null;
						if (argsWithBoundVars != null) {
						arguments = new Term[argsWithBoundVars.length];           
						for (int i=0; i<argsWithBoundVars.length; i++) {
						arguments[i] = argsWithBoundVars[i].term;
						
						//For OCL simplification
						if (argsWithBoundVars[i].boundVars != null) {
						if ((i == 1 && argsWithBoundVars[i].boundVars.size() == 1)
						|| (i == 2 && argsWithBoundVars[i].boundVars.size() == 2)) {
						vars = argsWithBoundVars[i].boundVars;
						} else {
						throw new antlr.SemanticException("Parsing error: The " + varfuncid + 
						" expression does not match any OCL collection operation!");
						}
						}
						//
						}
						}
						Operator op = lookupVarfuncId(varfuncid, arguments);
						if (op instanceof ParsableVariable) {
						a = termForParsedVariable((ParsableVariable)op);
						} else  if (op instanceof TermSymbol) {
						if (arguments==null) {
						arguments = AN_ARRAY_OF_TERMS;
						}
						if (vars == null) {
						a = tf.createFunctionTerm((TermSymbol)op, arguments);
						}
						
						//For OCL simplification
						else {
						if (vars.size() == 2) {
						a = tf.createTernaryBindingTerm(
						(TermSymbol)op, 
						vars.getQuantifiableVariable(0), 
						vars.getQuantifiableVariable(1), 
						arguments);
						} else {
						a = tf.createBinaryBindingTerm(
						(TermSymbol)op, 
						vars.getQuantifiableVariable(0),  
						arguments);
						}
						} 
						//
						}
						
					}
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  specialTerm() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		Operator vf = null;
		
		
		try {      // for error handling
			vf=expr_op();
			if ( inputState.guessing==0 ) {
				
				result = tf.createFunctionTerm((Function)vf, AN_ARRAY_OF_TERMS);
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final Term  abbreviation() throws RecognitionException, TokenStreamException {
		Term a=null;
		
		
		String sc = null;
		
		
		try {      // for error handling
			{
			sc=id();
			if ( inputState.guessing==0 ) {
				
				a =  scm.getTerm(sc);
				if(a==null){
				throw new NotDeclException
				("abbreviation", sc, 
				getFilename(), getLine(), getColumn());
				}                                
				
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  normalConditional(
		Term cond1
	) throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		Term cond2 = null;
		Term c_then = null;
		Term c_else = null;
		
		
		try {      // for error handling
			match(GUARD);
			cond2=logicTermReEntry();
			match(RPAREN);
			{
			switch ( LA(1)) {
			case DOT:
			{
				match(DOT);
				result=shortCond(cond1, cond2);
				break;
			}
			case TRUE:
			case FALSE:
			case IN_TYPE:
			case IS_OBJECT:
			case LPAREN:
			case LBRACE:
			case AT:
			case ARITH_OP:
			case CHAR_LITERAL:
			case PIDENT:
			case IDENT:
			{
				c_then=logicTermReEntry();
				match(COLON);
				c_else=logicTermReEntry();
				if ( inputState.guessing==0 ) {
					
					result = tf.createIfElseTerm(cond1, cond2, c_then, c_else);
					
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final Term  conjunctionConditional(
		Term cond1_1
	) throws RecognitionException, TokenStreamException {
		Term a = null;
		
		
		Term cond1_2 = null;
		Term cond2_1 = null;
		Term cond2_2 = null;
		Term c_then = null;
		Term c_else = null;
		
		
		try {      // for error handling
			match(COMMA);
			cond1_2=logicTermReEntry();
			match(COLON);
			c_else=logicTermReEntry();
			match(GUARD);
			cond2_1=logicTermReEntry();
			match(COMMA);
			cond2_2=logicTermReEntry();
			match(COLON);
			c_then=logicTermReEntry();
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
				a = tf.createConjCondTerm(new Term[]{cond1_1, cond1_2, c_else, 
				cond2_1, cond2_2, c_then});
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  shortCond(
		Term cond1, Term cond2
	) throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		ParsableVariable v=null;
		Term c_then = null;
		
		
		try {      // for error handling
			match(DOT);
			v=varId();
			match(CONDUP);
			c_then=logicTermReEntry();
			if ( inputState.guessing==0 ) {
				
				result = tf.createIfElseTerm((ProgramVariable)v, cond1, 
				cond2, c_then);
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final TermWithBoundVars  argument() throws RecognitionException, TokenStreamException {
		TermWithBoundVars p = null;
		
		Token  v0 = null;
		
		Sort s = null;
		List listVars = new LinkedList();
		LogicVariable v = null;
		LogicVariable[] arrayVars = null;
		ArrayOfQuantifiableVariable vars = null;
		Term a1;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case SLASH:
			case BACKSLASH:
			{
				{
				_loop58:
				do {
					if ((LA(1)==BACKSLASH)) {
						match(BACKSLASH);
						v0 = LT(1);
						match(IDENT);
						match(COLON);
						s=sortId();
						if ( inputState.guessing==0 ) {
							
							v = bindVar(v0, s); 
							listVars.add(v);
							
						}
					}
					else {
						break _loop58;
					}
					
				} while (true);
				}
				match(SLASH);
				a1=term();
				if ( inputState.guessing==0 ) {
					
					arrayVars = (LogicVariable[])listVars.toArray(new LogicVariable[listVars.size()]);
					vars = new ArrayOfQuantifiableVariable(arrayVars);
					p = new TermWithBoundVars(vars, a1);
					unbindVars();
					
				}
				break;
			}
			case FORALL:
			case EXISTS:
			case TRUE:
			case FALSE:
			case NOT:
			case IN_TYPE:
			case IS_OBJECT:
			case LPAREN:
			case LBRACE:
			case AT:
			case CTRL:
			case ARITH_OP:
			case CHAR_LITERAL:
			case DIAMOND:
			case BOX:
			case THROUGHOUT:
			case PIDENT:
			case IDENT:
			{
				a1=term();
				if ( inputState.guessing==0 ) {
					
					p = new TermWithBoundVars(vars, a1);
					
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_12);
			} else {
			  throw ex;
			}
		}
		return p;
	}
	
	public final Sort  sortId() throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		try {      // for error handling
			s=sortId_check(true);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_13);
			} else {
			  throw ex;
			}
		}
		return s;
	}
	
	public final Term  local_bindingterm() throws RecognitionException, TokenStreamException {
		Term a = null;
		
		Token  v0 = null;
		
		Operator op = null;
		LogicVariable v = null;
		Term a1;
		Sort s;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case FORALL:
			case EXISTS:
			{
				{
				switch ( LA(1)) {
				case FORALL:
				{
					match(FORALL);
					if ( inputState.guessing==0 ) {
						op = Op.ALL;
					}
					break;
				}
				case EXISTS:
				{
					match(EXISTS);
					if ( inputState.guessing==0 ) {
						op = Op.EX;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				v0 = LT(1);
				match(IDENT);
				match(COLON);
				s=sortId();
				match(DOT);
				if ( inputState.guessing==0 ) {
					v = bindVar(v0,s);
				}
				a1=term60();
				if ( inputState.guessing==0 ) {
					
					a = tf.createQuantifierTerm((Quantifier)op, v,a1);
					unbindVars();
					
				}
				break;
			}
			case LBRACE:
			{
				a=update_or_substitution();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		return a;
	}
	
	public final Term  substitutionterm() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		Token  v1 = null;
		Sort s;
		LogicVariable v = null;
		Term a1, a2;
		boolean waryAll = false;
		boolean waryEx = false;
		
		
		try {      // for error handling
			match(LBRACE);
			v1 = LT(1);
			match(IDENT);
			match(COLON);
			s=sortId();
			a1=logicTermReEntry();
			{
			switch ( LA(1)) {
			case WARY_ALL:
			{
				match(WARY_ALL);
				if ( inputState.guessing==0 ) {
					waryAll = true;
				}
				break;
			}
			case WARY_EX:
			{
				match(WARY_EX);
				if ( inputState.guessing==0 ) {
					waryEx  = true;
				}
				break;
			}
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RBRACE);
			if ( inputState.guessing==0 ) {
				v = bindVar(v1, s);
			}
			a2=term60();
			if ( inputState.guessing==0 ) {
				
				if ( waryAll )
				result = tf.createSubstitutionTerm ( Op.WARY_SUBST_ALL,
				v, a1, a2 );
				else if ( waryEx )
				result = tf.createSubstitutionTerm ( Op.WARY_SUBST_EX,
				v, a1, a2 );
				else
				result = tf.createSubstitutionTerm ( Op.SUBST,
				v, a1, a2 );
				unbindVars();
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final Term  updateterm() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		SingleUpdateData sud = null;
		List subs = new LinkedList();  
		Term a2 = null;
		
		
		try {      // for error handling
			match(LBRACE);
			sud=singleupdate();
			if ( inputState.guessing==0 ) {
				
				subs.add(sud.a0); 
				subs.add(sud.a1); 
				
			}
			{
			_loop68:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					sud=singleupdate();
					if ( inputState.guessing==0 ) {
						
						subs.add(sud.a0); 
						subs.add(sud.a1); 
						
					}
				}
				else {
					break _loop68;
				}
				
			} while (true);
			}
			match(RBRACE);
			a2=term60();
			if ( inputState.guessing==0 ) {
				
				subs.add(a2);
				
			}
			if ( inputState.guessing==0 ) {
				
				result = tf.createUpdateTerm((Term[])subs.toArray(new Term[subs.size()]));
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final SingleUpdateData  singleupdate() throws RecognitionException, TokenStreamException {
		SingleUpdateData sud=null;
		
		
		Term a0 = null;
		Term a1 = null;
		ArraySort as;
		TermSymbol pv;
		LhsUpdateData lud = null;
		boolean shadow_l = false;
		boolean shadow_r = false;
		
		
		try {      // for error handling
			{
			a0=lhsSingle();
			}
			match(ASSIGN);
			{
			a1=rhsSingle();
			}
			if ( inputState.guessing==0 ) {
				
				sud = new SingleUpdateData();
				sud.a0 = a0;
				sud.a1 = a1;
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_14);
			} else {
			  throw ex;
			}
		}
		return sud;
	}
	
	public final Term  lhsSingle() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		Term a1 = null;
		
		
		try {      // for error handling
			result=logicTermReEntry();
			if ( inputState.guessing==0 ) {
				
				if (!(result.sort() instanceof ProgramSVSort) &&
				result.op() != Op.META_SHADOW &&
				!(result.op() instanceof ProgramVariable || 
				result.op() instanceof AccessOp)) {
				throw new KeYSemanticException
				("Term of sort " + result.sort() + 
				" cannot stand for a location.",
				getLine(), getColumn(), getFilename());
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_15);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final Term  rhsSingle() throws RecognitionException, TokenStreamException {
		Term result = null;
		
		
		try {      // for error handling
			result=logicTermReEntry();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_14);
			} else {
			  throw ex;
			}
		}
		return result;
	}
	
	public final Operator  expr_op() throws RecognitionException, TokenStreamException {
		Operator v = null;
		
		Token  id = null;
		Token  id1 = null;
		Token  id2 = null;
		
		ParsableVariable left_var0 = null;
		ParsableVariable right_var0 = null;
		ParsableVariable unary_var0 = null;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case IN_TYPE:
			{
				match(IN_TYPE);
				match(LPAREN);
				{
				switch ( LA(1)) {
				case IDENT:
				{
					{
					left_var0=varId();
					{
					switch ( LA(1)) {
					case SLASH:
					case ARITH_OP:
					case IDENT:
					{
						{
						switch ( LA(1)) {
						case ARITH_OP:
						{
							id = LT(1);
							match(ARITH_OP);
							break;
						}
						case SLASH:
						{
							id1 = LT(1);
							match(SLASH);
							break;
						}
						case IDENT:
						{
							id2 = LT(1);
							match(IDENT);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						right_var0=varId();
						break;
					}
					case RPAREN:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
					break;
				}
				case 187:
				{
					{
					match(187);
					unary_var0=varId();
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(RPAREN);
				if ( inputState.guessing==0 ) {
					
					if (id==null) id=id1;   
					if (unary_var0!=null) {
					// can only be unary minus
					SortedSchemaVariable unary_var = (SortedSchemaVariable) unary_var0;
					Sort type = de.uka.ilkd.key.logic.sort.Sort.FORMULA;
					return new InTypeOperator
					(type, new de.uka.ilkd.key.java.expression.operator.Negative(unary_var));
					}
					else {
					SortedSchemaVariable left_var = (SortedSchemaVariable) left_var0;
					Sort type = de.uka.ilkd.key.logic.sort.Sort.FORMULA;
					if (right_var0 != null) {
					SortedSchemaVariable right_var = (SortedSchemaVariable) right_var0;
					String op_str = (id == null ? id2.getText() : id.getText());
					if ("+".equals(op_str)) {
					return new InTypeOperator
					(type, new de.uka.ilkd.key.java.expression.operator.Plus(left_var, right_var));
					} else if ("-".equals(op_str)) {
					return new InTypeOperator
					(type, new de.uka.ilkd.key.java.expression.operator.Minus(left_var, right_var));
					} else if ("*".equals(op_str)) {
					return new InTypeOperator
					(type, new de.uka.ilkd.key.java.expression.operator.Times(left_var, right_var));
					} else if ("/".equals(op_str)) {
					return new InTypeOperator
					(type, new de.uka.ilkd.key.java.expression.operator.Divide(left_var, right_var));
					} else if ("%".equals(op_str)) {
					return new InTypeOperator
					(type, new de.uka.ilkd.key.java.expression.operator.Modulo(left_var, right_var));
					} 
					}
					else {
					return new InTypeOperator(type, left_var);
					}
					}
					
				}
				break;
			}
			case IS_OBJECT:
			{
				match(IS_OBJECT);
				match(LPAREN);
				{
				left_var0=varId();
				}
				match(RPAREN);
				if ( inputState.guessing==0 ) {
					
					SortedSchemaVariable var = (SortedSchemaVariable) left_var0;
					return new IsObject(de.uka.ilkd.key.logic.sort.Sort.FORMULA, var);
					
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return v;
	}
	
	public final void decls() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			{
			_loop102:
			do {
				if ((LA(1)==INCLUDE)) {
					match(INCLUDE);
					{
					switch ( LA(1)) {
					case LDTS:
					{
						match(LDTS);
						match(COLON);
						match(LBRACE);
						include(true);
						{
						_loop101:
						do {
							if ((LA(1)==COMMA)) {
								match(COMMA);
								include(true);
							}
							else {
								break _loop101;
							}
							
						} while (true);
						}
						match(RBRACE);
						break;
					}
					case STRING_LITERAL:
					case IDENT:
					{
						include(false);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					match(SEMI);
				}
				else {
					break _loop102;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				
				if(parse_includes) return;
				activatedChoices = SetAsListOfChoice.EMPTY_SET;  
				
			}
			{
			switch ( LA(1)) {
			case WITH:
			{
				match(WITH);
				match(LPAREN);
				activated_choice();
				{
				_loop105:
				do {
					if ((LA(1)==COMMA)) {
						match(COMMA);
						activated_choice();
					}
					else {
						break _loop105;
					}
					
				} while (true);
				}
				match(RPAREN);
				break;
			}
			case EOF:
			case PROGRAM:
			case HEURISTICS:
			case SORTS:
			case OPTIONS:
			case SCHEMA:
			case PREDICATES:
			case FUNCTIONS:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				if(onlyWith) return;
			}
			{
			_loop107:
			do {
				switch ( LA(1)) {
				case OPTIONS:
				{
					option_decls();
					break;
				}
				case SORTS:
				{
					sort_decls();
					break;
				}
				case PROGRAM:
				{
					prog_var_decls();
					break;
				}
				case SCHEMA:
				{
					schema_var_decls();
					break;
				}
				case PREDICATES:
				{
					pred_decls();
					break;
				}
				case FUNCTIONS:
				{
					func_decls();
					break;
				}
				case HEURISTICS:
				{
					heur_decls();
					break;
				}
				default:
				{
					break _loop107;
				}
				}
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void include(
		boolean ldt
	) throws RecognitionException, TokenStreamException {
		
		Token  absfile = null;
		Token  relfile = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case IDENT:
			{
				absfile = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					
					if(parse_includes){
					addInclude(absfile.getText(),false,ldt);
					}
					
				}
				break;
			}
			case STRING_LITERAL:
			{
				relfile = LT(1);
				match(STRING_LITERAL);
				if ( inputState.guessing==0 ) {
					
					if(parse_includes){
					addInclude(relfile.getText(),true,ldt);
					}
					
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_16);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void activated_choice() throws RecognitionException, TokenStreamException {
		
		Token  cat = null;
		Token  choice = null;
		
		String name;
		Choice c;
		
		
		try {      // for error handling
			cat = LT(1);
			match(IDENT);
			match(COLON);
			choice = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				if(usedChoiceCategories.contains(cat.getText())){
				throw new IllegalArgumentException("You have already chosen a different option for "+cat.getText());
				}
				usedChoiceCategories.add(cat.getText());
				name = cat.getText()+":"+choice.getText();
				c = (Choice) choices().lookup(new Name(name));
				if(c==null){
				throw new NotDeclException("Option", choice,
				getFilename());
				}else{
				activatedChoices=activatedChoices.add(c);
				namespaces().setFunctions(functions().extended(c.funcNS().allElements()));
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_12);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void option_decls() throws RecognitionException, TokenStreamException {
		
		
		
		
		try {      // for error handling
			match(OPTIONS);
			match(LBRACE);
			choice();
			{
			_loop113:
			do {
				if ((LA(1)==SEMI)) {
					match(SEMI);
					choice();
				}
				else {
					break _loop113;
				}
				
			} while (true);
			}
			match(RBRACE);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_17);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void sort_decls() throws RecognitionException, TokenStreamException {
		
		
		boolean isObjectSort=false;
		boolean isGenericSort=false;
		
		//For OCL simplification
		boolean isOclSort = false;
		
		Sort[] sortExt=new Sort [0];
		Sort[] sortOneOf=new Sort [0];
		ListOfName sortIds;
		
		
		try {      // for error handling
			match(SORTS);
			match(LBRACE);
			{
			_loop124:
			do {
				if ((_tokenSet_18.member(LA(1)))) {
					if ( inputState.guessing==0 ) {
						
						isObjectSort=false; 
						isGenericSort=false; 
						isOclSort = false;
						sortExt = new Sort[0];
						sortOneOf = new Sort[0];
						
					}
					{
					switch ( LA(1)) {
					case OBJECT:
					{
						match(OBJECT);
						if ( inputState.guessing==0 ) {
							isObjectSort=true;
						}
						sortIds=sortIdentifiers();
						break;
					}
					case GENERIC:
					{
						match(GENERIC);
						if ( inputState.guessing==0 ) {
							isGenericSort=true;
						}
						sortIds=sortIdentifiers();
						{
						switch ( LA(1)) {
						case ONEOF:
						{
							match(ONEOF);
							sortOneOf=oneof_sorts();
							break;
						}
						case EXTENDS:
						case SEMI:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						{
						switch ( LA(1)) {
						case EXTENDS:
						{
							match(EXTENDS);
							sortExt=extends_sorts();
							break;
						}
						case SEMI:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						break;
					}
					case OCL:
					{
						match(OCL);
						if ( inputState.guessing==0 ) {
							isOclSort=true;
						}
						sortIds=sortIdentifiers();
						break;
					}
					case IDENT:
					{
						sortIds=sortIdentifiers();
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					match(SEMI);
					if ( inputState.guessing==0 ) {
						
						if (!skip_sorts) {
						Name sort_name;
						IteratorOfName it = sortIds.iterator ();
						while ( it.hasNext () ) {
						sort_name = it.next ();
						
						if (sorts().lookup(sort_name) == null) {
						Sort s;
						if (isObjectSort) {
						if ("Object".equals(sort_name)) {
						if (sorts().lookup(new Name("Object")) == null) {
						s = new ClassInstanceSortImpl(sort_name);
						}
						s=(Sort)sorts().lookup(new Name("Object"));
						} else {
						s = new ClassInstanceSortImpl(sort_name, 
						(Sort)sorts().lookup
						(new Name("Object")));
						}	
						}                            
						//Just constant for now
						else if (isOclSort) {
						s = Sort.OCL_ANY;
						}
						//
						else if (isGenericSort) {
						int        i;
						SetOfSort  ext   = SetAsListOfSort.EMPTY_SET;
						SetOfSort  oneOf = SetAsListOfSort.EMPTY_SET;
						
						for ( i = 0; i != sortExt.length; ++i )
						ext = ext.add ( sortExt[i] );
						
						for ( i = 0; i != sortOneOf.length; ++i )
						oneOf = oneOf.add ( sortOneOf[i] );
						
						try {
						s = new GenericSort ( sort_name,
						ext,
						oneOf );
						} catch ( GenericSupersortException e ) {
						throw new GenericSortException ( "sort",
						"Illegal sort given", e.getIllegalSort (),
						getFilename (), getLine (), getColumn () );
						}
						} else {
						s = new PrimitiveSort(sort_name);
						}
						sorts().add(s);
						if (s instanceof NonCollectionSort) {
						NonCollectionSort ns
						= (NonCollectionSort)s;
						sorts().add(ns.getSetSort());
						sorts().add(ns.getSequenceSort());
						sorts().add(ns.getBagSort());
						}
						if ( s instanceof SortDefiningSymbols )
						((SortDefiningSymbols)s).createSymbols ( defaultChoice.funcNS(),
						sorts() );
						}
						
						}
						}
						
					}
				}
				else {
					break _loop124;
				}
				
			} while (true);
			}
			match(RBRACE);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_17);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void prog_var_decls() throws RecognitionException, TokenStreamException {
		
		Token  v0 = null;
		Token  v1 = null;
		Token  pid = null;
		
		String var_name;
		String type = null;
		
		
		try {      // for error handling
			if ( inputState.guessing==0 ) {
				switchToNormalMode();
			}
			match(PROGRAM);
			match(VARIABLES);
			match(LBRACE);
			{
			_loop142:
			do {
				if ((LA(1)==PIDENT||LA(1)==IDENT)) {
					{
					switch ( LA(1)) {
					case IDENT:
					{
						{
						v0 = LT(1);
						match(IDENT);
						if ( inputState.guessing==0 ) {
							type= "" + v0.getText();
						}
						{
						_loop139:
						do {
							if ((LA(1)==DOT)) {
								match(DOT);
								v1 = LT(1);
								match(IDENT);
								if ( inputState.guessing==0 ) {
									type= type + "." + v1.getText();
								}
							}
							else {
								break _loop139;
							}
							
						} while (true);
						}
						}
						break;
					}
					case PIDENT:
					{
						{
						pid = LT(1);
						match(PIDENT);
						if ( inputState.guessing==0 ) {
							type = pid.getText();
						}
						}
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					{
					switch ( LA(1)) {
					case LBRACKET:
					{
						match(LBRACKET);
						match(RBRACKET);
						if ( inputState.guessing==0 ) {
							
							type = type + "[]";
							
						}
						break;
					}
					case PIDENT:
					case IDENT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					var_name=id();
					if ( inputState.guessing==0 ) {
						
						KeYJavaType kjt = getJavaInfo().getKeYJavaType(type);
								ProgramElementName pvName = new ProgramElementName(var_name);
						if (kjt == null) {
						throw new antlr.SemanticException
						("Program Variable " + var_name + 
						" declared with unknown type " + 
						type);
						
						} else if (lookup(pvName)!=null) {
								  // commented out as pv do not have unique name (at the moment)
								    //throw new AmbigiousDeclException
								//	(var_name, getFilename(), getLine(), getColumn()); 
								}
						namespaces().programVariables().add(new ProgramVariable
						(new ProgramElementName(var_name), kjt));
						
						
					}
					match(SEMI);
				}
				else {
					break _loop142;
				}
				
			} while (true);
			}
			match(RBRACE);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_17);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void schema_var_decls() throws RecognitionException, TokenStreamException {
		
		Token  id1 = null;
		Token  id2 = null;
		Token  id3 = null;
		Token  id5 = null;
		Token  id6 = null;
		Token  id7 = null;
		Token  id8 = null;
		
		Sort s = null;
		boolean makeVariableSV  = false;
		boolean makeDependingSV = false; // skolem functions
		boolean rigid           = false;
		boolean listModifier    = false;
		String type = "";    
		
		
		try {      // for error handling
			match(SCHEMA);
			match(VARIABLES);
			match(LBRACE);
			if ( inputState.guessing==0 ) {
				switchToSchemaMode();
			}
			{
			_loop167:
			do {
				switch ( LA(1)) {
				case MODAL:
				{
					{
					match(MODAL);
					match(OPERATOR);
					one_schema_modal_decl();
					{
					_loop147:
					do {
						if ((LA(1)==COMMA)) {
							match(COMMA);
							one_schema_modal_decl();
						}
						else {
							break _loop147;
						}
						
					} while (true);
					}
					match(SEMI);
					}
					break;
				}
				case PROGRAM:
				case FORMULA:
				case PIDENT:
				case IDENT:
				{
					if ( inputState.guessing==0 ) {
						makeVariableSV = false; makeDependingSV = false; rigid = false; listModifier=false;
					}
					{
					switch ( LA(1)) {
					case PROGRAM:
					{
						{
						match(PROGRAM);
						{
						switch ( LA(1)) {
						case SVLIST:
						{
							match(SVLIST);
							if ( inputState.guessing==0 ) {
								listModifier=true;
							}
							break;
						}
						case IDENT:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						if ( inputState.guessing==0 ) {
							type = "";
						}
						{
						int _cnt154=0;
						_loop154:
						do {
							boolean synPredMatched153 = false;
							if (((LA(1)==IDENT))) {
								int _m153 = mark();
								synPredMatched153 = true;
								inputState.guessing++;
								try {
									{
									match(IDENT);
									match(IDENT);
									}
								}
								catch (RecognitionException pe) {
									synPredMatched153 = false;
								}
								rewind(_m153);
								inputState.guessing--;
							}
							if ( synPredMatched153 ) {
								id1 = LT(1);
								match(IDENT);
								if ( inputState.guessing==0 ) {
									type += " "+id1.getText();
								}
							}
							else if ((LA(1)==IDENT)) {
								id2 = LT(1);
								match(IDENT);
								if ( inputState.guessing==0 ) {
									type = type.substring(1,type.length());
									s = (Sort) DeclParser.name2sort.get(type);
									if (s == null) {
									throw new antlr.SemanticException
									("SchemaVariable of sort "+type+ " not found.");
									}
									schema_var_decl(id2.getText(),s,makeVariableSV,makeDependingSV,rigid,listModifier);
								}
							}
							else {
								if ( _cnt154>=1 ) { break _loop154; } else {throw new NoViableAltException(LT(1), getFilename());}
							}
							
							_cnt154++;
						} while (true);
						}
						{
						_loop156:
						do {
							if ((LA(1)==COMMA)) {
								match(COMMA);
								id3 = LT(1);
								match(IDENT);
								if ( inputState.guessing==0 ) {
									schema_var_decl(id3.getText(),s,makeVariableSV,makeDependingSV,rigid,listModifier);
								}
							}
							else {
								break _loop156;
							}
							
						} while (true);
						}
						match(SEMI);
						}
						break;
					}
					case FORMULA:
					{
						match(FORMULA);
						{
						switch ( LA(1)) {
						case RIGID:
						{
							match(RIGID);
							if ( inputState.guessing==0 ) {
								rigid = true;
							}
							break;
						}
						case IDENT:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						if ( inputState.guessing==0 ) {
							s = Sort.FORMULA;type = "";
						}
						{
						id5 = LT(1);
						match(IDENT);
						if ( inputState.guessing==0 ) {
							schema_var_decl(id5.getText(),s,makeVariableSV,makeDependingSV,rigid,listModifier);
						}
						}
						{
						_loop161:
						do {
							if ((LA(1)==COMMA)) {
								match(COMMA);
								{
								id6 = LT(1);
								match(IDENT);
								if ( inputState.guessing==0 ) {
									schema_var_decl(id6.getText(),s,makeVariableSV,makeDependingSV,rigid,listModifier);
								}
								}
							}
							else {
								break _loop161;
							}
							
						} while (true);
						}
						match(SEMI);
						break;
					}
					case PIDENT:
					case IDENT:
					{
						s=any_sortId_check(true);
						{
						switch ( LA(1)) {
						case VARIABLES:
						{
							match(VARIABLES);
							if ( inputState.guessing==0 ) {
								makeVariableSV = true;
							}
							break;
						}
						case DEPENDING:
						{
							match(DEPENDING);
							if ( inputState.guessing==0 ) {
								makeDependingSV = true;
							}
							break;
						}
						case RIGID:
						{
							match(RIGID);
							if ( inputState.guessing==0 ) {
								rigid = true;
							}
							break;
						}
						case IDENT:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						if ( inputState.guessing==0 ) {
							type = "";
						}
						{
						id7 = LT(1);
						match(IDENT);
						if ( inputState.guessing==0 ) {
							schema_var_decl(id7.getText(),s,makeVariableSV,makeDependingSV,rigid,listModifier);
						}
						}
						{
						_loop166:
						do {
							if ((LA(1)==COMMA)) {
								match(COMMA);
								{
								id8 = LT(1);
								match(IDENT);
								if ( inputState.guessing==0 ) {
									schema_var_decl(id8.getText(),s,makeVariableSV,makeDependingSV,rigid,listModifier);
								}
								}
							}
							else {
								break _loop166;
							}
							
						} while (true);
						}
						match(SEMI);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				default:
				{
					break _loop167;
				}
				}
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				switchToNormalMode();
			}
			match(RBRACE);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_17);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void pred_decls() throws RecognitionException, TokenStreamException {
		
		Token  cat = null;
		Token  choice = null;
		
		Sort[] argSorts;
		String pred_name;
		Namespace oldFNS=null;
		String ctext = null;
		Choice c=null;
		
		
		try {      // for error handling
			match(PREDICATES);
			{
			switch ( LA(1)) {
			case LPAREN:
			{
				match(LPAREN);
				cat = LT(1);
				match(IDENT);
				match(COLON);
				choice = LT(1);
				match(IDENT);
				match(RPAREN);
				break;
			}
			case LBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				if(cat!=null){
				ctext = cat.getText()+":"+choice.getText();
				c = (Choice) choices().lookup(new Name(ctext));
				if(c==null){
				throw new NotDeclException("Option", choice,
				getFilename());
				}else{
				namespaces().setFunctions(c.funcNS());
				}
				}else{
				namespaces().setFunctions(defaultChoice.funcNS());
				}
				cat=null;
				
			}
			match(LBRACE);
			{
			_loop176:
			do {
				if ((LA(1)==PIDENT||LA(1)==IDENT)) {
					pred_name=id();
					argSorts=arg_sorts(!skip_predicates);
					if ( inputState.guessing==0 ) {
						
						if (!skip_predicates) {
						Name predicate = new Name(pred_name);		    		    
						if (lookup(predicate) != null) {
						throw new AmbigiousDeclException
						(pred_name, getFilename(), getLine(), getColumn());
						} else {
						Function p = new Function(predicate,
						Sort.FORMULA, 
						argSorts);
						functions().add(p);         
						}
						} 
						
					}
					match(SEMI);
				}
				else {
					break _loop176;
				}
				
			} while (true);
			}
			match(RBRACE);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_17);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void func_decls() throws RecognitionException, TokenStreamException {
		
		Token  cat = null;
		Token  choice = null;
		
		Sort[] argSorts;
		Sort retSort;
		String func_name;
		Namespace oldFNS=null;
		String ctext = null;
		Choice c=null;
		
		
		try {      // for error handling
			match(FUNCTIONS);
			{
			switch ( LA(1)) {
			case LPAREN:
			{
				match(LPAREN);
				cat = LT(1);
				match(IDENT);
				match(COLON);
				choice = LT(1);
				match(IDENT);
				match(RPAREN);
				break;
			}
			case LBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
				if(cat!=null){
				ctext = cat.getText()+":"+choice.getText();
				c = (Choice) choices().lookup(new Name(ctext));
				if(c==null){
				throw new NotDeclException("Option", choice,
				getFilename());
				}
				}else{
				c=defaultChoice;
				}
				namespaces().setFunctions(c.funcNS());
				cat=null;
				
			}
			match(LBRACE);
			{
			_loop180:
			do {
				if ((LA(1)==PIDENT||LA(1)==IDENT)) {
					retSort=sortId_check(!skip_functions);
					func_name=id();
					argSorts=arg_sorts(!skip_functions);
					if ( inputState.guessing==0 ) {
						
						if (!skip_functions) {
						Name fct_name = new Name(func_name);
						if (lookup(fct_name) != null) {
						throw new AmbigiousDeclException
						(func_name, getFilename(), getLine(), getColumn());
						} else {
						functions().add(new Function(fct_name,
							                                             retSort, 
							                                     argSorts));
						}
						} 
						
					}
					match(SEMI);
				}
				else {
					break _loop180;
				}
				
			} while (true);
			}
			match(RBRACE);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_17);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void heur_decls() throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
		int     t_priority = 0;
		Integer priority   = null;
		
		
		try {      // for error handling
			match(HEURISTICS);
			match(LBRACE);
			{
			_loop189:
			do {
				if ((LA(1)==IDENT)) {
					if ( inputState.guessing==0 ) {
						priority = null;
					}
					id = LT(1);
					match(IDENT);
					{
					switch ( LA(1)) {
					case LPAREN:
					{
						match(LPAREN);
						t_priority=integer_num();
						match(RPAREN);
						if ( inputState.guessing==0 ) {
							priority = new Integer ( t_priority );
						}
						break;
					}
					case SEMI:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					match(SEMI);
					if ( inputState.guessing==0 ) {
						
						if (!skip_heuristics) {
						Heuristic h = new Heuristic(new Name(id.getText()));
						if(heuristics().lookup(new Name(id.getText()))==null){
						heuristics().add(h);
						}
						if ( priority != null )
						heur_prioritization.setPriority ( h, priority.intValue () );
						}
						
					}
				}
				else {
					break _loop189;
				}
				
			} while (true);
			}
			match(RBRACE);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_17);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void choice() throws RecognitionException, TokenStreamException {
		
		Token  category = null;
		
		String cat=null;
		
		
		try {      // for error handling
			category = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				cat=category.getText();
			}
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				match(LBRACE);
				choice_option(cat);
				{
				_loop117:
				do {
					if ((LA(1)==COMMA)) {
						match(COMMA);
						choice_option(cat);
					}
					else {
						break _loop117;
					}
					
				} while (true);
				}
				match(RBRACE);
				break;
			}
			case SEMI:
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
				if(!category2Default.containsKey(cat)){
				choices().add(new Choice("On",cat));
				choices().add(new Choice("Off",cat)); 
				category2Default.put(cat, cat+":On");               
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_19);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void choice_option(
		String cat
	) throws RecognitionException, TokenStreamException {
		
		Token  choice = null;
		
		String name;
		
		
		try {      // for error handling
			choice = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				name=cat+":"+choice.getText();
				Choice c = (Choice) choices().lookup(new Name(name));
				if(c==null){
				c = new Choice(choice.getText(),cat);
				choices().add(c);
				}
				if(!category2Default.containsKey(cat)){
				category2Default.put(cat, name);
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_14);
			} else {
			  throw ex;
			}
		}
	}
	
	public final ListOfName  sortIdentifiers() throws RecognitionException, TokenStreamException {
		ListOfName ids = SLListOfName.EMPTY_LIST;
		
		Token  id = null;
		Token  id2 = null;
		
		try {      // for error handling
			id = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				ids = ids.append ( new Name(id.getText()) );
			}
			{
			_loop127:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					id2 = LT(1);
					match(IDENT);
					if ( inputState.guessing==0 ) {
						ids = ids.append ( new Name(id2.getText()) );
					}
				}
				else {
					break _loop127;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		return ids;
	}
	
	public final Sort[]  oneof_sorts() throws RecognitionException, TokenStreamException {
		Sort[] oneOfSorts = null;
		
		
		List args = new LinkedList();
		Sort s;
		
		
		try {      // for error handling
			match(LBRACE);
			s=sortId_check(true);
			if ( inputState.guessing==0 ) {
				args.add(s);
			}
			{
			_loop133:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					s=sortId_check(true);
					if ( inputState.guessing==0 ) {
						args.add(s);
					}
				}
				else {
					break _loop133;
				}
				
			} while (true);
			}
			match(RBRACE);
			if ( inputState.guessing==0 ) {
				
				oneOfSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_21);
			} else {
			  throw ex;
			}
		}
		return oneOfSorts;
	}
	
	public final Sort[]  extends_sorts() throws RecognitionException, TokenStreamException {
		Sort[] extendsSorts = null;
		
		
		List args = new LinkedList();
		Sort s;
		
		
		try {      // for error handling
			s=any_sortId_check(true);
			if ( inputState.guessing==0 ) {
				args.add(s);
			}
			{
			_loop130:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					s=any_sortId_check(true);
					if ( inputState.guessing==0 ) {
						args.add(s);
					}
				}
				else {
					break _loop130;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				
				extendsSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_22);
			} else {
			  throw ex;
			}
		}
		return extendsSorts;
	}
	
	public final Sort  any_sortId_check(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		Sort t;
		
		
		try {      // for error handling
			t=any_sortId_check_help(checkSort);
			s=array_decls(t);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_23);
			} else {
			  throw ex;
			}
		}
		return s;
	}
	
	public final Sort  sortId_check(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		Sort t;
		
		
		try {      // for error handling
			t=sortId_check_help(checkSort);
			s=array_decls(t);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_24);
			} else {
			  throw ex;
			}
		}
		return s;
	}
	
	public final void one_schema_modal_decl() throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
		Modality[] mods;
		
		
		try {      // for error handling
			id = LT(1);
			match(IDENT);
			match(EQUALS);
			mods=modalities_decl();
			if ( inputState.guessing==0 ) {
				
				SchemaVariable msv = (SchemaVariable)variables().lookup(new Name(id.getText()));
				if(msv != null)
				throw new antlr.SemanticException("Schema variable "+id.getText()+ " already defined");
				int arity = mods[0].arity();
				for(int i=1;i<mods.length;i++)
				if(arity != mods[i].arity())
				throw new antlr.SemanticException("Arity mismatch for schema variable "+id.getText());
				msv = SchemaVariableFactory.createModalOperatorSV(new Name(id.getText()), arity, mods);
				if (inSchemaMode()) {
				variables().add(msv);
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_25);
			} else {
			  throw ex;
			}
		}
	}
	
	public final Modality[]  modalities_decl() throws RecognitionException, TokenStreamException {
		Modality[] modalities = null;
		
		Token  s1 = null;
		Token  s2 = null;
		
		List args = new LinkedList();
		
		
		try {      // for error handling
			{
			match(LBRACE);
			s1 = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				
				if(s1.getText().charAt(0) == '#') {
				ModalOperatorSV msv = (ModalOperatorSV)variables().lookup(new Name(s1.getText()));
				if(msv == null)
				throw new antlr.SemanticException("Schema variable "+s1.getText()+ " not defined");
				for(int i=0; i<msv.modalities().length; i++)
				args.add(msv.modalities()[i]);
				}else{
				Modality op = Op.getModality(s1.getText());
				if(op == null)
				throw new antlr.SemanticException("Unrecognised modal operator "+s1.getText());
				args.add(op);
				}
				
			}
			{
			_loop172:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					s2 = LT(1);
					match(IDENT);
					if ( inputState.guessing==0 ) {
						
						if(s2.getText().charAt(0) == '#') {
						ModalOperatorSV msv = (ModalOperatorSV)variables().lookup(new Name(s2.getText()));
						if(msv == null)
						throw new antlr.SemanticException("Schema variable "+s2.getText()+ " not defined");
						for(int i=0; i<msv.modalities().length; i++)
						args.add(msv.modalities()[i]);
						} else {
						Modality op = Op.getModality(s2.getText());
						if(op == null)
						throw new antlr.SemanticException("Unrecognised modal operator "+s2.getText());
						args.add(op);
						}
						
					}
				}
				else {
					break _loop172;
				}
				
			} while (true);
			}
			match(RBRACE);
			}
			if ( inputState.guessing==0 ) {
				
				modalities = (Modality[])args.toArray(new Modality[args.size()]);
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_25);
			} else {
			  throw ex;
			}
		}
		return modalities;
	}
	
	public final Sort[]  arg_sorts(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort[] argSorts = null;
		
		
		List args = new LinkedList();
		Sort s;
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LPAREN:
			{
				match(LPAREN);
				s=sortId_check(checkSort);
				if ( inputState.guessing==0 ) {
					args.add(s);
				}
				{
				_loop184:
				do {
					if ((LA(1)==COMMA)) {
						match(COMMA);
						s=sortId_check(checkSort);
						if ( inputState.guessing==0 ) {
							args.add(s);
						}
					}
					else {
						break _loop184;
					}
					
				} while (true);
				}
				match(RPAREN);
				break;
			}
			case SEMI:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
				argSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_22);
			} else {
			  throw ex;
			}
		}
		return argSorts;
	}
	
	public final int  integer_num() throws RecognitionException, TokenStreamException {
		 int num = 0 ;
		
		
		if ( inputState.guessing==0 ) {
			
			try {
			Token t = LT(1);
			num = Integer.decode ( t.getText () ).intValue ();
			consume ();
			} catch ( TokenStreamException e ) {
			throw new antlr.SemanticException ( "Expected a number",
			getFilename (), getLine (), getColumn () );
			} catch ( NumberFormatException e ) {
			throw new antlr.SemanticException ( "Expected a number",
			getFilename (), getLine (), getColumn () );
			} catch ( NullPointerException e ) {
			throw new antlr.SemanticException ( "Expected a number",
			getFilename (), getLine (), getColumn () );
			}
			
		}
		return num;
	}
	
	public final Sort  sortId_check_help(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		try {      // for error handling
			s=any_sortId_check_help(checkSort);
			if ( inputState.guessing==0 ) {
				
				// don't allow generic sorts or collection sorts of
				// generic sorts at this point
				Sort t = s;
				while ( t instanceof CollectionSort )
				t = ((CollectionSort)t).elementSort ();
				if ( t instanceof GenericSort )
				throw new GenericSortException ( "sort",
				"Non-generic sort expected", t,
				getFilename (), getLine (), getColumn () );
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_26);
			} else {
			  throw ex;
			}
		}
		return s;
	}
	
	public final Sort  array_decls(
		Sort p
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		int  n=0;
		
		
		try {      // for error handling
			{
			_loop197:
			do {
				if ((LA(1)==LBRACKET)) {
					match(LBRACKET);
					match(RBRACKET);
					if ( inputState.guessing==0 ) {
						n++;
					}
				}
				else {
					break _loop197;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				
				if(n != 0){
				s = ArraySortImpl.getArraySortForDim(
				p, n, getJavaInfo().getObjectSort(),
				getJavaInfo().getCloneableSort());
				}else{
				s = p;
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_27);
			} else {
			  throw ex;
			}
		}
		return s;
	}
	
	public final Sort  any_sortId_check_help(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		String name;
		
		
		try {      // for error handling
			name=id();
			if ( inputState.guessing==0 ) {
				s= (Sort) sorts().lookup(new Name(name));
				if (checkSort && s == null) {
				throw new NotDeclException("sort", name, 
				getFilename(), 
				getLine(), getColumn());
				}
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_28);
			} else {
			  throw ex;
			}
		}
		return s;
	}
	
	public final IdDeclaration  id_declaration() throws RecognitionException, TokenStreamException {
		 IdDeclaration idd = null ;
		
		Token  id = null;
		
		Sort s = null;
		
		
		try {      // for error handling
			id = LT(1);
			match(IDENT);
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				s=sortId_check(true);
				break;
			}
			case EOF:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
				idd = new IdDeclaration ( id.getText (), s );
				
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		return idd;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"new\"",
		"\"branch\"",
		"\"notsimple\"",
		"\"include\"",
		"\"LDTs\"",
		"\"nostandardrules\"",
		"\"typeof\"",
		"\"object\"",
		"\"number\"",
		"\"intliteral\"",
		"\"longliteral\"",
		"\"generic\"",
		"\"extends\"",
		"\"oneof\"",
		"\"program\"",
		"\"svlist\"",
		"\"all\"",
		"\"ex\"",
		"\"true\"",
		"\"false\"",
		"\"find\"",
		"\"if\"",
		"\"varcond\"",
		"\"containsquery\"",
		"\"noninteractive\"",
		"\"recursive\"",
		"\"displayname\"",
		"\"helptext\"",
		"\"not\"",
		"\"free\"",
		"\"in\"",
		"\"depending\"",
		"\"on\"",
		"\"close\"",
		"\"goal\"",
		"\"replacewith\"",
		"\"add\"",
		"\"addrules\"",
		"\"addprogvars\"",
		"\"heuristics\"",
		"\"hasSort\"",
		"\"sorts\"",
		"\"options\"",
		"\"with\"",
		"\"schema\"",
		"\"variables\"",
		"\"local\"",
		"\"rigid\"",
		"\"predicates\"",
		"\"functions\"",
		"\"formula\"",
		"\"modal\"",
		"\"operator\"",
		"\"rules\"",
		"\"proof\"",
		"\"rule\"",
		"\"term\"",
		"\"inst\"",
		"\"ifseqformula\"",
		"\"interactive\"",
		"\"heur\"",
		"\"modifies\"",
		"\"contracts\"",
		"\"problem\"",
		"\"#inType\"",
		"\"#isObject\"",
		"\"#inLong\"",
		"\"#inInt\"",
		"\"#inChar\"",
		"\"#inShort\"",
		"\"#inByte\"",
		"\"#add\"",
		"\"#sub\"",
		"\"#mul\"",
		"\"#div\"",
		"\"#jdiv\"",
		"\"#mod\"",
		"\"#jmod\"",
		"\"#less\"",
		"\"#greater\"",
		"\"#leq\"",
		"\"#geq\"",
		"\"#eq\"",
		"\"#JavaIntUnaryMinus\"",
		"\"#JavaIntAdd\"",
		"\"#JavaIntSub\"",
		"\"#JavaIntMul\"",
		"\"#JavaIntDiv\"",
		"\"#JavaIntMod\"",
		"\"#JavaIntAnd\"",
		"\"#JavaIntOr\"",
		"\"#JavaIntXor\"",
		"\"#JavaIntComplement\"",
		"\"#JavaIntShiftRight\"",
		"\"#JavaIntShiftLeft\"",
		"\"#JavaIntUnsignedShiftRight\"",
		"\"#JavaLongUnaryMinus\"",
		"\"#JavaLongAdd\"",
		"\"#JavaLongSub\"",
		"\"#JavaLongMul\"",
		"\"#JavaLongDiv\"",
		"\"#JavaLongMod\"",
		"\"#JavaLongAnd\"",
		"\"#JavaLongOr\"",
		"\"#JavaLongXor\"",
		"\"#JavaLongComplement\"",
		"\"#JavaLongShiftRight\"",
		"\"#JavaLongShiftLeft\"",
		"\"#JavaLongUnsignedShiftRight\"",
		"\"#moduloByte\"",
		"\"#moduloShort\"",
		"\"#moduloInteger\"",
		"\"#moduloLong\"",
		"\"#staticanalysis\"",
		"\"#ResolveQuery\"",
		"\"#constantvalue\"",
		"\"#lengthReference\"",
		"\"#transient\"",
		"\"#shadowed\"",
		"\"#concat\"",
		"\"#introduce\"",
		"\"waryAll\"",
		"\"waryEx\"",
		"\"same\"",
		"\"compatible\"",
		"\"sameUpdateLevel\"",
		"\"smaller\"",
		"\"than\"",
		"\"quotes\"",
		"\"ThisReference\"",
		"\"keyLog\"",
		"\"keyUser\"",
		"\"keyVersion\"",
		"\"keySettings\"",
		"\"ocl\"",
		"\"#allSubtypes\"",
		"VOCAB",
		"`;'",
		"`/'",
		"`\\'",
		"`:'",
		"`?='",
		"`/->'",
		"`:='",
		"`.'",
		"`,'",
		"`('",
		"`)'",
		"`{'",
		"`}'",
		"`['",
		"']'",
		"`at'",
		"`|'",
		"`&'",
		"`->'",
		"`<->'",
		"`='",
		"] followed by a sequence of primes (at least one)",
		"`==>'",
		"'^'",
		"java operator",
		"white space",
		"a string in double quotes",
		"PRIMES_OR_CHARLITERAL",
		"Sequence of primes (at least one)",
		"a char in single quotes",
		"ESC",
		"DIAMOND",
		"BOX",
		"THROUGHOUT",
		"MODALITYARG",
		"BLOCK",
		"a string with double quotes",
		"a comment",
		"a comment",
		"a digit",
		"a hexadeciamal number",
		"a letter",
		"an admissible character for identifiers",
		"an admissible character for identifiers protected with ``",
		"PIDENT",
		"an identifer",
		"\"-\""
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 2L, 6917529027641081856L, 34001846272L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 4310695936L, 48L, 432473314034466816L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 2L, 6917529027641081856L, 44040192L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 2L, 6917529027641081856L, 4339007488L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 2L, 6917529027641081856L, 6486491136L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 2L, 6917529027641081856L, 7023362048L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 12582912L, 48L, 432350099985661952L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 0L, 0L, 1114112L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 2L, 6917529027641081856L, 34070003712L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { 2L, 6917529027641081856L, 2233093259264L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	private static final long[] mk_tokenSet_11() {
		long[] data = { 2814784139427842L, 6917529027641081904L, 432350134072500224L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
	private static final long[] mk_tokenSet_12() {
		long[] data = { 0L, 0L, 10485760L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
	private static final long[] mk_tokenSet_13() {
		long[] data = { 12582912L, 48L, 432350100003536896L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
	private static final long[] mk_tokenSet_14() {
		long[] data = { 0L, 0L, 35651584L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
	private static final long[] mk_tokenSet_15() {
		long[] data = { 0L, 0L, 524288L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
	private static final long[] mk_tokenSet_16() {
		long[] data = { 0L, 0L, 35659776L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
	private static final long[] mk_tokenSet_17() {
		long[] data = { 13906623068372994L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_17 = new BitSet(mk_tokenSet_17());
	private static final long[] mk_tokenSet_18() {
		long[] data = { 34816L, 0L, 288230376151712768L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_18 = new BitSet(mk_tokenSet_18());
	private static final long[] mk_tokenSet_19() {
		long[] data = { 0L, 0L, 33562624L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_19 = new BitSet(mk_tokenSet_19());
	private static final long[] mk_tokenSet_20() {
		long[] data = { 196608L, 0L, 8192L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_20 = new BitSet(mk_tokenSet_20());
	private static final long[] mk_tokenSet_21() {
		long[] data = { 65536L, 0L, 8192L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_21 = new BitSet(mk_tokenSet_21());
	private static final long[] mk_tokenSet_22() {
		long[] data = { 0L, 0L, 8192L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_22 = new BitSet(mk_tokenSet_22());
	private static final long[] mk_tokenSet_23() {
		long[] data = { 2814784126844928L, 0L, 288230376153817088L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_23 = new BitSet(mk_tokenSet_23());
	private static final long[] mk_tokenSet_24() {
		long[] data = { 12582914L, 48L, 432350100047577088L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_24 = new BitSet(mk_tokenSet_24());
	private static final long[] mk_tokenSet_25() {
		long[] data = { 0L, 0L, 2105344L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_25 = new BitSet(mk_tokenSet_25());
	private static final long[] mk_tokenSet_26() {
		long[] data = { 12582914L, 48L, 432350100114685952L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_26 = new BitSet(mk_tokenSet_26());
	private static final long[] mk_tokenSet_27() {
		long[] data = { 2814784139427842L, 48L, 432350100047585280L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_27 = new BitSet(mk_tokenSet_27());
	private static final long[] mk_tokenSet_28() {
		long[] data = { 2814784139427842L, 48L, 432350100114694144L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_28 = new BitSet(mk_tokenSet_28());
	
	}
