// $ANTLR 2.7.2: "modifies.g" -> "ModifiesParser.java"$


    package de.uka.ilkd.key.parser;

    import de.uka.ilkd.key.logic.*;
    import de.uka.ilkd.key.logic.op.*;
    import de.uka.ilkd.key.java.JavaInfo;
    import de.uka.ilkd.key.java.abstraction.KeYJavaType;
    import de.uka.ilkd.key.java.*;
    import de.uka.ilkd.key.java.reference.*;
    import java.util.HashSet;


import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

/** 
 * A parser for modifies clauses,
 * i.e. FieldReferences.
 */
public class ModifiesParser extends antlr.LLkParser       implements ModifiesParserTokenTypes
 {

	private Namespace ns;
	private HashSet fields = new HashSet();
	private JavaInfo javaInfo;
	private boolean isStatic = false;
	private String packagePrefix = new String();

	public ModifiesParser(TokenStream lexer,
			  Namespace ns,
			  JavaInfo javaInfo) {
	    this(lexer);
	    this.ns = ns;
	    this.javaInfo = javaInfo;
	}
		
	public Namespace namespace() {
	    return ns;
        }

	public JavaInfo getJavaInfo() {
	    return javaInfo;
	}

	public HashSet modifiesElements() {
	    return fields;
	}


protected ModifiesParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public ModifiesParser(TokenBuffer tokenBuf) {
  this(tokenBuf,3);
}

protected ModifiesParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public ModifiesParser(TokenStream lexer) {
  this(lexer,3);
}

public ModifiesParser(ParserSharedInputState state) {
  super(state,3);
  tokenNames = _tokenNames;
}

	public final void top() throws RecognitionException, TokenStreamException {
		
		ProgramElement f;
		
		f=fieldref();
		fields.add(f);
		{
		_loop3:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				f=fieldref();
				fields.add(f);
			}
			else {
				break _loop3;
			}
			
		} while (true);
		}
	}
	
	public final ProgramElement  fieldref() throws RecognitionException, TokenStreamException {
		ProgramElement pe = null;
		
		Token  id = null;
		String y = null;
							      KeYJavaType last = null;
							
		
		{
		{
		switch ( LA(1)) {
		case IDENT:
		{
			{
			y=programvar_or_typeref();
			}
			pe = (ProgramVariable) ns.lookup(new Name(y));
						  if (pe == null) {
					last = javaInfo.getKeYJavaType(y);
							if (last == null) {
								throw new 
						   		 RuntimeException("Program Variable or Typeref not found: "+y);
							}
							pe = new TypeRef(last);
							isStatic = true;
						  } else
						  last = ((ProgramVariable)pe).getKeYJavaType();
						
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			{
			_loop9:
			do {
				if ((LA(1)==IDENT) && (LA(2)==DOT)) {
					id = LT(1);
					match(IDENT);
					match(DOT);
					packagePrefix = packagePrefix+id.getText()+".";
						
				}
				else {
					break _loop9;
				}
				
			} while (true);
			}
			{
			y=programvar_or_typeref();
			}
			
				  last = javaInfo.getKeYJavaType(packagePrefix+y);
						  if (last == null) {
							throw new 
						   		 RuntimeException("Program Variable or Typeref not found: "+y);
						  }
						  pe = new TypeRef(last);
						  isStatic = true;
				
			match(RPAREN);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		_loop12:
		do {
			if ((LA(1)==DOT)) {
				match(DOT);
				y=programvar_or_typeref();
				
							  ProgramVariable x = javaInfo.getAttribute(y, last);
				if (x==null) { // for private attributes, though OCL has
							                 // no visibilities
						          x=javaInfo.getAttribute
						                (last.getSort().toString()+"::"+y, 
						                 last);
					          }
							  if (x == null) {
							    throw new
							    RuntimeException("Attribute "+y+" not found in "
										+last+"   "+pe);
							  }
							  if (isStatic) {
								if (!x.isStatic()) {
									throw new
							    		RuntimeException("ProgramVariable "+x+" is not static but "+
											  "a static field was expected.");
								}
								isStatic = false;
							  }
							  pe = new FieldReference(x, (ReferencePrefix) pe);
							  last = ((ProgramVariable)x).getKeYJavaType();
							
			}
			else {
				break _loop12;
			}
			
		} while (true);
		}
		}
		return pe;
	}
	
	public final String  programvar_or_typeref() throws RecognitionException, TokenStreamException {
		String pv = null;
		
		Token  id = null;
		
		id = LT(1);
		match(IDENT);
		pv = (String) id.getText(); 
			
		return pv;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"new\"",
		"\"branch\"",
		"\"notsimple\"",
		"\"include\"",
		"\"LDTs\"",
		"\"nostandardrules\"",
		"\"typeof\"",
		"\"object\"",
		"\"number\"",
		"\"intliteral\"",
		"\"longliteral\"",
		"\"generic\"",
		"\"extends\"",
		"\"oneof\"",
		"\"program\"",
		"\"svlist\"",
		"\"all\"",
		"\"ex\"",
		"\"true\"",
		"\"false\"",
		"\"find\"",
		"\"if\"",
		"\"varcond\"",
		"\"containsquery\"",
		"\"noninteractive\"",
		"\"recursive\"",
		"\"displayname\"",
		"\"helptext\"",
		"\"not\"",
		"\"free\"",
		"\"in\"",
		"\"depending\"",
		"\"on\"",
		"\"close\"",
		"\"goal\"",
		"\"replacewith\"",
		"\"add\"",
		"\"addrules\"",
		"\"addprogvars\"",
		"\"heuristics\"",
		"\"hasSort\"",
		"\"sorts\"",
		"\"options\"",
		"\"with\"",
		"\"schema\"",
		"\"variables\"",
		"\"local\"",
		"\"rigid\"",
		"\"predicates\"",
		"\"functions\"",
		"\"formula\"",
		"\"modal\"",
		"\"operator\"",
		"\"rules\"",
		"\"proof\"",
		"\"rule\"",
		"\"term\"",
		"\"inst\"",
		"\"ifseqformula\"",
		"\"interactive\"",
		"\"heur\"",
		"\"modifies\"",
		"\"contracts\"",
		"\"problem\"",
		"\"#inType\"",
		"\"#isObject\"",
		"\"#inLong\"",
		"\"#inInt\"",
		"\"#inChar\"",
		"\"#inShort\"",
		"\"#inByte\"",
		"\"#add\"",
		"\"#sub\"",
		"\"#mul\"",
		"\"#div\"",
		"\"#jdiv\"",
		"\"#mod\"",
		"\"#jmod\"",
		"\"#less\"",
		"\"#greater\"",
		"\"#leq\"",
		"\"#geq\"",
		"\"#eq\"",
		"\"#JavaIntUnaryMinus\"",
		"\"#JavaIntAdd\"",
		"\"#JavaIntSub\"",
		"\"#JavaIntMul\"",
		"\"#JavaIntDiv\"",
		"\"#JavaIntMod\"",
		"\"#JavaIntAnd\"",
		"\"#JavaIntOr\"",
		"\"#JavaIntXor\"",
		"\"#JavaIntComplement\"",
		"\"#JavaIntShiftRight\"",
		"\"#JavaIntShiftLeft\"",
		"\"#JavaIntUnsignedShiftRight\"",
		"\"#JavaLongUnaryMinus\"",
		"\"#JavaLongAdd\"",
		"\"#JavaLongSub\"",
		"\"#JavaLongMul\"",
		"\"#JavaLongDiv\"",
		"\"#JavaLongMod\"",
		"\"#JavaLongAnd\"",
		"\"#JavaLongOr\"",
		"\"#JavaLongXor\"",
		"\"#JavaLongComplement\"",
		"\"#JavaLongShiftRight\"",
		"\"#JavaLongShiftLeft\"",
		"\"#JavaLongUnsignedShiftRight\"",
		"\"#moduloByte\"",
		"\"#moduloShort\"",
		"\"#moduloInteger\"",
		"\"#moduloLong\"",
		"\"#staticanalysis\"",
		"\"#ResolveQuery\"",
		"\"#constantvalue\"",
		"\"#lengthReference\"",
		"\"#transient\"",
		"\"#shadowed\"",
		"\"#concat\"",
		"\"#introduce\"",
		"\"waryAll\"",
		"\"waryEx\"",
		"\"same\"",
		"\"compatible\"",
		"\"sameUpdateLevel\"",
		"\"smaller\"",
		"\"than\"",
		"\"quotes\"",
		"\"ThisReference\"",
		"\"keyLog\"",
		"\"keyUser\"",
		"\"keyVersion\"",
		"\"keySettings\"",
		"\"ocl\"",
		"\"#allSubtypes\"",
		"VOCAB",
		"`;'",
		"`/'",
		"`\\'",
		"`:'",
		"`?='",
		"`/->'",
		"`:='",
		"`.'",
		"`,'",
		"`('",
		"`)'",
		"`{'",
		"`}'",
		"`['",
		"']'",
		"`at'",
		"`|'",
		"`&'",
		"`->'",
		"`<->'",
		"`='",
		"] followed by a sequence of primes (at least one)",
		"`==>'",
		"'^'",
		"java operator",
		"white space",
		"a string in double quotes",
		"PRIMES_OR_CHARLITERAL",
		"Sequence of primes (at least one)",
		"a char in single quotes",
		"ESC",
		"DIAMOND",
		"BOX",
		"THROUGHOUT",
		"MODALITYARG",
		"BLOCK",
		"a string with double quotes",
		"a comment",
		"a comment",
		"a digit",
		"a hexadeciamal number",
		"a letter",
		"an admissible character for identifiers",
		"an admissible character for identifiers protected with ``",
		"PIDENT",
		"an identifer"
	};
	
	
	}
