// $ANTLR 2.7.2: "expandedtaclets.g" -> "TacletParser.java"$


package de.uka.ilkd.key.parser;

import java.io.*;
import antlr.*;
import de.uka.ilkd.key.parser.*;
import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.logic.sort.*;    
import de.uka.ilkd.key.logic.op.*;
import de.uka.ilkd.key.rule.metaconstruct.*;
import de.uka.ilkd.key.rule.*;
import de.uka.ilkd.key.proof.RuleSource;
import de.uka.ilkd.key.proof.init.Includes;

import de.uka.ilkd.key.java.JavaInfo;
import de.uka.ilkd.key.java.Services;
import de.uka.ilkd.key.java.SchemaJavaReader;
import de.uka.ilkd.key.java.SchemaRecoder2KeY;
import de.uka.ilkd.key.java.abstraction.KeYJavaType;
import de.uka.ilkd.key.java.abstraction.ListOfKeYJavaType;
import de.uka.ilkd.key.java.abstraction.SLListOfKeYJavaType;
import de.uka.ilkd.key.java.visitor.DeclarationProgramVariableCollector;
import java.util.List;
import java.util.LinkedList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import de.uka.ilkd.key.gui.AbbrevMap;

public interface TacletParserTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int NEW = 4;
	int BRANCH = 5;
	int NOTSIMPLE = 6;
	int INCLUDE = 7;
	int LDTS = 8;
	int NOSTANDARDRULES = 9;
	int TYPEOF = 10;
	int OBJECT = 11;
	int NUMBER = 12;
	int INTLITERAL = 13;
	int LONGLITERAL = 14;
	int GENERIC = 15;
	int EXTENDS = 16;
	int ONEOF = 17;
	int PROGRAM = 18;
	int SVLIST = 19;
	int FORALL = 20;
	int EXISTS = 21;
	int TRUE = 22;
	int FALSE = 23;
	int FIND = 24;
	int IF = 25;
	int VARCOND = 26;
	int CONTAINSQUERY = 27;
	int NONINTERACTIVE = 28;
	int RECURSIVE = 29;
	int DISPLAYNAME = 30;
	int HELPTEXT = 31;
	int NOT = 32;
	int FREE = 33;
	int IN = 34;
	int DEPENDING = 35;
	int ON = 36;
	int CLOSE = 37;
	int GOAL = 38;
	int REPLACEWITH = 39;
	int ADD = 40;
	int ADDRULES = 41;
	int ADDPROGVARS = 42;
	int HEURISTICS = 43;
	int HASSORT = 44;
	int SORTS = 45;
	int OPTIONS = 46;
	int WITH = 47;
	int SCHEMA = 48;
	int VARIABLES = 49;
	int LOCAL = 50;
	int RIGID = 51;
	int PREDICATES = 52;
	int FUNCTIONS = 53;
	int FORMULA = 54;
	int MODAL = 55;
	int OPERATOR = 56;
	int RULES = 57;
	int PROOF = 58;
	int RULE = 59;
	int TERM = 60;
	int INST = 61;
	int IFSEQFORMULA = 62;
	int INTERACTIVE = 63;
	int HEUR = 64;
	int MODIFIES = 65;
	int CONTRACTS = 66;
	int PROBLEM = 67;
	int IN_TYPE = 68;
	int IS_OBJECT = 69;
	int META_IN_LONG = 70;
	int META_IN_INT = 71;
	int META_IN_CHAR = 72;
	int META_IN_SHORT = 73;
	int META_IN_BYTE = 74;
	int META_ADD = 75;
	int META_SUB = 76;
	int META_MUL = 77;
	int META_DIV = 78;
	int META_JDIV = 79;
	int META_MOD = 80;
	int META_JMOD = 81;
	int META_LESS = 82;
	int META_GREATER = 83;
	int META_LEQ = 84;
	int META_GEQ = 85;
	int META_EQ = 86;
	int META_INT_UNARY_MINUS = 87;
	int META_INT_ADD = 88;
	int META_INT_SUB = 89;
	int META_INT_MUL = 90;
	int META_INT_DIV = 91;
	int META_INT_MOD = 92;
	int META_INT_AND = 93;
	int META_INT_OR = 94;
	int META_INT_XOR = 95;
	int META_INT_COMPLEMENT = 96;
	int META_INT_SHIFTRIGHT = 97;
	int META_INT_SHIFTLEFT = 98;
	int META_INT_UNSIGNEDSHIFTRIGHT = 99;
	int META_LONG_UNARY_MINUS = 100;
	int META_LONG_ADD = 101;
	int META_LONG_SUB = 102;
	int META_LONG_MUL = 103;
	int META_LONG_DIV = 104;
	int META_LONG_MOD = 105;
	int META_LONG_AND = 106;
	int META_LONG_OR = 107;
	int META_LONG_XOR = 108;
	int META_LONG_COMPLEMENT = 109;
	int META_LONG_SHIFTRIGHT = 110;
	int META_LONG_SHIFTLEFT = 111;
	int META_LONG_UNSIGNEDSHIFTRIGHT = 112;
	int META_MODULO_BYTE = 113;
	int META_MODULO_SHORT = 114;
	int META_MODULO_INTEGER = 115;
	int META_MODULO_LONG = 116;
	int STATIC_ANALYSIS = 117;
	int RESOLVE_QUERY = 118;
	int CONSTANT_VALUE = 119;
	int META_LENGTH = 120;
	int META_TRANSIENT = 121;
	int META_SHADOW = 122;
	int CONCAT = 123;
	int INTRODUCE = 124;
	int WARY_ALL = 125;
	int WARY_EX = 126;
	int SAME = 127;
	int COMPATIBLE = 128;
	int SAME_UPDATE_LEVEL = 129;
	int SMALLER = 130;
	int THAN = 131;
	int QUOTES = 132;
	int THISREFERENCE = 133;
	int KEYLOG = 134;
	int KEYLOGUSER = 135;
	int KEYLOGVERSION = 136;
	int KEYLOGSETTINGS = 137;
	int OCL = 138;
	int META_ALLSUBTYPES = 139;
	int VOCAB = 140;
	int SEMI = 141;
	int SLASH = 142;
	int BACKSLASH = 143;
	int COLON = 144;
	int GUARD = 145;
	int CONDUP = 146;
	int ASSIGN = 147;
	int DOT = 148;
	int COMMA = 149;
	int LPAREN = 150;
	int RPAREN = 151;
	int LBRACE = 152;
	int RBRACE = 153;
	int LBRACKET = 154;
	int RBRACKET = 155;
	int AT = 156;
	int OR = 157;
	int AND = 158;
	int IMP = 159;
	int EQV = 160;
	int EQUALS = 161;
	int RBRACKETPRIMES = 162;
	int SEQARROW = 163;
	int CTRL = 164;
	int ARITH_OP = 165;
	int WS = 166;
	int STRING_LITERAL = 167;
	int PRIMES_OR_CHARLITERAL = 168;
	int PRIMES = 169;
	int CHAR_LITERAL = 170;
	int ESC = 171;
	int DIAMOND = 172;
	int BOX = 173;
	int THROUGHOUT = 174;
	int MODALITYARG = 175;
	int BLOCK = 176;
	int QUOTED_STRING_LITERAL = 177;
	int SL_COMMENT = 178;
	int ML_COMMENT = 179;
	int DIGIT = 180;
	int HEX = 181;
	int LETTER = 182;
	int IDCHAR = 183;
	int PIDCHAR = 184;
	int PIDENT = 185;
	int IDENT = 186;
	int LITERAL_elemtypeof = 187;
	// "-" = 188
}
