// $ANTLR 2.7.2: "dictionary.g" -> "DictionaryParser.java"$


    package de.uka.ilkd.key.parser.dictionary;

    import java.io.*;
    import antlr.*;
    import java.util.Map;
    import java.util.HashMap;


import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

/** 
 * Parser for dictionaries as e.g. required by the proof assistant
 */
public class DictionaryParser extends antlr.LLkParser       implements DictionaryParserTokenTypes
 {

	private Map map = new HashMap(20);

	public Map getDictionary() {
	   return map;
	}


protected DictionaryParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public DictionaryParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected DictionaryParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public DictionaryParser(TokenStream lexer) {
  this(lexer,2);
}

public DictionaryParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final void start() throws RecognitionException, TokenStreamException {
		
		Token  sectionId = null;
		Token  keyId = null;
		Token  value = null;
		
		try {      // for error handling
			{
			_loop5:
			do {
				if ((LA(1)==LBRACKET)) {
					match(LBRACKET);
					sectionId = LT(1);
					match(IDENT);
					match(RBRACKET);
					{
					_loop4:
					do {
						if ((LA(1)==IDENT)) {
							keyId = LT(1);
							match(IDENT);
							match(EQUAL);
							value = LT(1);
							match(STRING_LITERAL);
							
									   map.put(sectionId.getText()+"."+keyId.getText(),
										   value.getText());
									
						}
						else {
							break _loop4;
						}
						
					} while (true);
					}
				}
				else {
					break _loop5;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"VOCAB",
		"`;'",
		"`/'",
		"`:'",
		"`='",
		"`,'",
		"`('",
		"`)'",
		"`{'",
		"`}'",
		"`['",
		"']'",
		"white space",
		"a string in double quotes",
		"PRIMES_OR_CHARLITERAL",
		"Sequence of primes (at least one)",
		"a char in single quotes",
		"ESC",
		"a string with double quotes",
		"a comment",
		"a digit",
		"a hexadeciamal number",
		"a letter",
		"an admissible character for identifiers",
		"an identifer"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	
	}
