/* Generated By:JavaCC: Do not edit this line. ProofJavaParser.java */
package de.uka.ilkd.key.parser.proofjava;

import java.io.*;
import java.util.*;

import recoder.*;
import recoder.list.*;
import recoder.java.*;
import recoder.java.declaration.*;
import recoder.java.declaration.modifier.*;
import recoder.java.expression.*;
import recoder.java.expression.literal.*;
import recoder.java.expression.operator.*;
import recoder.java.reference.*;
import recoder.java.statement.*;
import recoder.io.*;

import de.uka.ilkd.key.java.recoderext.*;

/**
   JavaCC AST generation specification based on the original Java1.1   
   grammar that comes with javacc, and includes the modification of D. Williams
   to accept the Java 1.2 strictfp modifier.
   Several patches have been added to allow semicola after member declarations.
   Augmented with special constructs used in KeY proofs. These are:
   - method-call statement
   - method-body statement
   - implicit fields
 */
public class ProofJavaParser implements ProofJavaParserConstants {

    public static final void initialize(Reader r) {
        current = null;
        comments.clear();
        ReInit(r);
    }

    /** the JavaProgramFactory instance that is used to create
	parse results
    */
    private static ProofJavaProgramFactory factory
        = (ProofJavaProgramFactory) ProofJavaProgramFactory.getInstance();

    /** temporary valid variable that is used to return an additional
        argument from parser method VariableDeclaratorId, since such an
        id may have a dimension
    */
    private static int tmpDimension;

    /** current token, follows the next links when necessary */
    private static Token current;

    /** all comments in a global list. */
    private static CommentMutableList comments = new CommentArrayList();


    /** reuseable position object. */
    private static SourceElement.Position position
        = new SourceElement.Position(0, 0);

    private static void copyPrefixInfo(SourceElement oldResult,
                                       SourceElement newResult) {
        newResult.setRelativePosition(oldResult.getRelativePosition());
        newResult.setStartPosition(oldResult.getStartPosition());
        newResult.setEndPosition(oldResult.getEndPosition());
    }

    /**
       Sets indentation information.
     */
    private static void shiftToken() {
        if (current != token) {
            if (current != null) {
                while (current.next != token) {
                    current = current.next;
                }
            }
            Token prev;
            if (token.specialToken != null) {
                prev = token.specialToken;
            } else {
                prev = current;
            }
            if (prev != null) {
                int col = token.beginColumn - 1;
                int lf = token.beginLine - prev.endLine;
                if (lf <= 0) {
                    col -= prev.endColumn; // - 1;
                    if (col < 0) {
                        col = 0;
                    }
                }
                position.setPosition(lf, col);
            }
        }
        current = token;
    }



    private static void setPrefixInfo(SourceElement constrResult) {
        position.setPosition(0, 0);
        shiftToken();
        constrResult.setRelativePosition(position);
        position.setPosition(current.beginLine, current.beginColumn);
        constrResult.setStartPosition(position);
    }

    private static void setPostfixInfo(SourceElement constrResult) {
        shiftToken();
        position.setPosition(current.endLine, current.endColumn);
        constrResult.setEndPosition(position);
    }

    private static void addComment(Comment c, Token tok) {
        Token prev = tok.specialToken;
        if (prev == null) {
            prev = token;
            // in case we are inside a lookahead we skip to the last known
            // non-special token
            while (prev.next != null) {
                prev = prev.next;
            }
        }
        position.setPosition(0, 0);

        int internalIndentation = 0;
        int internalLinefeeds = 0;
        if (prev.image != null) {
            int col = tok.beginColumn - 1;
            int lf = tok.beginLine - prev.endLine;
            if (lf <= 0) {
                col -= prev.endColumn; // - 1;
            }
            position.setPosition(lf, col);
        }
        c.setRelativePosition(position);
        position.setPosition(tok.beginLine, tok.beginColumn);
        c.setStartPosition(position);
        if (!(c instanceof DocComment)) {
            boolean hasEmptyLine = c.getRelativePosition().getLine() > 1;
            c.setPrefixed(hasEmptyLine);
            if (tok.specialToken != null && !hasEmptyLine) {
                c.setPrefixed(comments.getComment(comments.size() - 1).isPrefixed());
            }
        }
        comments.add(c);
    }

    static void addSingleLineComment(Token tok) {
        addComment(factory.createSingleLineComment(tok.image.trim()), tok);
    }

    static void addMultiLineComment(Token tok) {
        addComment(factory.createComment(tok.image), tok);
    }

    static void addDocComment(Token tok) {
        addComment(factory.createDocComment(tok.image), tok);
    }

    public static CommentMutableList getComments() {
        return comments;
    }


    /** checks whether or not the tree construction result is valid.
	Currently this only checks whether or not the result is <tt>null</tt>.
	@param constrResult the result of a factory call
	@exception ParseException if the result is not legal
    */
    private static void checkConstruction(SourceElement constrResult)
    throws ParseException {
        if (constrResult == null) {
            throw new ParseException
               ("An illegal null object was created during tree construction");
        }


        // insert check code here!!
    }

    private static void checkConstruction(ProgramElementList constrResult)
    throws ParseException {
        if (constrResult == null) {
            throw new ParseException
                ("An illegal null list was created during tree construction");
        }
        // insert check code here!!
    }


    /** inner class that is only used to return results from
	primary suffix syntax rule
	@author RN
    */
    static class PrimarySuffixReturnValue {

        // the following constants represent the various sub rules

        /** indicates that the result is currently undefined */
        static final int UNDEFINED       = -1;
        /** production was <pre>"." "this"</pre> */
        static final int THIS            =  0;
        /** production was <pre>"." AllocationExpression</pre> */
        static final int ALLOCATION_EXPR =  1;
        /** production was <pre>"[" Expression "]"</pre> */
        static final int INDEX_EXPR      =  2;
        /** production was <pre>"." <IDENTIFIER></pre> */
        static final int IDENTIFIER      =  3;
        /** production was <pre>Arguments</pre> */
        static final int ARGUMENTS       =  4;

        /** indicates the type of the result */
        int                   type = UNDEFINED;

        /** valid iff <tt>type</tt> is <tt>ALLOCATION_EXPR</tt> or 
	    <tt>INDEX_EXPR</tt> */
        Expression            expr = null;

        /** valid iff <tt>type</tt> is <tt>IDENTIFIER</tt> */
        Identifier            id   = null;

        /** valid iff <tt>type</tt> is <tt>ARGUMENTS</tt> */
        ExpressionMutableList args = null;
    }


    /** inner class that is only used to return results from
	primary prefix syntax rule
	@author RN
    */
    static class PrimaryPrefixReturnValue {

        // the following constants represent the various sub rules

        /** indicates that the result is currently undefined */
        static final int UNDEFINED        = -1;
        /** production was <pre>Literal</pre> */
        static final int LITERAL          =  0;
        /** production was <pre>"this"</pre> */
        static final int THIS             =  1;
        /** production was <pre>"super" "." <IDENTIFIER></pre> */
        static final int SUPER_MEMBER     =  2;
        /** production was <pre>"(" Expression ")"</pre> */
        static final int PARENTHESIZED_EXPR =  3;
        /** production was <pre>AllocationExpression</pre> */
        static final int ALLOCATION_EXPR  =  4;
        /** production was <pre>ResultType "." "class"</pre> */
        static final int CLASS_REF        =  5;
        /** production was <pre>Name</pre> */
        static final int QUALIFIED_NAME   =  6;
        /** production was <pre>"@(" Expression ")"</pre> */
        static final int PASSIVE_EXPR =  7;

        /** indicates the type of the result */
        int           type    = UNDEFINED;

        /** valid iff <tt>type</tt> is <tt>LITERAL</tt> */
        Literal       literal = null;

        /** valid iff <tt>type</tt> is <tt>PARENTHESED_EXPR</tt>
	    or <tt>ALLOCATION_EXPR</tt> */
        Expression    expr    = null;

        /** valid iff <tt>type</tt> is <tt>CLASS_REF</tt> */
        TypeReference typeref = null;

        /** valid iff <tt>type</tt> is <tt>QUALIFIED_NAME</tt> or
	 <tt>SUPER_MEMBER</tt>*/
        UncollatedReferenceQualifier name  = null;
    }

    /** return value containers for primary expression.
	need only be allocated once per parser. */
    static PrimarySuffixReturnValue suffix = new PrimarySuffixReturnValue();
    static PrimaryPrefixReturnValue prefix = new PrimaryPrefixReturnValue();

/*****************************************
 * THE JAVA LANGUAGE GRAMMAR STARTS HERE *
 *****************************************/

/*
 * Program structuring syntax follows.
 */
  static final public CompilationUnit CompilationUnit() throws ParseException {
    CompilationUnit result;
    PackageSpecification        ps  = null;
    ImportMutableList           il  = new ImportArrayList();
    Import                      imp;
    TypeDeclarationMutableList  tdl = new TypeDeclarationArrayList();
    TypeDeclaration             td;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PACKAGE:
      ps = PackageDeclaration();
      break;
    default:
      jj_la1[0] = jj_gen;
      ;
    }
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMPORT:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_1;
      }
      imp = ImportDeclaration();
      if (imp != null) il.add(imp);
    }
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case CLASS:
      case FINAL:
      case INTERFACE:
      case PUBLIC:
      case STRICTFP:
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      td = TypeDeclaration();
      if (td != null) tdl.add(td);
    }
    jj_consume_token(0);
    result = factory.createCompilationUnit(ps, il, tdl);
    checkConstruction(result);
    setPostfixInfo(result);
    setPrefixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public PackageSpecification PackageDeclaration() throws ParseException {
    PackageSpecification result;
    UncollatedReferenceQualifier qn;
    jj_consume_token(PACKAGE);
          result = factory.createPackageSpecification();
          setPrefixInfo(result);
    qn = Name();
    jj_consume_token(SEMICOLON);
    result.setPackageReference(qn.toPackageReference());
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Import ImportDeclaration() throws ParseException {
    Import result;
    UncollatedReferenceQualifier qn;
    String hs = null;
    boolean wildcard = false;
    jj_consume_token(IMPORT);
      result = factory.createImport();
      setPrefixInfo(result);
    qn = Name();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOT:
      jj_consume_token(DOT);
      jj_consume_token(STAR);
                              wildcard = true;
      break;
    default:
      jj_la1[3] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    // "*" will be thrown away immediately since the package name is sufficient
      result.setMultiImport(wildcard);
      if (wildcard) {
          result.setReference(qn);
      } else {
          result.setReference(qn.toTypeReference());
      }
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public TypeDeclaration TypeDeclaration() throws ParseException {
    TypeDeclaration result = null;
    if (jj_2_1(2147483647)) {
      result = ClassDeclaration();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case INTERFACE:
      case PUBLIC:
      case STRICTFP:
        result = InterfaceDeclaration();
        break;
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[4] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    if (result != null) {
        checkConstruction(result);
        setPostfixInfo(result);
    }
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

/*
 * Declaration syntax follows.
 */
  static final public ClassDeclaration ClassDeclaration() throws ParseException {
  ClassDeclaration    result = null;
  ModifierMutableList ml = new ModifierArrayList();
  Modifier            m;
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case FINAL:
      case PUBLIC:
      case STRICTFP:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_3;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                     m = factory.createAbstract();
        break;
      case FINAL:
        jj_consume_token(FINAL);
                     m = factory.createFinal();
        break;
      case PUBLIC:
        jj_consume_token(PUBLIC);
                     m = factory.createPublic();
        break;
      case STRICTFP:
        jj_consume_token(STRICTFP);
                     m = factory.createStrictFp();
        break;
      default:
        jj_la1[6] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        setPrefixInfo(m);
        setPostfixInfo(m);
        ml.add(m);
    }
    result = UnmodifiedClassDeclaration();
    result.setModifiers(ml);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ClassDeclaration UnmodifiedClassDeclaration() throws ParseException {
  ClassDeclaration                 result;
  UncollatedReferenceQualifier     qn;
  UncollatedReferenceQualifierList nl;
  MemberDeclarationMutableList     mdl;
  Extends ex;
  Implements im;
    jj_consume_token(CLASS);
      result = factory.createClassDeclaration();
      setPrefixInfo(result);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
          Identifier id = factory.createIdentifier(token.image);
          setPrefixInfo(id);
          setPostfixInfo(id);
          result.setIdentifier(id);
      break;
    case IMPLICITIDENTIFIER:
      jj_consume_token(IMPLICITIDENTIFIER);
          id = factory.createImplicitIdentifier(token.image);
          setPrefixInfo(id);
          setPostfixInfo(id);
          result.setIdentifier(id);
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXTENDS:
      jj_consume_token(EXTENDS);
          ex = factory.createExtends();
          setPrefixInfo(ex);
      qn = Name();
          ex.setSupertypes(new TypeReferenceArrayList(qn.toTypeReference()));
          result.setExtendedTypes(ex);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IMPLEMENTS:
      jj_consume_token(IMPLEMENTS);
          im = factory.createImplements();
          setPrefixInfo(im);
      nl = NameList();
          TypeReferenceMutableList trl = new TypeReferenceArrayList();
          for (int i = 0, s = nl.size(); i < s; i++) {
              TypeReference tr =
                  nl.getUncollatedReferenceQualifier(i).toTypeReference();
              trl.add(tr);
          }
          im.setSupertypes(trl);
          result.setImplementedTypes(im);
      break;
    default:
      jj_la1[9] = jj_gen;
      ;
    }
    mdl = ClassBody();
    result.setMembers(mdl);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MemberDeclarationMutableList ClassBody() throws ParseException {
  MemberDeclarationMutableList result = new MemberDeclarationArrayList();
  MemberDeclaration md;
    jj_consume_token(LBRACE);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case CLASS:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case INTERFACE:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case TRANSIENT:
      case VOID:
      case VOLATILE:
      case STRICTFP:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
      case LBRACE:
        ;
        break;
      default:
        jj_la1[10] = jj_gen;
        break label_4;
      }
      md = ClassBodyDeclaration();
        result.add(md);
    }
    jj_consume_token(RBRACE);
    checkConstruction(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ClassDeclaration NestedClassDeclaration() throws ParseException {
  ClassDeclaration result;
  ModifierMutableList ml = new ModifierArrayList();
  Modifier m;
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case FINAL:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case STATIC:
      case STRICTFP:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_5;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STATIC:
        jj_consume_token(STATIC);
                      m = factory.createStatic();
        break;
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                      m = factory.createAbstract();
        break;
      case FINAL:
        jj_consume_token(FINAL);
                      m = factory.createFinal();
        break;
      case PUBLIC:
        jj_consume_token(PUBLIC);
                      m = factory.createPublic();
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
                      m = factory.createProtected();
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
                      m = factory.createPrivate();
        break;
      case STRICTFP:
        jj_consume_token(STRICTFP);
                      m = factory.createStrictFp();
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        setPrefixInfo(m);
        setPostfixInfo(m);
        ml.add(m);
    }
    result = UnmodifiedClassDeclaration();
    result.setModifiers(ml);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MemberDeclaration ClassBodyDeclaration() throws ParseException {
  MemberDeclaration result;
    if (jj_2_2(2)) {
      result = Initializer();
    } else if (jj_2_3(2147483647)) {
      result = NestedClassDeclaration();
      label_6:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[13] = jj_gen;
          break label_6;
        }
        jj_consume_token(SEMICOLON);
      }
    } else if (jj_2_4(2147483647)) {
      result = NestedInterfaceDeclaration();
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[14] = jj_gen;
          break label_7;
        }
        jj_consume_token(SEMICOLON);
      }
    } else if (jj_2_5(2147483647)) {
      result = ConstructorDeclaration();
      label_8:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[15] = jj_gen;
          break label_8;
        }
        jj_consume_token(SEMICOLON);
      }
    } else if (jj_2_6(2147483647)) {
      result = MethodDeclaration();
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[16] = jj_gen;
          break label_9;
        }
        jj_consume_token(SEMICOLON);
      }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case TRANSIENT:
      case VOLATILE:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
        result = FieldDeclaration();
        label_10:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            ;
            break;
          default:
            jj_la1[17] = jj_gen;
            break label_10;
          }
          jj_consume_token(SEMICOLON);
        }
        break;
      default:
        jj_la1[18] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

// This production is to determine lookahead only.
  static final public void MethodDeclarationLookahead() throws ParseException {
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case FINAL:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case STATIC:
      case SYNCHRONIZED:
      case STRICTFP:
        ;
        break;
      default:
        jj_la1[19] = jj_gen;
        break label_11;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PUBLIC:
        jj_consume_token(PUBLIC);
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
        break;
      case STATIC:
        jj_consume_token(STATIC);
        break;
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
        break;
      case FINAL:
        jj_consume_token(FINAL);
        break;
      case NATIVE:
        jj_consume_token(NATIVE);
        break;
      case SYNCHRONIZED:
        jj_consume_token(SYNCHRONIZED);
        break;
      case STRICTFP:
        jj_consume_token(STRICTFP);
        break;
      default:
        jj_la1[20] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    ResultType();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
      break;
    case IMPLICITIDENTIFIER:
      jj_consume_token(IMPLICITIDENTIFIER);
      break;
    default:
      jj_la1[21] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(LPAREN);
  }

  static final public InterfaceDeclaration InterfaceDeclaration() throws ParseException {
  InterfaceDeclaration result;
  ModifierMutableList ml = new ModifierArrayList();
  Modifier m;
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case PUBLIC:
      case STRICTFP:
        ;
        break;
      default:
        jj_la1[22] = jj_gen;
        break label_12;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                      m = factory.createAbstract();
        break;
      case PUBLIC:
        jj_consume_token(PUBLIC);
                      m = factory.createPublic();
        break;
      case STRICTFP:
        jj_consume_token(STRICTFP);
                      m = factory.createStrictFp();
        break;
      default:
        jj_la1[23] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        setPrefixInfo(m);
        setPostfixInfo(m);
        ml.add(m);
    }
    result = UnmodifiedInterfaceDeclaration();
    result.setModifiers(ml);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public InterfaceDeclaration NestedInterfaceDeclaration() throws ParseException {
  InterfaceDeclaration result;
  ModifierMutableList ml = new ModifierArrayList();
  Modifier m;
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case FINAL:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case STATIC:
      case STRICTFP:
        ;
        break;
      default:
        jj_la1[24] = jj_gen;
        break label_13;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STATIC:
        jj_consume_token(STATIC);
                      m = factory.createStatic();
        break;
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                      m = factory.createAbstract();
        break;
      case FINAL:
        jj_consume_token(FINAL);
                      m = factory.createFinal();
        break;
      case PUBLIC:
        jj_consume_token(PUBLIC);
                      m = factory.createPublic();
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
                      m = factory.createProtected();
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
                      m = factory.createPrivate();
        break;
      case STRICTFP:
        jj_consume_token(STRICTFP);
                      m = factory.createStrictFp();
        break;
      default:
        jj_la1[25] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        setPrefixInfo(m);
        setPostfixInfo(m);
        ml.add(m);
    }
    result = UnmodifiedInterfaceDeclaration();
    result.setModifiers(ml);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public InterfaceDeclaration UnmodifiedInterfaceDeclaration() throws ParseException {
    InterfaceDeclaration             result;
    UncollatedReferenceQualifierList nl;
    MemberDeclarationMutableList     mdl = new MemberDeclarationArrayList();
    MemberDeclaration                md;
    Extends ex;
    jj_consume_token(INTERFACE);
      result = factory.createInterfaceDeclaration();
      setPrefixInfo(result);
    jj_consume_token(IDENTIFIER);
      Identifier id = factory.createIdentifier(token.image);
      setPrefixInfo(id);
      setPostfixInfo(id);
      result.setIdentifier(id);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXTENDS:
      jj_consume_token(EXTENDS);
          ex = factory.createExtends();
          setPrefixInfo(ex);
      nl = NameList();
          TypeReferenceMutableList trl = new TypeReferenceArrayList();
          for (int i = 0, s = nl.size(); i < s; i++) {
              TypeReference tr =
                  nl.getUncollatedReferenceQualifier(i).toTypeReference();
              trl.add(tr);
          }
          ex.setSupertypes(trl);
          result.setExtendedTypes(ex);
      break;
    default:
      jj_la1[26] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case CLASS:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case INTERFACE:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case TRANSIENT:
      case VOID:
      case VOLATILE:
      case STRICTFP:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
        ;
        break;
      default:
        jj_la1[27] = jj_gen;
        break label_14;
      }
      md = InterfaceMemberDeclaration();
        mdl.add(md);
    }
    jj_consume_token(RBRACE);
    result.setMembers(mdl);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MemberDeclaration InterfaceMemberDeclaration() throws ParseException {
    MemberDeclaration result;
    if (jj_2_7(2147483647)) {
      result = NestedClassDeclaration();
      label_15:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[28] = jj_gen;
          break label_15;
        }
        jj_consume_token(SEMICOLON);
      }
    } else if (jj_2_8(2147483647)) {
      result = NestedInterfaceDeclaration();
      label_16:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[29] = jj_gen;
          break label_16;
        }
        jj_consume_token(SEMICOLON);
      }
    } else if (jj_2_9(2147483647)) {
      result = MethodDeclaration();
      label_17:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[30] = jj_gen;
          break label_17;
        }
        jj_consume_token(SEMICOLON);
      }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case TRANSIENT:
      case VOLATILE:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
        result = FieldDeclaration();
        label_18:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            ;
            break;
          default:
            jj_la1[31] = jj_gen;
            break label_18;
          }
          jj_consume_token(SEMICOLON);
        }
        break;
      default:
        jj_la1[32] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public FieldDeclaration FieldDeclaration() throws ParseException {
    FieldDeclaration result;
    ModifierMutableList ml = new ModifierArrayList();
    Modifier m = null;
    TypeReference tr;
    FieldSpecificationMutableList vl = new FieldSpecificationArrayList();
    VariableSpecification var;
    label_19:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FINAL:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case STATIC:
      case TRANSIENT:
      case VOLATILE:
        ;
        break;
      default:
        jj_la1[33] = jj_gen;
        break label_19;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PUBLIC:
        jj_consume_token(PUBLIC);
                      m = factory.createPublic();
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
                      m = factory.createProtected();
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
                      m = factory.createPrivate();
        break;
      case STATIC:
        jj_consume_token(STATIC);
                      m = factory.createStatic();
        break;
      case FINAL:
        jj_consume_token(FINAL);
                      m = factory.createFinal();
        break;
      case TRANSIENT:
        jj_consume_token(TRANSIENT);
                      m = factory.createTransient();
        break;
      case VOLATILE:
        jj_consume_token(VOLATILE);
                      m = factory.createVolatile();
        break;
      default:
        jj_la1[34] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        setPrefixInfo(m);
        setPostfixInfo(m);
        ml.add(m);
    }
    tr = Type();
    result = factory.createFieldDeclaration();
    result.setModifiers(ml);
    result.setTypeReference(tr);
    var = VariableDeclarator(true);
          vl.add((FieldSpecification)var);
    label_20:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[35] = jj_gen;
        break label_20;
      }
      jj_consume_token(COMMA);
      var = VariableDeclarator(true);
          vl.add((FieldSpecification)var);
    }
    jj_consume_token(SEMICOLON);
    result.setFieldSpecifications(vl);
    //    setPrefixInfo(result);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public VariableSpecification VariableDeclarator(boolean isForField) throws ParseException {
    Identifier id;
    int dim = 0;
    Expression init = null;
    VariableSpecification result;
    id = VariableDeclaratorId();
                                  dim = tmpDimension;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
      init = VariableInitializer();
      break;
    default:
      jj_la1[36] = jj_gen;
      ;
    }
    if (isForField) {
        result = factory.createFieldSpecification(id, dim, init);
    } else {
        result = factory.createVariableSpecification(id, dim, init);
    }
    //    setPrefixInfo(result); // only after "=" !!!!!!!!!!!!!!!
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Identifier VariableDeclaratorId() throws ParseException {
    Identifier result;
    jj_consume_token(IDENTIFIER);
    result = factory.createIdentifier(token.image);
    setPrefixInfo(result);
    setPostfixInfo(result);
    tmpDimension = 0;
    label_21:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        ;
        break;
      default:
        jj_la1[37] = jj_gen;
        break label_21;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
              tmpDimension++;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    //setPrefixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression VariableInitializer() throws ParseException {
  Expression result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      result = ArrayInitializer();
      break;
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case BANG:
    case TILDE:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case 126:
      result = Expression();
      break;
    default:
      jj_la1[38] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ArrayInitializer ArrayInitializer() throws ParseException {
    ArrayInitializer result;
    ExpressionMutableList el = new ExpressionArrayList();
    Expression init;
    jj_consume_token(LBRACE);
        result = factory.createArrayInitializer();
        setPrefixInfo(result);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case LBRACE:
    case BANG:
    case TILDE:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case 126:
      init = VariableInitializer();
      el.add(init);
      label_22:
      while (true) {
        if (jj_2_10(2)) {
          ;
        } else {
          break label_22;
        }
        jj_consume_token(COMMA);
        init = VariableInitializer();
      el.add(init);
      }
      break;
    default:
      jj_la1[39] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      break;
    default:
      jj_la1[40] = jj_gen;
      ;
    }
    jj_consume_token(RBRACE);
    result.setArguments(el);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MethodDeclaration MethodDeclaration() throws ParseException {
  ModifierMutableList ml = new ModifierArrayList();
  Modifier m = null;
  TypeReference tr;
  UncollatedReferenceQualifierMutableList nl = null;
  Throws th = null;
  StatementBlock body = null;
  MethodDeclaration result;
    label_23:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case FINAL:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case STATIC:
      case SYNCHRONIZED:
      case STRICTFP:
        ;
        break;
      default:
        jj_la1[41] = jj_gen;
        break label_23;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PUBLIC:
        jj_consume_token(PUBLIC);
                         m = factory.createPublic();
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
                         m = factory.createProtected();
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
                         m = factory.createPrivate();
        break;
      case STATIC:
        jj_consume_token(STATIC);
                         m = factory.createStatic();
        break;
      case FINAL:
        jj_consume_token(FINAL);
                         m = factory.createFinal();
        break;
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                         m = factory.createAbstract();
        break;
      case NATIVE:
        jj_consume_token(NATIVE);
                         m = factory.createNative();
        break;
      case SYNCHRONIZED:
        jj_consume_token(SYNCHRONIZED);
                         m = factory.createSynchronized();
        break;
      case STRICTFP:
        jj_consume_token(STRICTFP);
                         m = factory.createStrictFp();
        break;
      default:
        jj_la1[42] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        setPrefixInfo(m);
        setPostfixInfo(m);
        ml.add(m);
    }
    tr = ResultType();
    result = MethodDeclarator(tr);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case THROWS:
      jj_consume_token(THROWS);
      th = factory.createThrows();
      setPrefixInfo(th);
      nl = NameList();
      break;
    default:
      jj_la1[43] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      body = Block();
      break;
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[44] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      if (nl != null) {
          TypeReferenceMutableList trl = new TypeReferenceArrayList();
          for (int i = 0, s = nl.size(); i < s; i++) {
              trl.add(nl.getUncollatedReferenceQualifier(i).toTypeReference());
          }
          th.setExceptions(trl);
          //  Throws th = factory.createThrows(trl);
          result.setThrown(th);
      }
      result.setModifiers(ml);
      result.setBody(body);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MethodDeclaration MethodDeclarator(TypeReference tr) throws ParseException {
    Identifier                      id;
    ParameterDeclarationMutableList pdl;
    MethodDeclaration               result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
    id = factory.createIdentifier(token.image); setPrefixInfo(id); setPostfixInfo(id);
      break;
    case IMPLICITIDENTIFIER:
      jj_consume_token(IMPLICITIDENTIFIER);
    id = factory.createImplicitIdentifier(token.image); setPrefixInfo(id); setPostfixInfo(id);
      break;
    default:
      jj_la1[45] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    pdl = FormalParameters();
    label_24:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        ;
        break;
      default:
        jj_la1[46] = jj_gen;
        break label_24;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
      if (tr != null) { tr.setDimensions(tr.getDimensions()+1); }
    }
      result = factory.createMethodDeclaration();
      result.setIdentifier(id);
      result.setTypeReference(tr);
      result.setParameters(pdl);
      checkConstruction(result);
      setPostfixInfo(result);
      setPrefixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ParameterDeclarationMutableList FormalParameters() throws ParseException {
    ParameterDeclaration pd;
    ParameterDeclarationMutableList result = new ParameterDeclarationArrayList();
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FINAL:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
      pd = FormalParameter();
                                       result.add(pd);
      label_25:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[47] = jj_gen;
          break label_25;
        }
        jj_consume_token(COMMA);
        pd = FormalParameter();
                                       result.add(pd);
      }
      break;
    default:
      jj_la1[48] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
      checkConstruction(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ParameterDeclaration FormalParameter() throws ParseException {
    Identifier id;
    int dim;
    TypeReference tr;
    Modifier mod = null;
    VariableSpecification vspec;
    ParameterDeclaration result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FINAL:
      jj_consume_token(FINAL);
              mod = factory.createFinal(); setPrefixInfo(mod);
      break;
    default:
      jj_la1[49] = jj_gen;
      ;
    }
    tr = Type();
    id = VariableDeclaratorId();
                                dim = tmpDimension;
      result = factory.createParameterDeclaration(tr, id);
      if (mod != null) {
          ModifierMutableList ml = new ModifierArrayList();
          ml.add(mod);
          result.setModifiers(ml);
      }
      vspec = result.getVariables().getVariableSpecification(0);
      vspec.setDimensions(dim);
      checkConstruction(result);
      setPostfixInfo(result);
      setPrefixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ConstructorDeclaration ConstructorDeclaration() throws ParseException {
    ConstructorDeclaration          result;
    Modifier                        m = null;
    Identifier                      id;
    ParameterDeclarationMutableList pdl;
    UncollatedReferenceQualifierMutableList nl = null;
    SpecialConstructorReference     scr = null;
    StatementBlock                  body;
    StatementMutableList            stats = new StatementArrayList();
    Statement                       stat;
     result = factory.createConstructorDeclaration();
     setPrefixInfo(result);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRIVATE:
    case PROTECTED:
    case PUBLIC:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PUBLIC:
        jj_consume_token(PUBLIC);
                         m = factory.createPublic();
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
                         m = factory.createProtected();
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
                         m = factory.createPrivate();
        break;
      default:
        jj_la1[50] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
          setPrefixInfo(m);
          setPostfixInfo(m);
      break;
    default:
      jj_la1[51] = jj_gen;
      ;
    }
    jj_consume_token(IDENTIFIER);
      id = factory.createIdentifier(token.image);
      setPrefixInfo(id);
      setPostfixInfo(id);
    pdl = FormalParameters();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case THROWS:
      jj_consume_token(THROWS);
      nl = NameList();
      break;
    default:
      jj_la1[52] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
      body = factory.createStatementBlock();
      setPrefixInfo(body);
      body.setBody(stats);
    if (jj_2_11(2147483647)) {
      scr = ExplicitConstructorInvocation();
        stats.add(scr);
    } else {
      ;
    }
    label_26:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CLASS:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FINAL:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case LONG:
      case METHODFRAME:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
      case LPAREN:
      case LBRACE:
      case SEMICOLON:
      case INCR:
      case DECR:
      case 126:
      case 127:
        ;
        break;
      default:
        jj_la1[53] = jj_gen;
        break label_26;
      }
      stat = BlockStatement();
        stats.add(stat);
    }
    jj_consume_token(RBRACE);
      result.setIdentifier(id);
      result.setParameters(pdl);
      if (m != null) {
          ModifierMutableList ml = new ModifierArrayList(1);
          ml.add(m);
          result.setModifiers(ml);
      }
      if (nl != null) {
          int s = nl.size();
          TypeReferenceMutableList trl = new TypeReferenceArrayList(s);
          for (int i = 0; i < s; i++) {
              trl.add(nl.getUncollatedReferenceQualifier(i).toTypeReference());
          }
          Throws th = factory.createThrows(trl);
          setPrefixInfo(th);
          result.setThrown(th);
      }
      result.setBody(body);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public SpecialConstructorReference ExplicitConstructorInvocation() throws ParseException {
    SpecialConstructorReference result;
    ExpressionMutableList args;
    Expression expr = null;
    if (jj_2_13(2147483647)) {
      jj_consume_token(THIS);
     result = factory.createThisConstructorReference(); setPrefixInfo(result);
      args = Arguments();
      jj_consume_token(SEMICOLON);
    result.setArguments(args);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case SHORT:
      case SUPER:
      case THIS:
      case TRUE:
      case VOID:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
      case LPAREN:
      case 126:
        if (jj_2_12(2)) {
          expr = PrimaryExpression();
          jj_consume_token(DOT);
        } else {
          ;
        }
        jj_consume_token(SUPER);
     result = factory.createSuperConstructorReference(); setPrefixInfo(result);
        args = Arguments();
        jj_consume_token(SEMICOLON);
    result.setArguments(args);
    ((SuperConstructorReference)result).setReferencePrefix((ReferencePrefix)expr);
        break;
      default:
        jj_la1[54] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ClassInitializer Initializer() throws ParseException {
  ClassInitializer result;
  ModifierMutableList ml = null;
  StatementBlock block;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STATIC:
      jj_consume_token(STATIC);
      ml = new ModifierArrayList();
      Static s = factory.createStatic();
      setPrefixInfo(s);
      setPostfixInfo(s);
      ml.add(s);
      break;
    default:
      jj_la1[55] = jj_gen;
      ;
    }
    block = Block();
    result = factory.createClassInitializer(block);
    setPrefixInfo(result);
    if (ml != null) {
      result.setModifiers(ml);
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

/*
 * Type, name and expression syntax follows.
 */
  static final public TypeReference Type() throws ParseException {
  TypeReference result;
  UncollatedReferenceQualifier qn;
  int dimension = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
      result = PrimitiveType();
      break;
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
      qn = Name();
        result = qn.toTypeReference();
      break;
    default:
      jj_la1[56] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_27:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        ;
        break;
      default:
        jj_la1[57] = jj_gen;
        break label_27;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
              if (dimension == 0) setPrefixInfo(result); dimension++;
    }
      result.setDimensions(dimension);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public TypeReference PrimitiveType() throws ParseException {
    TypeReference result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
      jj_consume_token(BOOLEAN);
      break;
    case CHAR:
      jj_consume_token(CHAR);
      break;
    case BYTE:
      jj_consume_token(BYTE);
      break;
    case SHORT:
      jj_consume_token(SHORT);
      break;
    case INT:
      jj_consume_token(INT);
      break;
    case LONG:
      jj_consume_token(LONG);
      break;
    case FLOAT:
      jj_consume_token(FLOAT);
      break;
    case DOUBLE:
      jj_consume_token(DOUBLE);
      break;
    default:
      jj_la1[58] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    Identifier id = factory.createIdentifier(token.image);
    setPrefixInfo(id);
    setPostfixInfo(id);
    result = factory.createTypeReference(id);
    checkConstruction(result);
    setPostfixInfo(result);
    //    setPrefixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public TypeReference ResultType() throws ParseException {
  TypeReference result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VOID:
      jj_consume_token(VOID);
    Identifier id = factory.createIdentifier(token.image);
    setPrefixInfo(id);
    setPostfixInfo(id);
    result = factory.createTypeReference(id);
    setPrefixInfo(result);
      break;
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
      result = Type();
      break;
    default:
      jj_la1[59] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public UncollatedReferenceQualifier Name() throws ParseException {
  UncollatedReferenceQualifier result;
  Identifier id;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
    id = factory.createIdentifier(token.image);
    setPrefixInfo(id);
    setPostfixInfo(id);
    result = factory.createUncollatedReferenceQualifier(id);
      break;
    case IMPLICITIDENTIFIER:
      jj_consume_token(IMPLICITIDENTIFIER);
    id = factory.createImplicitIdentifier(token.image);
    setPrefixInfo(id);
    setPostfixInfo(id);
    result = factory.createUncollatedReferenceQualifier(id);
      break;
    default:
      jj_la1[60] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_28:
    while (true) {
      if (jj_2_14(2)) {
        ;
      } else {
        break label_28;
      }
      jj_consume_token(DOT);
                       setPrefixInfo(result);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
        id = factory.createIdentifier(token.image);
        break;
      case IMPLICITIDENTIFIER:
        jj_consume_token(IMPLICITIDENTIFIER);
        id = factory.createImplicitIdentifier(token.image);
        break;
      default:
        jj_la1[61] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      setPrefixInfo(id);
      setPostfixInfo(id);
      result = factory.createUncollatedReferenceQualifier(result, id);
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public UncollatedReferenceQualifierMutableList NameList() throws ParseException {
  UncollatedReferenceQualifierMutableList result =
      new UncollatedReferenceQualifierArrayList(2);
  UncollatedReferenceQualifier qn;
    qn = Name();
    result.add(qn);
    label_29:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[62] = jj_gen;
        break label_29;
      }
      jj_consume_token(COMMA);
      qn = Name();
      result.add(qn);
    }
    checkConstruction(result);
/*    setPostfixInfo(result);*/
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

/*
 * Expression syntax follows.
 */
  static final public Expression Expression() throws ParseException {
    Expression result;
    Expression expr;
    Assignment op;
    ExpressionMutableList leftRight = new ExpressionArrayList(2);
    result = ConditionalExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
    case PLUSASSIGN:
    case MINUSASSIGN:
    case STARASSIGN:
    case SLASHASSIGN:
    case ANDASSIGN:
    case ORASSIGN:
    case XORASSIGN:
    case REMASSIGN:
    case LSHIFTASSIGN:
    case RSIGNEDSHIFTASSIGN:
    case RUNSIGNEDSHIFTASSIGN:
      op = AssignmentOperator();
      expr = Expression();
        leftRight.add(result);
        leftRight.add(expr);
        op.setArguments(leftRight);
        result = op;
      break;
    default:
      jj_la1[63] = jj_gen;
      ;
    }
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Assignment AssignmentOperator() throws ParseException {
    Assignment result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
               result = factory.createCopyAssignment();
      break;
    case STARASSIGN:
      jj_consume_token(STARASSIGN);
               result = factory.createTimesAssignment();
      break;
    case SLASHASSIGN:
      jj_consume_token(SLASHASSIGN);
               result = factory.createDivideAssignment();
      break;
    case REMASSIGN:
      jj_consume_token(REMASSIGN);
               result = factory.createModuloAssignment();
      break;
    case PLUSASSIGN:
      jj_consume_token(PLUSASSIGN);
               result = factory.createPlusAssignment();
      break;
    case MINUSASSIGN:
      jj_consume_token(MINUSASSIGN);
               result = factory.createMinusAssignment();
      break;
    case LSHIFTASSIGN:
      jj_consume_token(LSHIFTASSIGN);
               result = factory.createShiftLeftAssignment();
      break;
    case RSIGNEDSHIFTASSIGN:
      jj_consume_token(RSIGNEDSHIFTASSIGN);
               result = factory.createShiftRightAssignment();
      break;
    case RUNSIGNEDSHIFTASSIGN:
      jj_consume_token(RUNSIGNEDSHIFTASSIGN);
               result = factory.createUnsignedShiftRightAssignment();
      break;
    case ANDASSIGN:
      jj_consume_token(ANDASSIGN);
               result = factory.createBinaryAndAssignment();
      break;
    case XORASSIGN:
      jj_consume_token(XORASSIGN);
               result = factory.createBinaryXOrAssignment();
      break;
    case ORASSIGN:
      jj_consume_token(ORASSIGN);
               result = factory.createBinaryOrAssignment();
      break;
    default:
      jj_la1[64] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    checkConstruction(result);
    setPostfixInfo(result);
    setPrefixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression ConditionalExpression() throws ParseException {
    Expression result;
    Expression expr1;
    Expression expr2;
    Operator op;
    result = ConditionalOrExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HOOK:
      jj_consume_token(HOOK);
          op = factory.createConditional(); setPrefixInfo(op);
      expr1 = Expression();
      jj_consume_token(COLON);
      expr2 = ConditionalExpression();
        ExpressionMutableList args = new ExpressionArrayList(3);
        args.add(result);
        args.add(expr1);
        args.add(expr2);
        op.setArguments(args);
        result = op;
      break;
    default:
      jj_la1[65] = jj_gen;
      ;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression ConditionalOrExpression() throws ParseException {
    Expression result;
    Expression expr;
    Operator op;
    result = ConditionalAndExpression();
    label_30:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SC_OR:
        ;
        break;
      default:
        jj_la1[66] = jj_gen;
        break label_30;
      }
      jj_consume_token(SC_OR);
           op = factory.createLogicalOr(); setPrefixInfo(op);
      expr = ConditionalAndExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        op.setArguments(args);
        result = op;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression ConditionalAndExpression() throws ParseException {
    Expression result;
    Expression expr;
    Operator op;
    result = InclusiveOrExpression();
    label_31:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SC_AND:
        ;
        break;
      default:
        jj_la1[67] = jj_gen;
        break label_31;
      }
      jj_consume_token(SC_AND);
           op = factory.createLogicalAnd(); setPrefixInfo(op);
      expr = InclusiveOrExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        op.setArguments(args);
        result = op;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression InclusiveOrExpression() throws ParseException {
    Expression result;
    Expression expr;
    Operator op;
    result = ExclusiveOrExpression();
    label_32:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BIT_OR:
        ;
        break;
      default:
        jj_la1[68] = jj_gen;
        break label_32;
      }
      jj_consume_token(BIT_OR);
          op = factory.createBinaryOr(); setPrefixInfo(op);
      expr = ExclusiveOrExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        op.setArguments(args);
        result = op;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression ExclusiveOrExpression() throws ParseException {
    Expression result;
    Expression expr;
    Operator op;
    result = AndExpression();
    label_33:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case XOR:
        ;
        break;
      default:
        jj_la1[69] = jj_gen;
        break label_33;
      }
      jj_consume_token(XOR);
          op = factory.createBinaryXOr(); setPrefixInfo(op);
      expr = AndExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        op.setArguments(args);
        result = op;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression AndExpression() throws ParseException {
    Expression result;
    Expression expr;
    Operator op;
    result = EqualityExpression();
    label_34:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BIT_AND:
        ;
        break;
      default:
        jj_la1[70] = jj_gen;
        break label_34;
      }
      jj_consume_token(BIT_AND);
          op = factory.createBinaryAnd(); setPrefixInfo(op);
      expr = EqualityExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        op.setArguments(args);
        result = op;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression EqualityExpression() throws ParseException {
    Expression result;
    Expression expr;
    Operator cmp;
    result = InstanceOfExpression();
    label_35:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
      case NE:
        ;
        break;
      default:
        jj_la1[71] = jj_gen;
        break label_35;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
        jj_consume_token(EQ);
               cmp = factory.createEquals(); setPrefixInfo(cmp);
        break;
      case NE:
        jj_consume_token(NE);
               cmp = factory.createNotEquals(); setPrefixInfo(cmp);
        break;
      default:
        jj_la1[72] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expr = InstanceOfExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        cmp.setArguments(args);
        result = cmp;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression InstanceOfExpression() throws ParseException {
    Expression result;
    TypeReference tr;
    result = RelationalExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INSTANCEOF:
      jj_consume_token(INSTANCEOF);
      tr = Type();
        result = factory.createInstanceof(result, tr);
        setPrefixInfo(result);
      break;
    default:
      jj_la1[73] = jj_gen;
      ;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression RelationalExpression() throws ParseException {
    Expression result;
    Operator cmp;
    Expression expr;
    result = ShiftExpression();
    label_36:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GT:
      case LT:
      case LE:
      case GE:
        ;
        break;
      default:
        jj_la1[74] = jj_gen;
        break label_36;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
               cmp = factory.createLessThan(); setPrefixInfo(cmp);
        break;
      case GT:
        jj_consume_token(GT);
               cmp = factory.createGreaterThan(); setPrefixInfo(cmp);
        break;
      case LE:
        jj_consume_token(LE);
               cmp = factory.createLessOrEquals(); setPrefixInfo(cmp);
        break;
      case GE:
        jj_consume_token(GE);
               cmp = factory.createGreaterOrEquals(); setPrefixInfo(cmp);
        break;
      default:
        jj_la1[75] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expr = ShiftExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        cmp.setArguments(args);
        result = cmp;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression ShiftExpression() throws ParseException {
    Expression result;
    Operator shift;
    Expression expr;
    result = AdditiveExpression();
    label_37:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LSHIFT:
      case RSIGNEDSHIFT:
      case RUNSIGNEDSHIFT:
        ;
        break;
      default:
        jj_la1[76] = jj_gen;
        break label_37;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LSHIFT:
        jj_consume_token(LSHIFT);
                shift = factory.createShiftLeft(); setPrefixInfo(shift);
        break;
      case RSIGNEDSHIFT:
        jj_consume_token(RSIGNEDSHIFT);
                shift = factory.createShiftRight(); setPrefixInfo(shift);
        break;
      case RUNSIGNEDSHIFT:
        jj_consume_token(RUNSIGNEDSHIFT);
                shift = factory.createUnsignedShiftRight(); setPrefixInfo(shift);
        break;
      default:
        jj_la1[77] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expr = AdditiveExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        shift.setArguments(args);
        result = shift;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression AdditiveExpression() throws ParseException {
    Expression result;
    Operator add;
    Expression expr;
    result = MultiplicativeExpression();
    label_38:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        ;
        break;
      default:
        jj_la1[78] = jj_gen;
        break label_38;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
              add = factory.createPlus(); setPrefixInfo(add);
        break;
      case MINUS:
        jj_consume_token(MINUS);
              add = factory.createMinus(); setPrefixInfo(add);
        break;
      default:
        jj_la1[79] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expr = MultiplicativeExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        add.setArguments(args);
        result = add;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression MultiplicativeExpression() throws ParseException {
    Expression result = null;
    Operator mult = null;
    Expression expr;
    result = UnaryExpression();
    label_39:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case SLASH:
      case REM:
        ;
        break;
      default:
        jj_la1[80] = jj_gen;
        break label_39;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
        jj_consume_token(STAR);
              mult = factory.createTimes();  setPrefixInfo(mult);
        break;
      case SLASH:
        jj_consume_token(SLASH);
              mult = factory.createDivide(); setPrefixInfo(mult);
        break;
      case REM:
        jj_consume_token(REM);
              mult = factory.createModulo(); setPrefixInfo(mult);
        break;
      default:
        jj_la1[81] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expr = UnaryExpression();
        ExpressionMutableList args = new ExpressionArrayList(2);
        args.add(result);
        args.add(expr);
        mult.setArguments(args);
        result = mult;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression UnaryExpression() throws ParseException {
    Expression result;
    Expression expr;
    boolean negative = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PLUS:
    case MINUS:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
          result = factory.createPositive(); setPrefixInfo(result);
        break;
      case MINUS:
        jj_consume_token(MINUS);
          result = factory.createNegative(); setPrefixInfo(result);
        break;
      default:
        jj_la1[82] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expr = UnaryExpression();
      ((Operator)result).setArguments(new ExpressionArrayList(expr));
      break;
    case INCR:
      result = PreIncrementExpression();
      break;
    case DECR:
      result = PreDecrementExpression();
      break;
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case BANG:
    case TILDE:
    case 126:
      result = UnaryExpressionNotPlusMinus();
      break;
    default:
      jj_la1[83] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public PreIncrement PreIncrementExpression() throws ParseException {
    PreIncrement result;
    Expression expr;
    jj_consume_token(INCR);
      result = factory.createPreIncrement();
      setPrefixInfo(result);
    expr = PrimaryExpression();
      result.setArguments(new ExpressionArrayList(expr));
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public PreDecrement PreDecrementExpression() throws ParseException {
    PreDecrement result;
    Expression expr;
    jj_consume_token(DECR);
      result = factory.createPreDecrement();
      setPrefixInfo(result);
    expr = PrimaryExpression();
      result.setArguments(new ExpressionArrayList(expr));
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression UnaryExpressionNotPlusMinus() throws ParseException {
    Expression result;
    Expression expr;
    boolean    not = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BANG:
    case TILDE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TILDE:
        jj_consume_token(TILDE);
            result = factory.createBinaryNot();  setPrefixInfo(result);
        break;
      case BANG:
        jj_consume_token(BANG);
            result = factory.createLogicalNot(); setPrefixInfo(result);
        break;
      default:
        jj_la1[84] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expr = UnaryExpression();
      ((Operator)result).setArguments(new ExpressionArrayList(expr));
      break;
    default:
      jj_la1[85] = jj_gen;
      if (jj_2_15(2147483647)) {
        result = CastExpression();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FALSE:
        case FLOAT:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case SHORT:
        case SUPER:
        case THIS:
        case TRUE:
        case VOID:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case IMPLICITIDENTIFIER:
        case LPAREN:
        case 126:
          result = PostfixExpression();
          break;
        default:
          jj_la1[86] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
        checkConstruction(result);
        setPostfixInfo(result);
        {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

// This production is to determine lookahead only. The LOOKAHEAD specifications
// below are not used, but they are there just to indicate that we know about
// this.
  static final public void CastLookahead() throws ParseException {
    if (jj_2_16(2147483647)) {
      jj_consume_token(LPAREN);
      PrimitiveType();
      label_40:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACKET:
          ;
          break;
        default:
          jj_la1[87] = jj_gen;
          break label_40;
        }
        jj_consume_token(LBRACKET);
        jj_consume_token(RBRACKET);
      }
      jj_consume_token(RPAREN);
    } else if (jj_2_17(2147483647)) {
      jj_consume_token(LPAREN);
      Name();
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        Name();
        jj_consume_token(RPAREN);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TILDE:
          jj_consume_token(TILDE);
          break;
        case BANG:
          jj_consume_token(BANG);
          break;
        case LPAREN:
          jj_consume_token(LPAREN);
          break;
        case IDENTIFIER:
          jj_consume_token(IDENTIFIER);
          break;
        case THIS:
          jj_consume_token(THIS);
          break;
        case SUPER:
          jj_consume_token(SUPER);
          break;
        case NEW:
          jj_consume_token(NEW);
          break;
        case FALSE:
        case NULL:
        case TRUE:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
          Literal();
          break;
        default:
          jj_la1[88] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[89] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  static final public Expression PostfixExpression() throws ParseException {
    Expression result;
    result = PrimaryExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INCR:
    case DECR:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INCR:
        jj_consume_token(INCR);
        result = factory.createPostIncrement(result);
        setPrefixInfo(result);
        break;
      case DECR:
        jj_consume_token(DECR);
        result = factory.createPostDecrement(result);
        setPrefixInfo(result);
        break;
      default:
        jj_la1[90] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[91] = jj_gen;
      ;
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public TypeCast CastExpression() throws ParseException {
    TypeCast result = null;
    TypeReference tr;
    Expression expr = null;
    result = factory.createTypeCast();
    if (jj_2_18(2147483647)) {
      jj_consume_token(LPAREN);
        setPrefixInfo(result);
      tr = Type();
      jj_consume_token(RPAREN);
      expr = UnaryExpression();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        setPrefixInfo(result);
        tr = Type();
        jj_consume_token(RPAREN);
        expr = UnaryExpressionNotPlusMinus();
        break;
      default:
        jj_la1[92] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      result.setTypeReference(tr);
      result.setArguments(new ExpressionArrayList(expr));
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression PrimaryExpression() throws ParseException {
    Expression result = null;
    ReferencePrefix tmpResult = null;
    prefix = PrimaryPrefix();
      // create initial AST construct from prefix only
      switch (prefix.type) {
      case PrimaryPrefixReturnValue.LITERAL:
          if (prefix.literal instanceof StringLiteral) {
              tmpResult = (StringLiteral)prefix.literal;
          }
          else
          {
              result = prefix.literal;
              checkConstruction(result);
              setPostfixInfo(result);
              {if (true) return result;}
              //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          }
          break;
      case PrimaryPrefixReturnValue.THIS:
          tmpResult = factory.createThisReference();
          setPrefixInfo(tmpResult);
          setPostfixInfo(tmpResult);
          break;
      case PrimaryPrefixReturnValue.SUPER_MEMBER:
          tmpResult = prefix.name;
          break;
      case PrimaryPrefixReturnValue.PARENTHESIZED_EXPR:
          tmpResult = (ParenthesizedExpression)prefix.expr;
          break;
      case PrimaryPrefixReturnValue.ALLOCATION_EXPR:
          tmpResult = (ReferencePrefix)prefix.expr;
          break;
      case PrimaryPrefixReturnValue.CLASS_REF:
          tmpResult = factory.createMetaClassReference(prefix.typeref);
          setPrefixInfo(tmpResult);
          setPostfixInfo(tmpResult);
          break;
      case PrimaryPrefixReturnValue.QUALIFIED_NAME:
          tmpResult = prefix.name;
          break;
      case PrimaryPrefixReturnValue.PASSIVE_EXPR:
          tmpResult = (PassiveExpression)prefix.expr;
          break;
      default:
          {if (true) throw new ParseException("Unknown prefix");}
      }
    label_41:
    while (true) {
      if (jj_2_19(2)) {
        ;
      } else {
        break label_41;
      }
      suffix = PrimarySuffix();
      switch (suffix.type) {
      case PrimarySuffixReturnValue.THIS:
          // the prefix MUST be a type expression!!!!!
          // we currently only create UncollatedReferenceQualifiers
          if (tmpResult instanceof TypeReference) {
              tmpResult =
                 factory.createThisReference((TypeReference)tmpResult);
              setPrefixInfo(tmpResult);
              setPostfixInfo(tmpResult);
          } else if (tmpResult instanceof UncollatedReferenceQualifier) {
              tmpResult =
                 factory.createThisReference(((UncollatedReferenceQualifier)tmpResult).toTypeReference());
              setPrefixInfo(tmpResult);
              setPostfixInfo(tmpResult);
          } else {
              {if (true) throw new ParseException("No type as prefix of `this'");}
          }
          break;
      case PrimarySuffixReturnValue.ALLOCATION_EXPR:
          if (suffix.expr instanceof New) {
              ((New)suffix.expr).setReferencePrefix(tmpResult);
              tmpResult = (New)suffix.expr;
          } else {
              {if (true) throw new ParseException("Allocation without new?");}
          }
          break;
      case PrimarySuffixReturnValue.INDEX_EXPR:
          if (tmpResult instanceof UncollatedReferenceQualifier ||
              tmpResult instanceof MethodReference ||
              tmpResult instanceof ParenthesizedExpression ||
              //tmpResult instanceof ThisReference || // this[i] in array initialization
              tmpResult instanceof VariableReference) {
                  // Now we know that this is an array reference
              ExpressionMutableList indicees = new ExpressionArrayList(1);
              indicees.add(suffix.expr);
              tmpResult =
                  factory.createArrayReference(tmpResult, indicees);
              setPrefixInfo(tmpResult);
              setPostfixInfo(tmpResult);
          } else if (tmpResult instanceof ArrayReference) {
              // we need to add another access dimension
              ((ArrayReference)tmpResult).getDimensionExpressions().add(suffix.expr);
          } else {
              {if (true) throw new ParseException("Bad index context - " +
                                       tmpResult.getClass().getName() + "?!");}
              /*
		e.g. StringLiteral, TypeReference, NewArray
		(would have to be in parentheses), SuperReference, ...
	      */
          }
          break;
      case PrimarySuffixReturnValue.IDENTIFIER:
          tmpResult = factory.createUncollatedReferenceQualifier(tmpResult, suffix.id);
          setPrefixInfo(tmpResult);
          setPostfixInfo(tmpResult);
          break;
      case PrimarySuffixReturnValue.ARGUMENTS:
          // method call -determine the kind of method
          if (tmpResult instanceof UncollatedReferenceQualifier) {
              // this is a normal method call
              tmpResult = factory.createMethodReference
              (((UncollatedReferenceQualifier)tmpResult).getReferencePrefix(),
               ((UncollatedReferenceQualifier)tmpResult).getIdentifier(),
               suffix.args);
              setPrefixInfo(tmpResult);
              setPostfixInfo(tmpResult);
          } else {
              {if (true) throw new ParseException("Arguments without method name?");}
          }
          break;
      default:
          {if (true) throw new ParseException("Unknown primary suffix type");}
      }
    }
      if (tmpResult instanceof UncollatedReferenceQualifier) {
          result = (UncollatedReferenceQualifier)tmpResult;
      } else {
          result = (Expression)tmpResult;
      }
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public PrimaryPrefixReturnValue PrimaryPrefix() throws ParseException {
    // reuses global prefix field
    Literal                      lit;
    Expression                   expr;
    TypeReference                tr;
    UncollatedReferenceQualifier qn;
    SuperReference               supRef = null;
    ParenthesizedExpression      parExpr = null;
    Identifier                   id = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FALSE:
    case NULL:
    case TRUE:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      lit = Literal();
      prefix.type    = prefix.LITERAL;
      prefix.literal = lit;
      break;
    case THIS:
      jj_consume_token(THIS);
      prefix.type = prefix.THIS;
      break;
    case SUPER:
      jj_consume_token(SUPER);
      supRef = factory.createSuperReference();
      setPrefixInfo(supRef);
      setPostfixInfo(supRef);
      jj_consume_token(DOT);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
      id   = factory.createIdentifier(token.image);
        break;
      case IMPLICITIDENTIFIER:
        jj_consume_token(IMPLICITIDENTIFIER);
      id   = factory.createImplicitIdentifier(token.image);
        break;
      default:
        jj_la1[93] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    setPrefixInfo(id);
    setPostfixInfo(id);
    prefix.name =
      factory.createUncollatedReferenceQualifier(supRef, id);
    prefix.type = prefix.SUPER_MEMBER;
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
  parExpr = factory.createParenthesizedExpression();
    setPrefixInfo(parExpr);
      expr = Expression();
      jj_consume_token(RPAREN);
        setPostfixInfo(parExpr);
      parExpr.setArguments(new ExpressionArrayList(expr));
      prefix.expr = parExpr;
      prefix.type = prefix.PARENTHESIZED_EXPR;
      break;
    case 126:
      jj_consume_token(126);
    parExpr = factory.createPassiveExpression();
    setPrefixInfo(parExpr);
      expr = Expression();
      jj_consume_token(RPAREN);
       parExpr.setArguments(new ExpressionArrayList(expr));
       prefix.expr = parExpr;
       prefix.type = prefix.PASSIVE_EXPR;
      break;
    case NEW:
      expr = AllocationExpression();
      prefix.type = prefix.ALLOCATION_EXPR;
      prefix.expr = expr;
      break;
    default:
      jj_la1[94] = jj_gen;
      if (jj_2_20(2147483647)) {
        tr = ResultType();
        jj_consume_token(DOT);
        jj_consume_token(CLASS);
      prefix.type    = prefix.CLASS_REF;
      prefix.typeref = tr;
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
        case IMPLICITIDENTIFIER:
          qn = Name();
      prefix.type = prefix.QUALIFIED_NAME;
      prefix.name = qn;
          break;
        default:
          jj_la1[95] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
      {if (true) return prefix;}
    throw new Error("Missing return statement in function");
  }

  static final public PrimarySuffixReturnValue PrimarySuffix() throws ParseException {
    // reuses global suffix field
    Expression               expr;
    ExpressionMutableList    args;
    Identifier               id;
    Literal                  lit;
    if (jj_2_21(2)) {
      jj_consume_token(DOT);
      jj_consume_token(THIS);
      suffix.type = suffix.THIS;
    } else if (jj_2_22(2)) {
      jj_consume_token(DOT);
      expr = AllocationExpression();
      suffix.type = suffix.ALLOCATION_EXPR;
      suffix.expr = expr;
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        jj_consume_token(LBRACKET);
        expr = Expression();
        jj_consume_token(RBRACKET);
      suffix.type = suffix.INDEX_EXPR;
      suffix.expr = expr;
        break;
      case DOT:
        jj_consume_token(DOT);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          jj_consume_token(IDENTIFIER);
      suffix.id   = factory.createIdentifier(token.image);
          break;
        case IMPLICITIDENTIFIER:
          jj_consume_token(IMPLICITIDENTIFIER);
      suffix.id   = factory.createImplicitIdentifier(token.image);
          break;
        default:
          jj_la1[96] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      suffix.type = suffix.IDENTIFIER;
      setPrefixInfo(suffix.id);
      setPostfixInfo(suffix.id);
        break;
      case LPAREN:
        args = Arguments();
      suffix.type = suffix.ARGUMENTS;
      suffix.args = args;
        break;
      default:
        jj_la1[97] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      {if (true) return suffix;}
    throw new Error("Missing return statement in function");
  }

  static final public Literal Literal() throws ParseException {
    Literal result;
    Expression e;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      jj_consume_token(INTEGER_LITERAL);
      if (token.image.endsWith("L") || token.image.endsWith("l")) {
          result = factory.createLongLiteral(token.image);
      } else {
          result = factory.createIntLiteral(token.image);
      }
      setPrefixInfo(result);
      break;
    case FLOATING_POINT_LITERAL:
      jj_consume_token(FLOATING_POINT_LITERAL);
      if (token.image.endsWith("F") || token.image.endsWith("f")) {
          result = factory.createFloatLiteral(token.image);
      } else {
          result = factory.createDoubleLiteral(token.image);
      }
      setPrefixInfo(result);
      break;
    case CHARACTER_LITERAL:
      jj_consume_token(CHARACTER_LITERAL);
      result = factory.createCharLiteral(token.image);
      setPrefixInfo(result);
      break;
    case STRING_LITERAL:
      jj_consume_token(STRING_LITERAL);
      result = factory.createStringLiteral(token.image);
      setPrefixInfo(result);
      break;
    case FALSE:
    case TRUE:
      result = BooleanLiteral();
      break;
    case NULL:
      result = NullLiteral();
      break;
    default:
      jj_la1[98] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public BooleanLiteral BooleanLiteral() throws ParseException {
    BooleanLiteral result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
           result = factory.createBooleanLiteral(true);
      break;
    case FALSE:
      jj_consume_token(FALSE);
            result = factory.createBooleanLiteral(false);
      break;
    default:
      jj_la1[99] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    setPrefixInfo(result);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public NullLiteral NullLiteral() throws ParseException {
    NullLiteral result;
    jj_consume_token(NULL);
      result = factory.createNullLiteral();
      setPrefixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ExpressionMutableList Arguments() throws ParseException {
    ExpressionMutableList result = null;
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case BANG:
    case TILDE:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case 126:
      result = ArgumentList();
      break;
    default:
      jj_la1[100] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
      if (result != null)
      {
          checkConstruction(result);

          }
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ExpressionMutableList ArgumentList() throws ParseException {
    ExpressionMutableList result = new ExpressionArrayList();
    Expression expr;
    expr = Expression();
                              result.add(expr);
    label_42:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[101] = jj_gen;
        break label_42;
      }
      jj_consume_token(COMMA);
      expr = Expression();
                              result.add(expr);
    }
    checkConstruction(result);

    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public TypeOperator AllocationExpression() throws ParseException {
    UncollatedReferenceQualifier qn;
    TypeOperator  result;
    TypeReference tr;
    ExpressionMutableList args;
    MemberDeclarationMutableList body = null;
    ClassDeclaration cd = null;
    NewArray na;
    if (jj_2_23(2)) {
      jj_consume_token(NEW);
        na = factory.createNewArray();
        setPrefixInfo(na);
      tr = PrimitiveType();
        na.setTypeReference(tr);
      result = ArrayDimsAndInits(na);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
      result = factory.createNew();
      setPrefixInfo(result);
        qn = Name();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          args = Arguments();
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
           cd = factory.createClassDeclaration();
           setPrefixInfo(cd);
            body = ClassBody();
           cd.setMembers(body);
           setPostfixInfo(cd);
            break;
          default:
            jj_la1[102] = jj_gen;
            ;
          }
         result.setTypeReference(qn.toTypeReference());
         ((New)result).setArguments(args);
         if (cd != null) {
             ((New)result).setClassDeclaration(cd);
         }
          break;
        case LBRACKET:
        na = factory.createNewArray();
        copyPrefixInfo(result, na);
        na.setTypeReference(qn.toTypeReference());
          result = ArrayDimsAndInits(na);
          break;
        default:
          jj_la1[103] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[104] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

/*
 * The third LOOKAHEAD specification below is to parse to PrimarySuffix
 * if there is an expression between the "[...]".
 */
  static final public NewArray ArrayDimsAndInits(NewArray result) throws ParseException {
    int dimensions = 0;
    Expression expr;
    ExpressionMutableList sizes = null;
    ArrayInitializer init = null;
    if (jj_2_26(2)) {
      label_43:
      while (true) {
        jj_consume_token(LBRACKET);
        expr = Expression();
        jj_consume_token(RBRACKET);
          sizes = (sizes == null) ? new ExpressionArrayList() : sizes;
          sizes.add(expr);
          dimensions++;
        if (jj_2_24(2)) {
          ;
        } else {
          break label_43;
        }
      }
      label_44:
      while (true) {
        if (jj_2_25(2)) {
          ;
        } else {
          break label_44;
        }
        jj_consume_token(LBRACKET);
        jj_consume_token(RBRACKET);
        dimensions++;
      }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        label_45:
        while (true) {
          jj_consume_token(LBRACKET);
          jj_consume_token(RBRACKET);
        dimensions++;
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            ;
            break;
          default:
            jj_la1[105] = jj_gen;
            break label_45;
          }
        }
        init = ArrayInitializer();
        break;
      default:
        jj_la1[106] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      //      setPrefixInfo(result); 
      result.setDimensions(dimensions);
      if (sizes != null) {
          result.setArguments(sizes);
      }
      result.setArrayInitializer(init);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

/*
 * Statement syntax follows.
 */
  static final public Statement Statement() throws ParseException {
  Statement result = null;
  Expression expr;
    if (jj_2_27(2)) {
      result = LabeledStatement();
    } else if (jj_2_28(2)) {
      result = MethodCallStatement();
    } else if (jj_2_29(2147483647)) {
      result = MethodBodyStatement();
      jj_consume_token(SEMICOLON);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        result = Block();
        break;
      case SEMICOLON:
        result = EmptyStatement();
        break;
      default:
        jj_la1[107] = jj_gen;
        if (jj_2_30(2)) {
          expr = StatementExpression();
          jj_consume_token(SEMICOLON);
      try {
          result = (ExpressionStatement)expr;
      }
      catch (ClassCastException cce) {
          // this is a semantical error!!!
          ParseException e =  new ParseException("ExpressionStatement expected");
      }
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SWITCH:
            result = SwitchStatement();
            break;
          case IF:
            result = IfStatement();
            break;
          case WHILE:
            result = WhileStatement();
            break;
          case DO:
            result = DoStatement();
            break;
          case FOR:
            result = ForStatement();
            break;
          case BREAK:
            result = BreakStatement();
            break;
          case CONTINUE:
            result = ContinueStatement();
            break;
          case RETURN:
            result = ReturnStatement();
            break;
          case THROW:
            result = ThrowStatement();
            break;
          case SYNCHRONIZED:
            result = SynchronizedStatement();
            break;
          case TRY:
            result = TryStatement();
            break;
          case ASSERT:
            result = AssertStatement();
            break;
          case 127:
            result = KeYCatchAllStatement();
            break;
          default:
            jj_la1[108] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Statement KeYCatchAllStatement() throws ParseException {
  Statement cat;
  ParameterDeclaration param;
  StatementBlock block;
    jj_consume_token(127);
    jj_consume_token(LPAREN);
    param = FormalParameter();
    jj_consume_token(RPAREN);
    block = Block();
    cat = factory.createCatchAllStatement(param, block);
    {if (true) return cat;}
    throw new Error("Missing return statement in function");
  }

  static final public LabeledStatement LabeledStatement() throws ParseException {
  LabeledStatement result;
  Identifier id;
  Statement stat;
    jj_consume_token(IDENTIFIER);
              id = factory.createIdentifier(token.image);
              setPrefixInfo(id);
              setPostfixInfo(id);
    jj_consume_token(COLON);
      result = factory.createLabeledStatement();
      setPrefixInfo(result);
      result.setIdentifier(id);
    stat = Statement();
    result.setBody(stat);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MethodCallStatement MethodCallStatement() throws ParseException {
  MethodCallStatement result;
  VariableReference resVar = null;
  UncollatedReferenceQualifier qn;
  StatementBlock block;
  ExecutionContext ec;
    jj_consume_token(METHODFRAME);
    jj_consume_token(LPAREN);
    if (jj_2_31(2147483647)) {
      qn = Name();
      jj_consume_token(COMMA);
       resVar = qn.toVariableReference();
    } else {
      ;
    }
    ec = ExecutionContext();
    jj_consume_token(RPAREN);
    jj_consume_token(COLON);
    block = Block();
      result = factory.createMethodCallStatement(resVar, ec, block);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MethodBodyStatement MethodBodyStatement() throws ParseException {
  TypeReference bodySource;
  Expression tmp;
  VariableReference resVar = null;
  UncollatedReferenceQualifier qn;
  MethodReference methRef;
  MethodBodyStatement result;
    bodySource = Type();
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
      qn = Name();
           resVar = qn.toVariableReference();
      break;
    default:
      jj_la1[109] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    jj_consume_token(DOUBLECOLON);
    tmp = Expression();
    if (tmp instanceof MethodReference)
    {
        methRef = (MethodReference)tmp;
    }
    else
    {
        {if (true) throw new ParseException("Expected a method reference.");}
    }
    result = factory.createMethodBodyStatement(bodySource, resVar, methRef);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ExecutionContext ExecutionContext() throws ParseException {
  TypeReference classContext;
  Expression runtimeInstance = null;
    classContext = Type();
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case BANG:
    case TILDE:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case 126:
      runtimeInstance = Expression();
      break;
    default:
      jj_la1[110] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    {if (true) return new ExecutionContext
        (classContext,
        (ReferencePrefix)runtimeInstance);}
    throw new Error("Missing return statement in function");
  }

  static final public StatementBlock Block() throws ParseException {
  StatementBlock result;
  StatementMutableList sl = new StatementArrayList();
  Statement stat;
    jj_consume_token(LBRACE);
    result = factory.createStatementBlock();
    setPrefixInfo(result);
    label_46:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CLASS:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FINAL:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case LONG:
      case METHODFRAME:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
      case LPAREN:
      case LBRACE:
      case SEMICOLON:
      case INCR:
      case DECR:
      case 126:
      case 127:
        ;
        break;
      default:
        jj_la1[111] = jj_gen;
        break label_46;
      }
      stat = BlockStatement();
      sl.add(stat);
    }
    jj_consume_token(RBRACE);
    result.setBody(sl);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public StatementBlock StartBlock() throws ParseException {
  StatementBlock result;
  StatementMutableList sl = new StatementArrayList();
  Statement stat;
    jj_consume_token(LBRACE);
    result = factory.createStatementBlock();
    setPrefixInfo(result);
    label_47:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CLASS:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FINAL:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case LONG:
      case METHODFRAME:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
      case LPAREN:
      case LBRACE:
      case SEMICOLON:
      case INCR:
      case DECR:
      case 126:
      case 127:
        ;
        break;
      default:
        jj_la1[112] = jj_gen;
        break label_47;
      }
      stat = BlockStatement();
      sl.add(stat);
    }
    jj_consume_token(RBRACE);
    result.setBody(sl);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Statement BlockStatement() throws ParseException {
  Statement result;
    if (jj_2_32(2147483647)) {
      result = LocalVariableDeclaration();
      jj_consume_token(SEMICOLON);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case LONG:
      case METHODFRAME:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
      case LPAREN:
      case LBRACE:
      case SEMICOLON:
      case INCR:
      case DECR:
      case 126:
      case 127:
        result = Statement();
        break;
      case CLASS:
        result = UnmodifiedClassDeclaration();
        break;
      default:
        jj_la1[113] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public LocalVariableDeclaration LocalVariableDeclaration() throws ParseException {
  LocalVariableDeclaration result;
  VariableSpecificationMutableList vl = new VariableSpecificationArrayList(1);
  TypeReference tr;
  VariableSpecification var;
    result = factory.createLocalVariableDeclaration();
    setPrefixInfo(result);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FINAL:
      jj_consume_token(FINAL);
      Final fi = factory.createFinal();
      setPrefixInfo(fi);
      setPostfixInfo(fi);
      result.setModifiers(new ModifierArrayList(fi));
      break;
    default:
      jj_la1[114] = jj_gen;
      ;
    }
    tr = Type();
    var = VariableDeclarator(false);
                                    vl.add(var);
    label_48:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[115] = jj_gen;
        break label_48;
      }
      jj_consume_token(COMMA);
      var = VariableDeclarator(false);
                                       vl.add(var);
    }
      result.setTypeReference(tr);
      result.setVariableSpecifications(vl);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public EmptyStatement EmptyStatement() throws ParseException {
    EmptyStatement result;
    jj_consume_token(SEMICOLON);
    result = factory.createEmptyStatement();
    setPrefixInfo(result);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Expression StatementExpression() throws ParseException {
    Expression result;
    Expression expr;
    Assignment op;
    ExpressionMutableList leftRight;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INCR:
      result = PreIncrementExpression();
      break;
    case DECR:
      result = PreDecrementExpression();
      break;
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case 126:
      result = PrimaryExpression();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
      case INCR:
      case DECR:
      case PLUSASSIGN:
      case MINUSASSIGN:
      case STARASSIGN:
      case SLASHASSIGN:
      case ANDASSIGN:
      case ORASSIGN:
      case XORASSIGN:
      case REMASSIGN:
      case LSHIFTASSIGN:
      case RSIGNEDSHIFTASSIGN:
      case RUNSIGNEDSHIFTASSIGN:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INCR:
          jj_consume_token(INCR);
          result = factory.createPostIncrement(result);
          setPrefixInfo(result);
          break;
        case DECR:
          jj_consume_token(DECR);
        result = factory.createPostDecrement(result);
        setPrefixInfo(result);
          break;
        case ASSIGN:
        case PLUSASSIGN:
        case MINUSASSIGN:
        case STARASSIGN:
        case SLASHASSIGN:
        case ANDASSIGN:
        case ORASSIGN:
        case XORASSIGN:
        case REMASSIGN:
        case LSHIFTASSIGN:
        case RSIGNEDSHIFTASSIGN:
        case RUNSIGNEDSHIFTASSIGN:
          op = AssignmentOperator();
          expr = Expression();
          leftRight = new ExpressionArrayList(2);
          leftRight.add(result);
          leftRight.add(expr);
          op.setArguments(leftRight);
          result = op;
          break;
        default:
          jj_la1[116] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[117] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[118] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Switch SwitchStatement() throws ParseException {
  Switch result;
  Expression expr;
  BranchMutableList branches = new BranchArrayList(2);
  Branch branch;
  StatementMutableList stats;
  Statement stat;
    jj_consume_token(SWITCH);
      result = factory.createSwitch();
      setPrefixInfo(result);
    jj_consume_token(LPAREN);
    expr = Expression();
    jj_consume_token(RPAREN);
    jj_consume_token(LBRACE);
    label_49:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
      case _DEFAULT:
        ;
        break;
      default:
        jj_la1[119] = jj_gen;
        break label_49;
      }
      branch = SwitchLabel();
        stats = new StatementArrayList();
      label_50:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSERT:
        case BOOLEAN:
        case BREAK:
        case BYTE:
        case CHAR:
        case CLASS:
        case CONTINUE:
        case DO:
        case DOUBLE:
        case FALSE:
        case FINAL:
        case FLOAT:
        case FOR:
        case IF:
        case INT:
        case LONG:
        case METHODFRAME:
        case NEW:
        case NULL:
        case RETURN:
        case SHORT:
        case SUPER:
        case SWITCH:
        case SYNCHRONIZED:
        case THIS:
        case THROW:
        case TRUE:
        case TRY:
        case VOID:
        case WHILE:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case IMPLICITIDENTIFIER:
        case LPAREN:
        case LBRACE:
        case SEMICOLON:
        case INCR:
        case DECR:
        case 126:
        case 127:
          ;
          break;
        default:
          jj_la1[120] = jj_gen;
          break label_50;
        }
        stat = BlockStatement();
          stats.add(stat);
      }
        if (branch instanceof Case) {
          ((Case)branch).setBody(stats);
        } else {
          ((Default)branch).setBody(stats);
        }
        branches.add(branch);
    }
    jj_consume_token(RBRACE);
      result.setExpression(expr);
      result.setBranchList(branches);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Branch SwitchLabel() throws ParseException {
  Branch result;
  Expression expr;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CASE:
      jj_consume_token(CASE);
        result = factory.createCase();
        setPrefixInfo(result);
      expr = Expression();
      jj_consume_token(COLON);
        ((Case)result).setExpression(expr);
      break;
    case _DEFAULT:
      jj_consume_token(_DEFAULT);
        result = factory.createDefault();
        setPrefixInfo(result);
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[121] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Assert AssertStatement() throws ParseException {
  Assert result;
  Expression cond = null;
  Expression msg = null;
    jj_consume_token(ASSERT);
       result = factory.createAssert();
       setPrefixInfo(result);
    cond = Expression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      msg = Expression();
      break;
    default:
      jj_la1[122] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
      result.setCondition(cond);
      result.setMessage(msg);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public If IfStatement() throws ParseException {
  If result;
  Expression cond, e0, e1;
  Then thenStat;
  Else elseStat = null;
  Statement trueStat;
  Statement falseStat = null;
    jj_consume_token(IF);
      result = factory.createIf();
      setPrefixInfo(result);
    jj_consume_token(LPAREN);
    cond = Expression();
    jj_consume_token(RPAREN);
      thenStat = factory.createThen();
      setPrefixInfo(thenStat);
    trueStat = Statement();
     thenStat.setBody(trueStat);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELSE:
      jj_consume_token(ELSE);
        elseStat = factory.createElse();
        setPrefixInfo(elseStat);
      falseStat = Statement();
       elseStat.setBody(falseStat);
      break;
    default:
      jj_la1[123] = jj_gen;
      ;
    }
      result.setExpression(cond);
      result.setThen(thenStat);
      if (elseStat != null) {
          result.setElse(elseStat);
      }
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public While WhileStatement() throws ParseException {
  While result;
  Expression expr;
  Statement stat;
    jj_consume_token(WHILE);
    result = factory.createWhile();
    setPrefixInfo(result);
    jj_consume_token(LPAREN);
    expr = Expression();
    jj_consume_token(RPAREN);
    stat = Statement();
    result.setGuard(expr);
    result.setBody(stat);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Do DoStatement() throws ParseException {
  Do result;
  Expression expr;
  Statement stat;
    jj_consume_token(DO);
      result = factory.createDo();
      setPrefixInfo(result);
    stat = Statement();
    jj_consume_token(WHILE);
    jj_consume_token(LPAREN);
    expr = Expression();
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
    result.setGuard(expr);
    result.setBody(stat);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public For ForStatement() throws ParseException {
    For result;
    LoopInitializerMutableList init = null;
    Expression guard = null;
    ExpressionMutableList update = null;
    Statement body;
    jj_consume_token(FOR);
      result = factory.createFor();
      setPrefixInfo(result);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FINAL:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case INCR:
    case DECR:
    case 126:
      init = ForInit();
      break;
    default:
      jj_la1[124] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case BANG:
    case TILDE:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case 126:
      guard = Expression();
      break;
    default:
      jj_la1[125] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case INCR:
    case DECR:
    case 126:
      update = ForUpdate();
      break;
    default:
      jj_la1[126] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    body = Statement();
      result.setInitializers(init);
      result.setGuard(guard);
      result.setUpdates(update);
      result.setBody(body);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public LoopInitializerMutableList ForInit() throws ParseException {
    LoopInitializerMutableList result = new LoopInitializerArrayList();
    LocalVariableDeclaration varDecl = null;
    ExpressionList exprs = null;
    if (jj_2_33(2147483647)) {
      varDecl = LocalVariableDeclaration();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case SHORT:
      case SUPER:
      case THIS:
      case TRUE:
      case VOID:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
      case LPAREN:
      case INCR:
      case DECR:
      case 126:
        exprs = StatementExpressionList();
        break;
      default:
        jj_la1[127] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        if (varDecl != null) {
            result.add(varDecl);
        } else {
            for (int i =  0, s = exprs.size(); i < s; i += 1)
                result.add((LoopInitializer)exprs.getExpression(i));
        }
        checkConstruction(result);

        {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ExpressionMutableList StatementExpressionList() throws ParseException {
    ExpressionMutableList result = new ExpressionArrayList(2);
    Expression expr;
    expr = StatementExpression();
                                       result.add(expr);
    label_51:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[128] = jj_gen;
        break label_51;
      }
      jj_consume_token(COMMA);
      expr = StatementExpression();
                                       result.add(expr);
    }
      checkConstruction(result);

      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public ExpressionMutableList ForUpdate() throws ParseException {
    ExpressionMutableList result;
    result = StatementExpressionList();
    checkConstruction(result);

    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Break BreakStatement() throws ParseException {
    Identifier id = null;
    Break result;
    jj_consume_token(BREAK);
      result = factory.createBreak();
      setPrefixInfo(result);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
      id = factory.createIdentifier(token.image);
      setPrefixInfo(id);
      setPostfixInfo(id);
      result.setIdentifier(id);
      break;
    default:
      jj_la1[129] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Continue ContinueStatement() throws ParseException {
    Identifier id = null;
    Continue result;
    jj_consume_token(CONTINUE);
      result = factory.createContinue();
      setPrefixInfo(result);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
         id = factory.createIdentifier(token.image);
         setPrefixInfo(id);
         setPostfixInfo(id);
         result.setIdentifier(id);
      break;
    default:
      jj_la1[130] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Return ReturnStatement() throws ParseException {
    Expression expr = null;
    Return result;
    jj_consume_token(RETURN);
      result = factory.createReturn();
      setPrefixInfo(result);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case IMPLICITIDENTIFIER:
    case LPAREN:
    case BANG:
    case TILDE:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case 126:
      expr = Expression();
        result.setExpression(expr);
      break;
    default:
      jj_la1[131] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Throw ThrowStatement() throws ParseException {
    Throw result;
    Expression expr;
    jj_consume_token(THROW);
      result = factory.createThrow();
      setPrefixInfo(result);
    expr = Expression();
    jj_consume_token(SEMICOLON);
      result.setExpression(expr);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public SynchronizedBlock SynchronizedStatement() throws ParseException {
    SynchronizedBlock result;
    Expression expr;
    StatementBlock block;
    jj_consume_token(SYNCHRONIZED);
      result = factory.createSynchronizedBlock();
      setPrefixInfo(result);
    jj_consume_token(LPAREN);
    expr = Expression();
    jj_consume_token(RPAREN);
    block = Block();
      result.setExpression(expr);
      result.setBody(block);
      checkConstruction(result);
      setPostfixInfo(result);
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public Try TryStatement() throws ParseException {
    Try result;
    StatementBlock block;
    ParameterDeclaration param;
    BranchMutableList branches = new BranchArrayList(1);
    Catch cat;
    Finally fin;
    jj_consume_token(TRY);
        result = factory.createTry();
        setPrefixInfo(result);
    block = Block();
          result.setBody(block);
    label_52:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CATCH:
        ;
        break;
      default:
        jj_la1[132] = jj_gen;
        break label_52;
      }
      jj_consume_token(CATCH);
      cat = factory.createCatch();
      setPrefixInfo(cat);
      jj_consume_token(LPAREN);
      param = FormalParameter();
      jj_consume_token(RPAREN);
      block = Block();
        cat.setParameterDeclaration(param);
        cat.setBody(block);
        branches.add(cat);
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FINALLY:
      jj_consume_token(FINALLY);
         fin = factory.createFinally();
         setPrefixInfo(fin);
      block = Block();
          fin.setBody(block);
          branches.add(fin);
      break;
    default:
      jj_la1[133] = jj_gen;
      ;
    }
    result.setBranchList(branches);
    checkConstruction(result);
    setPostfixInfo(result);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

/**
   For partial parsing ONLY. Allows this()/super() calls, as in
   constructor bodies.
 */
  static final public StatementMutableList GeneralizedStatements() throws ParseException {
    StatementMutableList            result = new StatementArrayList();
    SpecialConstructorReference     scr = null;
    Statement                       stat = null;
    if (jj_2_34(2147483647)) {
      scr = ExplicitConstructorInvocation();
        result.add(scr);
    } else {
      ;
    }
    label_53:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CLASS:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FINAL:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case LONG:
      case METHODFRAME:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case IMPLICITIDENTIFIER:
      case LPAREN:
      case LBRACE:
      case SEMICOLON:
      case INCR:
      case DECR:
      case 126:
      case 127:
        ;
        break;
      default:
        jj_la1[134] = jj_gen;
        break label_53;
      }
      stat = BlockStatement();
        result.add(stat);
    }
      checkConstruction(result);

      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  static final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  static final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  static final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  static final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  static final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  static final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  static final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  static final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  static final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  static final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  static final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  static final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  static final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  static final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  static final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  static final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  static final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  static final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  static final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  static final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  static final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  static final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  static final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  static final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  static final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  static final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_27(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(26, xla); }
  }

  static final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_28(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(27, xla); }
  }

  static final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_29(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(28, xla); }
  }

  static final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_30(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(29, xla); }
  }

  static final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_31(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(30, xla); }
  }

  static final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_32(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(31, xla); }
  }

  static final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_33(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(32, xla); }
  }

  static final private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_34(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(33, xla); }
  }

  static final private boolean jj_3R_67() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3_14() {
    if (jj_scan_token(DOT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_67()) {
    jj_scanpos = xsp;
    if (jj_3R_68()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_183() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_365() {
    if (jj_scan_token(CASE)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  static final private boolean jj_3R_359() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_365()) {
    jj_scanpos = xsp;
    if (jj_3R_366()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_280() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_3R_59()) return true;
    return false;
  }

  static final private boolean jj_3R_113() {
    if (jj_scan_token(SUPER)) return true;
    if (jj_scan_token(DOT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_183()) {
    jj_scanpos = xsp;
    if (jj_3R_184()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_85() {
    if (jj_scan_token(IMPLICITIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_279() {
    if (jj_scan_token(IMPLICITIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_112() {
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  static final private boolean jj_3R_84() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_59() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_84()) {
    jj_scanpos = xsp;
    if (jj_3R_85()) return true;
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_14()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_111() {
    if (jj_3R_129()) return true;
    return false;
  }

  static final private boolean jj_3R_278() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_91() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_111()) {
    jj_scanpos = xsp;
    if (jj_3R_112()) {
    jj_scanpos = xsp;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_3R_114()) {
    jj_scanpos = xsp;
    if (jj_3R_115()) {
    jj_scanpos = xsp;
    if (jj_3R_116()) {
    jj_scanpos = xsp;
    if (jj_3R_117()) {
    jj_scanpos = xsp;
    if (jj_3R_118()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_149() {
    if (jj_scan_token(CLASS)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_278()) {
    jj_scanpos = xsp;
    if (jj_3R_279()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_280()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_281()) jj_scanpos = xsp;
    if (jj_3R_216()) return true;
    return false;
  }

  static final private boolean jj_3R_360() {
    if (jj_3R_128()) return true;
    return false;
  }

  static final private boolean jj_3R_100() {
    if (jj_3R_81()) return true;
    return false;
  }

  static final private boolean jj_3R_346() {
    if (jj_3R_359()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_360()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_99() {
    if (jj_scan_token(VOID)) return true;
    return false;
  }

  static final private boolean jj_3R_73() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_99()) {
    jj_scanpos = xsp;
    if (jj_3R_100()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_191() {
    if (jj_scan_token(SWITCH)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_346()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_54() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(49)) {
    jj_scanpos = xsp;
    if (jj_scan_token(65)) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_70() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(20)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(51)) {
    jj_scanpos = xsp;
    if (jj_scan_token(39)) {
    jj_scanpos = xsp;
    if (jj_scan_token(41)) {
    jj_scanpos = xsp;
    if (jj_scan_token(32)) {
    jj_scanpos = xsp;
    if (jj_scan_token(26)) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_1() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_54()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_134() {
    if (jj_3R_146()) return true;
    if (jj_3R_75()) return true;
    return false;
  }

  static final private boolean jj_3R_133() {
    if (jj_scan_token(DECR)) return true;
    return false;
  }

  static final private boolean jj_3R_132() {
    if (jj_scan_token(INCR)) return true;
    return false;
  }

  static final private boolean jj_3R_127() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_132()) {
    jj_scanpos = xsp;
    if (jj_3R_133()) {
    jj_scanpos = xsp;
    if (jj_3R_134()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_108() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_107() {
    if (jj_3R_59()) return true;
    return false;
  }

  static final private boolean jj_3R_105() {
    if (jj_3R_65()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_127()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_104() {
    if (jj_3R_126()) return true;
    return false;
  }

  static final private boolean jj_3R_106() {
    if (jj_3R_70()) return true;
    return false;
  }

  static final private boolean jj_3R_103() {
    if (jj_3R_125()) return true;
    return false;
  }

  static final private boolean jj_3R_81() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_106()) {
    jj_scanpos = xsp;
    if (jj_3R_107()) return true;
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_108()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_80() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_103()) {
    jj_scanpos = xsp;
    if (jj_3R_104()) {
    jj_scanpos = xsp;
    if (jj_3R_105()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_190() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_19() {
    if (jj_3R_72()) return true;
    return false;
  }

  static final private boolean jj_3R_82() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_55() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_82()) jj_scanpos = xsp;
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_342() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_262()) return true;
    return false;
  }

  static final private boolean jj_3R_166() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_147() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_166()) jj_scanpos = xsp;
    if (jj_3R_81()) return true;
    if (jj_3R_262()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_342()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3_12() {
    if (jj_3R_65()) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  static final private boolean jj_3_13() {
    if (jj_scan_token(THIS)) return true;
    if (jj_3R_66()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_121() {
    if (jj_3R_129()) return true;
    return false;
  }

  static final private boolean jj_3R_90() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_12()) jj_scanpos = xsp;
    if (jj_scan_token(SUPER)) return true;
    if (jj_3R_66()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_89() {
    if (jj_scan_token(THIS)) return true;
    if (jj_3R_66()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_32() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) jj_scanpos = xsp;
    if (jj_3R_81()) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_64() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_89()) {
    jj_scanpos = xsp;
    if (jj_3R_90()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_65() {
    if (jj_3R_91()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_19()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_137() {
    if (jj_3R_149()) return true;
    return false;
  }

  static final private boolean jj_3R_136() {
    if (jj_3R_148()) return true;
    return false;
  }

  static final private boolean jj_3R_135() {
    if (jj_3R_147()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_128() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_135()) {
    jj_scanpos = xsp;
    if (jj_3R_136()) {
    jj_scanpos = xsp;
    if (jj_3R_137()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3_18() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_70()) return true;
    return false;
  }

  static final private boolean jj_3R_341() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_81()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_270()) return true;
    return false;
  }

  static final private boolean jj_3_11() {
    if (jj_3R_64()) return true;
    return false;
  }

  static final private boolean jj_3R_340() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_81()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_234()) return true;
    return false;
  }

  static final private boolean jj_3R_333() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_340()) {
    jj_scanpos = xsp;
    if (jj_3R_341()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_256() {
    if (jj_3R_128()) return true;
    return false;
  }

  static final private boolean jj_3R_255() {
    if (jj_3R_64()) return true;
    return false;
  }

  static final private boolean jj_3R_71() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_254() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_3R_295()) return true;
    return false;
  }

  static final private boolean jj_3R_364() {
    if (jj_scan_token(DECR)) return true;
    return false;
  }

  static final private boolean jj_3R_120() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_363() {
    if (jj_scan_token(INCR)) return true;
    return false;
  }

  static final private boolean jj_3R_357() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_363()) {
    jj_scanpos = xsp;
    if (jj_3R_364()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_293() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3R_292() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3R_291() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_334() {
    if (jj_3R_65()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_357()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3_17() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_59()) return true;
    if (jj_scan_token(LBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_109() {
    if (jj_3R_128()) return true;
    return false;
  }

  static final private boolean jj_3R_252() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_291()) {
    jj_scanpos = xsp;
    if (jj_3R_292()) {
    jj_scanpos = xsp;
    if (jj_3R_293()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3_16() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_70()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_71()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_95() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_59()) return true;
    if (jj_scan_token(RPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(91)) {
    jj_scanpos = xsp;
    if (jj_scan_token(90)) {
    jj_scanpos = xsp;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_scan_token(74)) {
    jj_scanpos = xsp;
    if (jj_scan_token(56)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(44)) {
    jj_scanpos = xsp;
    if (jj_3R_121()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_237() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_252()) jj_scanpos = xsp;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_3R_253()) return true;
    xsp = jj_scanpos;
    if (jj_3R_254()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    xsp = jj_scanpos;
    if (jj_3R_255()) jj_scanpos = xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_256()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_83() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_109()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_94() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_59()) return true;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_93() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_70()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_120()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_69() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_93()) {
    jj_scanpos = xsp;
    if (jj_3R_94()) {
    jj_scanpos = xsp;
    if (jj_3R_95()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_358() {
    if (jj_3R_75()) return true;
    return false;
  }

  static final private boolean jj_3_15() {
    if (jj_3R_69()) return true;
    return false;
  }

  static final private boolean jj_3R_344() {
    if (jj_3R_81()) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_358()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_322() {
    if (jj_3R_334()) return true;
    return false;
  }

  static final private boolean jj_3R_321() {
    if (jj_3R_333()) return true;
    return false;
  }

  static final private boolean jj_3R_332() {
    if (jj_scan_token(BANG)) return true;
    return false;
  }

  static final private boolean jj_3R_339() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_331() {
    if (jj_scan_token(TILDE)) return true;
    return false;
  }

  static final private boolean jj_3R_324() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_339()) jj_scanpos = xsp;
    if (jj_3R_81()) return true;
    if (jj_3R_315()) return true;
    return false;
  }

  static final private boolean jj_3R_320() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_331()) {
    jj_scanpos = xsp;
    if (jj_3R_332()) return true;
    }
    if (jj_3R_234()) return true;
    return false;
  }

  static final private boolean jj_3R_270() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_320()) {
    jj_scanpos = xsp;
    if (jj_3R_321()) {
    jj_scanpos = xsp;
    if (jj_3R_322()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_294() {
    if (jj_3R_324()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_325()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_325() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_324()) return true;
    return false;
  }

  static final private boolean jj_3R_345() {
    if (jj_3R_59()) return true;
    return false;
  }

  static final private boolean jj_3R_253() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_294()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_189() {
    if (jj_3R_81()) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_345()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(DOUBLECOLON)) return true;
    if (jj_3R_75()) return true;
    return false;
  }

  static final private boolean jj_3R_126() {
    if (jj_scan_token(DECR)) return true;
    if (jj_3R_65()) return true;
    return false;
  }

  static final private boolean jj_3_31() {
    if (jj_3R_59()) return true;
    if (jj_scan_token(COMMA)) return true;
    return false;
  }

  static final private boolean jj_3R_307() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_125() {
    if (jj_scan_token(INCR)) return true;
    if (jj_3R_65()) return true;
    return false;
  }

  static final private boolean jj_3R_306() {
    if (jj_scan_token(IMPLICITIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_343() {
    if (jj_3R_59()) return true;
    if (jj_scan_token(COMMA)) return true;
    return false;
  }

  static final private boolean jj_3R_305() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_258() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_305()) {
    jj_scanpos = xsp;
    if (jj_3R_306()) return true;
    }
    if (jj_3R_253()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_307()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_77() {
    if (jj_scan_token(METHODFRAME)) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_343()) jj_scanpos = xsp;
    if (jj_3R_344()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_248() {
    if (jj_3R_270()) return true;
    return false;
  }

  static final private boolean jj_3R_247() {
    if (jj_3R_126()) return true;
    return false;
  }

  static final private boolean jj_3R_246() {
    if (jj_3R_125()) return true;
    return false;
  }

  static final private boolean jj_3R_269() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  static final private boolean jj_3_34() {
    if (jj_3R_64()) return true;
    return false;
  }

  static final private boolean jj_3R_268() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  static final private boolean jj_3R_245() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_268()) {
    jj_scanpos = xsp;
    if (jj_3R_269()) return true;
    }
    if (jj_3R_234()) return true;
    return false;
  }

  static final private boolean jj_3R_260() {
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_234() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_245()) {
    jj_scanpos = xsp;
    if (jj_3R_246()) {
    jj_scanpos = xsp;
    if (jj_3R_247()) {
    jj_scanpos = xsp;
    if (jj_3R_248()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_259() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_3R_295()) return true;
    return false;
  }

  static final private boolean jj_3R_76() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_148()) return true;
    return false;
  }

  static final private boolean jj_3R_304() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  static final private boolean jj_3R_303() {
    if (jj_scan_token(SYNCHRONIZED)) return true;
    return false;
  }

  static final private boolean jj_3R_302() {
    if (jj_scan_token(NATIVE)) return true;
    return false;
  }

  static final private boolean jj_3R_301() {
    if (jj_scan_token(ABSTRACT)) return true;
    return false;
  }

  static final private boolean jj_3R_300() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_330() {
    if (jj_scan_token(REM)) return true;
    return false;
  }

  static final private boolean jj_3R_299() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_329() {
    if (jj_scan_token(SLASH)) return true;
    return false;
  }

  static final private boolean jj_3R_298() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3R_328() {
    if (jj_scan_token(STAR)) return true;
    return false;
  }

  static final private boolean jj_3R_297() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3R_296() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_79() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_317() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_328()) {
    jj_scanpos = xsp;
    if (jj_3R_329()) {
    jj_scanpos = xsp;
    if (jj_3R_330()) return true;
    }
    }
    if (jj_3R_234()) return true;
    return false;
  }

  static final private boolean jj_3R_257() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_296()) {
    jj_scanpos = xsp;
    if (jj_3R_297()) {
    jj_scanpos = xsp;
    if (jj_3R_298()) {
    jj_scanpos = xsp;
    if (jj_3R_299()) {
    jj_scanpos = xsp;
    if (jj_3R_300()) {
    jj_scanpos = xsp;
    if (jj_3R_301()) {
    jj_scanpos = xsp;
    if (jj_3R_302()) {
    jj_scanpos = xsp;
    if (jj_3R_303()) {
    jj_scanpos = xsp;
    if (jj_3R_304()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_203() {
    if (jj_scan_token(127)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_324()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_238() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_257()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_73()) return true;
    if (jj_3R_258()) return true;
    xsp = jj_scanpos;
    if (jj_3R_259()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_260()) {
    jj_scanpos = xsp;
    if (jj_scan_token(84)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_227() {
    if (jj_3R_234()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_317()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_355() {
    if (jj_scan_token(FINALLY)) return true;
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_182() {
    if (jj_3R_203()) return true;
    return false;
  }

  static final private boolean jj_3R_181() {
    if (jj_3R_202()) return true;
    return false;
  }

  static final private boolean jj_3R_78() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_180() {
    if (jj_3R_201()) return true;
    return false;
  }

  static final private boolean jj_3R_179() {
    if (jj_3R_200()) return true;
    return false;
  }

  static final private boolean jj_3R_178() {
    if (jj_3R_199()) return true;
    return false;
  }

  static final private boolean jj_3R_319() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  static final private boolean jj_3R_177() {
    if (jj_3R_198()) return true;
    return false;
  }

  static final private boolean jj_3R_318() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  static final private boolean jj_3R_176() {
    if (jj_3R_197()) return true;
    return false;
  }

  static final private boolean jj_3_10() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_63()) return true;
    return false;
  }

  static final private boolean jj_3R_175() {
    if (jj_3R_196()) return true;
    return false;
  }

  static final private boolean jj_3R_264() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_318()) {
    jj_scanpos = xsp;
    if (jj_3R_319()) return true;
    }
    if (jj_3R_227()) return true;
    return false;
  }

  static final private boolean jj_3R_174() {
    if (jj_3R_195()) return true;
    return false;
  }

  static final private boolean jj_3R_173() {
    if (jj_3R_194()) return true;
    return false;
  }

  static final private boolean jj_3R_354() {
    if (jj_scan_token(CATCH)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_324()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_219() {
    if (jj_3R_63()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_10()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_172() {
    if (jj_3R_193()) return true;
    return false;
  }

  static final private boolean jj_3R_171() {
    if (jj_3R_192()) return true;
    return false;
  }

  static final private boolean jj_3R_170() {
    if (jj_3R_191()) return true;
    return false;
  }

  static final private boolean jj_3R_222() {
    if (jj_3R_227()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_264()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_110() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_219()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(85)) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3_29() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_78()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_79()) jj_scanpos = xsp;
    if (jj_scan_token(LPAREN)) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(74)) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(DOUBLECOLON)) return true;
    return false;
  }

  static final private boolean jj_3_30() {
    if (jj_3R_80()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_169() {
    if (jj_3R_190()) return true;
    return false;
  }

  static final private boolean jj_3R_201() {
    if (jj_scan_token(TRY)) return true;
    if (jj_3R_83()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_354()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_355()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_168() {
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_167() {
    if (jj_3R_189()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_28() {
    if (jj_3R_77()) return true;
    return false;
  }

  static final private boolean jj_3_27() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_267() {
    if (jj_scan_token(RUNSIGNEDSHIFT)) return true;
    return false;
  }

  static final private boolean jj_3R_148() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_27()) {
    jj_scanpos = xsp;
    if (jj_3_28()) {
    jj_scanpos = xsp;
    if (jj_3R_167()) {
    jj_scanpos = xsp;
    if (jj_3R_168()) {
    jj_scanpos = xsp;
    if (jj_3R_169()) {
    jj_scanpos = xsp;
    if (jj_3_30()) {
    jj_scanpos = xsp;
    if (jj_3R_170()) {
    jj_scanpos = xsp;
    if (jj_3R_171()) {
    jj_scanpos = xsp;
    if (jj_3R_172()) {
    jj_scanpos = xsp;
    if (jj_3R_173()) {
    jj_scanpos = xsp;
    if (jj_3R_174()) {
    jj_scanpos = xsp;
    if (jj_3R_175()) {
    jj_scanpos = xsp;
    if (jj_3R_176()) {
    jj_scanpos = xsp;
    if (jj_3R_177()) {
    jj_scanpos = xsp;
    if (jj_3R_178()) {
    jj_scanpos = xsp;
    if (jj_3R_179()) {
    jj_scanpos = xsp;
    if (jj_3R_180()) {
    jj_scanpos = xsp;
    if (jj_3R_181()) {
    jj_scanpos = xsp;
    if (jj_3R_182()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_88() {
    if (jj_3R_75()) return true;
    return false;
  }

  static final private boolean jj_3R_266() {
    if (jj_scan_token(RSIGNEDSHIFT)) return true;
    return false;
  }

  static final private boolean jj_3R_87() {
    if (jj_3R_110()) return true;
    return false;
  }

  static final private boolean jj_3R_265() {
    if (jj_scan_token(LSHIFT)) return true;
    return false;
  }

  static final private boolean jj_3R_63() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_87()) {
    jj_scanpos = xsp;
    if (jj_3R_88()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_240() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_265()) {
    jj_scanpos = xsp;
    if (jj_3R_266()) {
    jj_scanpos = xsp;
    if (jj_3R_267()) return true;
    }
    }
    if (jj_3R_222()) return true;
    return false;
  }

  static final private boolean jj_3R_218() {
    if (jj_3R_222()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_240()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_327() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_200() {
    if (jj_scan_token(SYNCHRONIZED)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_215() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_315() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_327()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_211() {
    Token xsp;
    if (jj_3R_215()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_215()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_110()) return true;
    return false;
  }

  static final private boolean jj_3_25() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_244() {
    if (jj_scan_token(GE)) return true;
    return false;
  }

  static final private boolean jj_3R_243() {
    if (jj_scan_token(LE)) return true;
    return false;
  }

  static final private boolean jj_3R_242() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  static final private boolean jj_3R_241() {
    if (jj_scan_token(LT)) return true;
    return false;
  }

  static final private boolean jj_3R_233() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_241()) {
    jj_scanpos = xsp;
    if (jj_3R_242()) {
    jj_scanpos = xsp;
    if (jj_3R_243()) {
    jj_scanpos = xsp;
    if (jj_3R_244()) return true;
    }
    }
    }
    if (jj_3R_218()) return true;
    return false;
  }

  static final private boolean jj_3_24() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_214() {
    if (jj_3R_218()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_233()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_316() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_63()) return true;
    return false;
  }

  static final private boolean jj_3_26() {
    Token xsp;
    if (jj_3_24()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_24()) { jj_scanpos = xsp; break; }
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_25()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_199() {
    if (jj_scan_token(THROW)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_262() {
    if (jj_3R_315()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_316()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_206() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_26()) {
    jj_scanpos = xsp;
    if (jj_3R_211()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_224() {
    if (jj_scan_token(INSTANCEOF)) return true;
    if (jj_3R_81()) return true;
    return false;
  }

  static final private boolean jj_3R_353() {
    if (jj_3R_75()) return true;
    return false;
  }

  static final private boolean jj_3R_210() {
    if (jj_3R_214()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_224()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_198() {
    if (jj_scan_token(RETURN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_353()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_263() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_262()) return true;
    return false;
  }

  static final private boolean jj_3R_208() {
    if (jj_3R_206()) return true;
    return false;
  }

  static final private boolean jj_3R_226() {
    if (jj_scan_token(NE)) return true;
    return false;
  }

  static final private boolean jj_3R_225() {
    if (jj_scan_token(EQ)) return true;
    return false;
  }

  static final private boolean jj_3R_221() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_225()) {
    jj_scanpos = xsp;
    if (jj_3R_226()) return true;
    }
    if (jj_3R_210()) return true;
    return false;
  }

  static final private boolean jj_3R_314() {
    if (jj_scan_token(VOLATILE)) return true;
    return false;
  }

  static final private boolean jj_3R_352() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_313() {
    if (jj_scan_token(TRANSIENT)) return true;
    return false;
  }

  static final private boolean jj_3R_312() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_205() {
    if (jj_3R_210()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_221()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_212() {
    if (jj_3R_216()) return true;
    return false;
  }

  static final private boolean jj_3R_311() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_310() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3R_309() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3R_308() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_207() {
    if (jj_3R_66()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_212()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_197() {
    if (jj_scan_token(CONTINUE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_352()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_261() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_308()) {
    jj_scanpos = xsp;
    if (jj_3R_309()) {
    jj_scanpos = xsp;
    if (jj_3R_310()) {
    jj_scanpos = xsp;
    if (jj_3R_311()) {
    jj_scanpos = xsp;
    if (jj_3R_312()) {
    jj_scanpos = xsp;
    if (jj_3R_313()) {
    jj_scanpos = xsp;
    if (jj_3R_314()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_239() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_261()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_81()) return true;
    if (jj_3R_262()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_263()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_101() {
    if (jj_scan_token(NEW)) return true;
    if (jj_3R_59()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_207()) {
    jj_scanpos = xsp;
    if (jj_3R_208()) return true;
    }
    return false;
  }

  static final private boolean jj_3_9() {
    if (jj_3R_60()) return true;
    return false;
  }

  static final private boolean jj_3R_62() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(49)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(65)) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_8() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_62()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  static final private boolean jj_3R_61() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(49)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(65)) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_217() {
    if (jj_scan_token(BIT_AND)) return true;
    if (jj_3R_205()) return true;
    return false;
  }

  static final private boolean jj_3_7() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_61()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_351() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_188() {
    if (jj_3R_205()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_217()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3_23() {
    if (jj_scan_token(NEW)) return true;
    if (jj_3R_70()) return true;
    if (jj_3R_206()) return true;
    return false;
  }

  static final private boolean jj_3R_338() {
    if (jj_3R_239()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(84)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_74() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_23()) {
    jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_337() {
    if (jj_3R_238()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(84)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_196() {
    if (jj_scan_token(BREAK)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_351()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_336() {
    if (jj_3R_236()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(84)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_335() {
    if (jj_3R_235()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(84)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_323() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_335()) {
    jj_scanpos = xsp;
    if (jj_3R_336()) {
    jj_scanpos = xsp;
    if (jj_3R_337()) {
    jj_scanpos = xsp;
    if (jj_3R_338()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_119() {
    if (jj_3R_75()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_130()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_130() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_75()) return true;
    return false;
  }

  static final private boolean jj_3R_362() {
    if (jj_3R_369()) return true;
    return false;
  }

  static final private boolean jj_3R_213() {
    if (jj_scan_token(XOR)) return true;
    if (jj_3R_188()) return true;
    return false;
  }

  static final private boolean jj_3R_153() {
    if (jj_3R_188()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_213()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_290() {
    if (jj_3R_323()) return true;
    return false;
  }

  static final private boolean jj_3R_369() {
    if (jj_3R_80()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_370()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_370() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_80()) return true;
    return false;
  }

  static final private boolean jj_3R_92() {
    if (jj_3R_119()) return true;
    return false;
  }

  static final private boolean jj_3R_66() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_92()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_289() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_3R_295()) return true;
    return false;
  }

  static final private boolean jj_3R_209() {
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_153()) return true;
    return false;
  }

  static final private boolean jj_3_33() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) jj_scanpos = xsp;
    if (jj_3R_81()) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_145() {
    if (jj_3R_153()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_209()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_151() {
    if (jj_scan_token(NULL)) return true;
    return false;
  }

  static final private boolean jj_3R_368() {
    if (jj_3R_369()) return true;
    return false;
  }

  static final private boolean jj_3R_367() {
    if (jj_3R_147()) return true;
    return false;
  }

  static final private boolean jj_3R_361() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_367()) {
    jj_scanpos = xsp;
    if (jj_3R_368()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_251() {
    if (jj_scan_token(INTERFACE)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_289()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_290()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_186() {
    if (jj_scan_token(FALSE)) return true;
    return false;
  }

  static final private boolean jj_3R_185() {
    if (jj_scan_token(TRUE)) return true;
    return false;
  }

  static final private boolean jj_3R_350() {
    if (jj_3R_362()) return true;
    return false;
  }

  static final private boolean jj_3R_204() {
    if (jj_scan_token(SC_AND)) return true;
    if (jj_3R_145()) return true;
    return false;
  }

  static final private boolean jj_3R_349() {
    if (jj_3R_75()) return true;
    return false;
  }

  static final private boolean jj_3R_150() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_185()) {
    jj_scanpos = xsp;
    if (jj_3R_186()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_348() {
    if (jj_3R_361()) return true;
    return false;
  }

  static final private boolean jj_3R_131() {
    if (jj_3R_145()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_204()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_288() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  static final private boolean jj_3R_287() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3R_286() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3R_285() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_195() {
    if (jj_scan_token(FOR)) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_348()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_349()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_350()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_148()) return true;
    return false;
  }

  static final private boolean jj_3R_284() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_143() {
    if (jj_3R_151()) return true;
    return false;
  }

  static final private boolean jj_3R_283() {
    if (jj_scan_token(ABSTRACT)) return true;
    return false;
  }

  static final private boolean jj_3R_142() {
    if (jj_3R_150()) return true;
    return false;
  }

  static final private boolean jj_3R_282() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_250() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_282()) {
    jj_scanpos = xsp;
    if (jj_3R_283()) {
    jj_scanpos = xsp;
    if (jj_3R_284()) {
    jj_scanpos = xsp;
    if (jj_3R_285()) {
    jj_scanpos = xsp;
    if (jj_3R_286()) {
    jj_scanpos = xsp;
    if (jj_3R_287()) {
    jj_scanpos = xsp;
    if (jj_3R_288()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_141() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  static final private boolean jj_3R_236() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_250()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_251()) return true;
    return false;
  }

  static final private boolean jj_3R_187() {
    if (jj_scan_token(SC_OR)) return true;
    if (jj_3R_131()) return true;
    return false;
  }

  static final private boolean jj_3R_140() {
    if (jj_scan_token(CHARACTER_LITERAL)) return true;
    return false;
  }

  static final private boolean jj_3R_124() {
    if (jj_3R_131()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_187()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_139() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    return false;
  }

  static final private boolean jj_3R_194() {
    if (jj_scan_token(DO)) return true;
    if (jj_3R_148()) return true;
    if (jj_scan_token(WHILE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_138() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  static final private boolean jj_3R_129() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_138()) {
    jj_scanpos = xsp;
    if (jj_3R_139()) {
    jj_scanpos = xsp;
    if (jj_3R_140()) {
    jj_scanpos = xsp;
    if (jj_3R_141()) {
    jj_scanpos = xsp;
    if (jj_3R_142()) {
    jj_scanpos = xsp;
    if (jj_3R_143()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_152() {
    if (jj_scan_token(HOOK)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_102()) return true;
    return false;
  }

  static final private boolean jj_3R_102() {
    if (jj_3R_124()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_152()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_193() {
    if (jj_scan_token(WHILE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_148()) return true;
    return false;
  }

  static final private boolean jj_3R_86() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(49)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(43)) {
    jj_scanpos = xsp;
    if (jj_scan_token(55)) {
    jj_scanpos = xsp;
    if (jj_scan_token(65)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_98() {
    if (jj_3R_66()) return true;
    return false;
  }

  static final private boolean jj_3R_60() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_86()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_73()) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(74)) {
    jj_scanpos = xsp;
    if (jj_scan_token(75)) return true;
    }
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_6() {
    if (jj_3R_60()) return true;
    return false;
  }

  static final private boolean jj_3R_58() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(49)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3_5() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_58()) jj_scanpos = xsp;
    if (jj_3R_59()) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_57() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(49)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(65)) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_165() {
    if (jj_scan_token(ORASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_164() {
    if (jj_scan_token(XORASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3_4() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_57()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  static final private boolean jj_3R_56() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(49)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(65)) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_163() {
    if (jj_scan_token(ANDASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_123() {
    if (jj_scan_token(IMPLICITIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_162() {
    if (jj_scan_token(RUNSIGNEDSHIFTASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3_3() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_56()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_161() {
    if (jj_scan_token(RSIGNEDSHIFTASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_160() {
    if (jj_scan_token(LSHIFTASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_159() {
    if (jj_scan_token(MINUSASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_232() {
    if (jj_3R_239()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(84)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_158() {
    if (jj_scan_token(PLUSASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_122() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_157() {
    if (jj_scan_token(REMASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_231() {
    if (jj_3R_238()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(84)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_156() {
    if (jj_scan_token(SLASHASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_155() {
    if (jj_scan_token(STARASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_230() {
    if (jj_3R_237()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(84)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_154() {
    if (jj_scan_token(ASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_97() {
    if (jj_scan_token(DOT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_122()) {
    jj_scanpos = xsp;
    if (jj_3R_123()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_229() {
    if (jj_3R_236()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(84)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_228() {
    if (jj_3R_235()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(84)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_146() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_154()) {
    jj_scanpos = xsp;
    if (jj_3R_155()) {
    jj_scanpos = xsp;
    if (jj_3R_156()) {
    jj_scanpos = xsp;
    if (jj_3R_157()) {
    jj_scanpos = xsp;
    if (jj_3R_158()) {
    jj_scanpos = xsp;
    if (jj_3R_159()) {
    jj_scanpos = xsp;
    if (jj_3R_160()) {
    jj_scanpos = xsp;
    if (jj_3R_161()) {
    jj_scanpos = xsp;
    if (jj_3R_162()) {
    jj_scanpos = xsp;
    if (jj_3R_163()) {
    jj_scanpos = xsp;
    if (jj_3R_164()) {
    jj_scanpos = xsp;
    if (jj_3R_165()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_2() {
    if (jj_3R_55()) return true;
    return false;
  }

  static final private boolean jj_3R_96() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_347() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_3R_148()) return true;
    return false;
  }

  static final private boolean jj_3R_223() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_2()) {
    jj_scanpos = xsp;
    if (jj_3R_228()) {
    jj_scanpos = xsp;
    if (jj_3R_229()) {
    jj_scanpos = xsp;
    if (jj_3R_230()) {
    jj_scanpos = xsp;
    if (jj_3R_231()) {
    jj_scanpos = xsp;
    if (jj_3R_232()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_22() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_74()) return true;
    return false;
  }

  static final private boolean jj_3_21() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  static final private boolean jj_3R_72() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_21()) {
    jj_scanpos = xsp;
    if (jj_3_22()) {
    jj_scanpos = xsp;
    if (jj_3R_96()) {
    jj_scanpos = xsp;
    if (jj_3R_97()) {
    jj_scanpos = xsp;
    if (jj_3R_98()) return true;
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_192() {
    if (jj_scan_token(IF)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_148()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_347()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_277() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  static final private boolean jj_3R_276() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3R_144() {
    if (jj_3R_146()) return true;
    if (jj_3R_75()) return true;
    return false;
  }

  static final private boolean jj_3R_275() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3R_274() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_273() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_272() {
    if (jj_scan_token(ABSTRACT)) return true;
    return false;
  }

  static final private boolean jj_3R_75() {
    if (jj_3R_102()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_144()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_271() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_249() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_271()) {
    jj_scanpos = xsp;
    if (jj_3R_272()) {
    jj_scanpos = xsp;
    if (jj_3R_273()) {
    jj_scanpos = xsp;
    if (jj_3R_274()) {
    jj_scanpos = xsp;
    if (jj_3R_275()) {
    jj_scanpos = xsp;
    if (jj_3R_276()) {
    jj_scanpos = xsp;
    if (jj_3R_277()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_20() {
    if (jj_3R_73()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_235() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_249()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_149()) return true;
    return false;
  }

  static final private boolean jj_3R_118() {
    if (jj_3R_59()) return true;
    return false;
  }

  static final private boolean jj_3R_117() {
    if (jj_3R_73()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_356() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_75()) return true;
    return false;
  }

  static final private boolean jj_3R_116() {
    if (jj_3R_74()) return true;
    return false;
  }

  static final private boolean jj_3R_220() {
    if (jj_3R_223()) return true;
    return false;
  }

  static final private boolean jj_3R_216() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_220()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_326() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_59()) return true;
    return false;
  }

  static final private boolean jj_3R_202() {
    if (jj_scan_token(ASSERT)) return true;
    if (jj_3R_75()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_356()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_115() {
    if (jj_scan_token(126)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_295() {
    if (jj_3R_59()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_326()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_114() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_75()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_366() {
    if (jj_scan_token(_DEFAULT)) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  static final private boolean jj_3R_68() {
    if (jj_scan_token(IMPLICITIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_281() {
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_3R_295()) return true;
    return false;
  }

  static final private boolean jj_3R_184() {
    if (jj_scan_token(IMPLICITIDENTIFIER)) return true;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public ProofJavaParserTokenManager token_source;
  static JavaCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[135];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static private int[] jj_la1_3;
  static {
      jj_la1_0();
      jj_la1_1();
      jj_la1_2();
      jj_la1_3();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x0,0x0,0x40202000,0x0,0x2000,0x40002000,0x40002000,0x0,0x10000000,0x0,0x4432a000,0x40002000,0x40002000,0x0,0x0,0x0,0x0,0x0,0x44128000,0x40002000,0x40002000,0x0,0x2000,0x2000,0x40002000,0x40002000,0x10000000,0x4432a000,0x0,0x0,0x0,0x0,0x44128000,0x40000000,0x40000000,0x0,0x0,0x0,0x24128000,0x24128000,0x0,0x40002000,0x40002000,0x0,0x0,0x0,0x0,0x0,0x44128000,0x40000000,0x0,0x0,0x0,0x66b3c000,0x24128000,0x0,0x4128000,0x0,0x4128000,0x4128000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x24128000,0x0,0x0,0x24128000,0x0,0x20000000,0x0,0x0,0x0,0x0,0x0,0x20000000,0x0,0x0,0x0,0x20000000,0x20000000,0x24128000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2814000,0x0,0x24128000,0x66b3c000,0x66b3c000,0x26b3c000,0x40000000,0x0,0x0,0x0,0x24128000,0x1040000,0x66b3c000,0x1040000,0x0,0x8000000,0x64128000,0x24128000,0x24128000,0x24128000,0x0,0x0,0x0,0x24128000,0x80000,0x80000000,0x66b3c000,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x4000,0x20,0x20100,0x0,0x20100,0x20000,0x20000,0x0,0x0,0x10,0xc89b8b81,0x138000,0x138000,0x0,0x0,0x0,0x0,0x0,0x881b8281,0x938800,0x938800,0x0,0x20000,0x20000,0x138000,0x138000,0x0,0xc89b8b81,0x0,0x0,0x0,0x0,0x881b8281,0x88138000,0x88138000,0x0,0x0,0x0,0x51283281,0x51283281,0x0,0x938800,0x938800,0x4000000,0x0,0x0,0x0,0x0,0x80281,0x0,0x38000,0x38000,0x4000000,0x73ec368b,0x51283281,0x100000,0x80281,0x0,0x80281,0x40080281,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x51283281,0x0,0x0,0x51283281,0x0,0x11203000,0x0,0x0,0x0,0x0,0x0,0x11203000,0x0,0x0,0x0,0x10002000,0x10000000,0x51283281,0x0,0x0,0x0,0x1000,0x0,0x0,0x0,0x22c4000a,0x0,0x51283281,0x73ec368b,0x73ec368b,0x73ec368b,0x0,0x0,0x0,0x0,0x51283281,0x0,0x73ec368b,0x0,0x0,0x0,0x51283281,0x51283281,0x51283281,0x51283281,0x0,0x0,0x0,0x51283281,0x0,0x0,0x73ec368b,};
   }
   private static void jj_la1_2() {
      jj_la1_2 = new int[] {0x0,0x0,0x100002,0x400000,0x100002,0x2,0x2,0xc00,0x0,0x0,0x10c02,0x2,0x2,0x100000,0x100000,0x100000,0x100000,0x100000,0xc00,0x2,0x2,0xc00,0x2,0x2,0x2,0x2,0x0,0xc02,0x100000,0x100000,0x100000,0x100000,0xc00,0x0,0x0,0x200000,0x800000,0x40000,0xc014f44,0xc014f44,0x200000,0x2,0x2,0x0,0x110000,0xc00,0x40000,0x200000,0xc00,0x0,0x0,0x0,0x0,0x114f45,0x4f44,0x0,0xc00,0x40000,0x0,0xc00,0xc00,0xc00,0x200000,0x800000,0x800000,0x10000000,0x0,0x0,0x0,0x0,0x0,0x80000000,0x80000000,0x0,0x3000000,0x3000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc004f44,0xc000000,0xc000000,0x4f44,0x40000,0xc004744,0x4000,0x0,0x0,0x4000,0xc00,0x4344,0xc00,0xc00,0x444000,0x344,0x0,0xc004f44,0x200000,0x10000,0x44000,0x0,0x40000,0x40000,0x110000,0x1,0xc00,0xc004f44,0x114f45,0x114f45,0x114f45,0x0,0x200000,0x800000,0x800000,0x4f44,0x0,0x114f45,0x0,0x20000000,0x0,0x4f44,0xc004f44,0x4f44,0x4f44,0x200000,0x400,0x400,0xc004f44,0x0,0x0,0x114f45,};
   }
   private static void jj_la1_3() {
      jj_la1_3 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x400001e0,0x400001e0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0000060,0x40000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1ffc0000,0x1ffc0000,0x0,0x8,0x10,0x1000,0x2000,0x800,0x4,0x4,0x0,0x3,0x3,0x38000,0x38000,0x180,0x180,0x4600,0x4600,0x180,0x400001e0,0x0,0x0,0x40000000,0x0,0x0,0x0,0x60,0x60,0x0,0x0,0x40000000,0x0,0x0,0x0,0x0,0x0,0x400001e0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80000000,0x0,0x400001e0,0xc0000060,0xc0000060,0xc0000060,0x0,0x0,0x1ffc0060,0x1ffc0060,0x40000060,0x0,0xc0000060,0x0,0x0,0x0,0x40000060,0x400001e0,0x40000060,0x40000060,0x0,0x0,0x0,0x400001e0,0x0,0x0,0xc0000060,};
   }
  static final private JJCalls[] jj_2_rtns = new JJCalls[34];
  static private boolean jj_rescan = false;
  static private int jj_gc = 0;

  public ProofJavaParser(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new ProofJavaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 135; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 135; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public ProofJavaParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new ProofJavaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 135; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 135; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public ProofJavaParser(ProofJavaParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 135; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(ProofJavaParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 135; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  static final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  static final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;
  static private int[] jj_lasttokens = new int[100];
  static private int jj_endpos;

  static private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  static public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[128];
    for (int i = 0; i < 128; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 135; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 128; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

  static final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 34; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  static final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
